import algds.c2002.Hamster;

/**
 * der Hamster(Pathfinder) luft das Labyrinth zufllig ab,
 * indem er sich bei jedem Schritt umschaut 
 * und dann zufllig entscheidet welchen der ihm zu Verfgung stehenden Wege er geht.
 *
 * Hat er die maximale Anzahl von Koernern aufgenommen,
 * so kehrt er auf dem krzesten Weg zurueck.
 *
 * Kann nicht mit dem erweiterten Labyrinth umgehen.
 */


public class Pathfinder extends Hamster {

/**
 * Markierung, ob der Lauf beendet werden soll oder nicht.
 */
boolean finished = false;

int MerkeAusgang[]=new int[6];
int Feld_merkeDrehung []=new int[5000];
boolean Feld_merkeKreuzung []=new boolean[5000];
int HomeArray []=new int [7];	

	int laufVar=0;
	int i2= 0;
	int dreh2=6;;
	int wert=0;
	int ausgang=0;
	int step=0;
	int richtung=1;
	
	boolean merkeKreuzung=false;
	boolean full = false;
	boolean firstturn=true;	
	boolean end = false;
	boolean isgoinghome=false;
	
/**
 * Hauptmethode.
 * Geht sammeln, kehrt nach Hause zurueck und legt allen Mais ab,
 * bis end true ist. Dann wird der Lauf beendet.
 */
public void run() {
	
	finished = false;
	wert=0;
	
	while (!finished) {
		laufVar=0;

		goShopping();
		if (!end) goHome();
		i2=0;	
		if(atHome()){
			dropAll();
		}
		if(end)
			finished=true;	
	}
}

		
public void goShopping() {
	int i = 0;
	int k=0;
	int j = 0;
	int dreheZumAusgang=2;
	int MerkeDrehung=0;
	int feld=0;
	boolean rueckwaerts=false;
	boolean AusgangNochVorhanden=false;
	
	full = false;
	
	while (!full) {
		boolean forward=false;
		isgoinghome=false;
		step++;
		merkeKreuzung=false;
		j++;
		dreheZumAusgang=2;
		i=0;
// Wenn der Hamster 6-mal in eine Sackgasse gelaufen ist(i2=6), durchluft er diese if-Schleife
		if (i2==6){ 
			
			goHome();
			k=0;
// In Feld_merkeDrehung[0] ist gespeichert, auf welchen Weg der Hamster das Heimatfeld verlassen hat.
// Dieser Wert ist die Drehung und beschreibt den Ausgang, welcher gelscht werden soll.
			if (Feld_merkeDrehung[0]==1) ausgang=5;
			if (Feld_merkeDrehung[0]==2) ausgang=0;
			if (Feld_merkeDrehung[0]==3) ausgang=1;
			if (Feld_merkeDrehung[0]==4) ausgang=3;
			if (Feld_merkeDrehung[0]==5) ausgang=4;
			if (Feld_merkeDrehung[0]==6) ausgang=2;
// HomeArray[] wird durchlaufen, bis das Feld erreicht ist, in dem der Ausgang gespeichert ist
			while(HomeArray[k]!=ausgang)
				k++;
// um ihn hier zu lschen.
			while(k<6){
				HomeArray[k]=HomeArray[(k+1)];
				k++;
			}
			k=HomeArray[6];
			k--;
			HomeArray[6]=k;
			
			i=0;
			i2=0;
			laufVar=0;
			rueckwaerts=false;
		}
// In dieser if-Schleife dreht der Hamster sich auf seinem Heimatfeld in Richtung 1 (oben), ausser beim ersten mal (firstturn).
		if ((atHome())&&(!firstturn)){
			
			wert=Feld_merkeDrehung[0];
			
			if (wert==3){
				turn(TURN_RIGHT);
			}
			if (wert==2){
			     	
			     	turn(TURN_RIGHT);
				turn(TURN_RIGHT);
			}
			if (wert==1){
				turn(TURN_RIGHT);
				turn(TURN_RIGHT);
			 	turn(TURN_RIGHT);
			}
			if (wert==4){
			        turn(TURN_LEFT);
			}
			if (wert==5){
				turn(TURN_LEFT);
		   		turn(TURN_LEFT);
			}
		}
// Test wieviele Ausgnge das Feld besitzt und gleichzeitiges Speichern in MerkeAusgang[].
		if (((firstturn)&&(atHome()))||(!atHome())){
			for (int dreh=0;dreh<6;dreh++){
				turn(TURN_RIGHT);  
				if ((lookForward() != WALL)){
					MerkeAusgang[i]=dreh;
					i++;
				}  
			}
		}
// Bevor der Hamster das Heimatfeld zum ersten mal verlsst, speichert er die Ausgnge in HomeArray[]
		if ((firstturn)&&(atHome())){
			HomeArray[0]=MerkeAusgang[0];
			HomeArray[1]=MerkeAusgang[1];
			HomeArray[2]=MerkeAusgang[2];
			HomeArray[3]=MerkeAusgang[3];
			HomeArray[4]=MerkeAusgang[4];
			HomeArray[5]=MerkeAusgang[5];
			HomeArray[6]=i;
		}
// Bevor der Hamster das Heimatfeld verlsst, bernimmt er die Ausgnge von HomeArray[]
		if ((!firstturn)&&(atHome())){
			MerkeAusgang[0]=HomeArray[0];
			MerkeAusgang[1]=HomeArray[1];
			MerkeAusgang[2]=HomeArray[2];
			MerkeAusgang[3]=HomeArray[3];
			MerkeAusgang[4]=HomeArray[4];
			MerkeAusgang[5]=HomeArray[5];
			i=HomeArray[6];
		}
		firstturn=false;
		
// ABBRUCH WENN KEINE AUSGNGE MEHR VORHANDEN SIND oder mehr als 3500 Schritte und atHome()
		if ((HomeArray[6]==0)||((step>3500)&&(atHome()))){
			end=true;
			break;
		}
// wenn Feld mehr als 2 Ausgnge besitzt
		if (i>2){
			merkeKreuzung=true;  
			while(dreheZumAusgang==2){
				int zufall=((int)(i*Math.random()));
					if (zufall==0)
						dreheZumAusgang=MerkeAusgang[0];
					if (zufall==1)    		
					       	dreheZumAusgang=MerkeAusgang[1];
					if (zufall==2)           			
						dreheZumAusgang=MerkeAusgang[2];      		       
					if (zufall==3)    			        
						dreheZumAusgang=MerkeAusgang[3];
					if (zufall==4)           
						dreheZumAusgang=MerkeAusgang[4];      				
					if (zufall==5)    					
						dreheZumAusgang=MerkeAusgang[5];

					if (dreheZumAusgang==0){
						turn(TURN_RIGHT);
						MerkeDrehung=2;
			    } 
			    if (dreheZumAusgang==1){                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           			
						turn(TURN_RIGHT);turn(TURN_RIGHT);
						MerkeDrehung=3;
					}
				  if (dreheZumAusgang==3) {            			
						turn(TURN_LEFT);turn(TURN_LEFT);
						MerkeDrehung=4;
					} 
					if (dreheZumAusgang==4) {            			
						turn(TURN_LEFT);
						MerkeDrehung=5;
					}
					if (dreheZumAusgang==5)
						MerkeDrehung=1;	 			
			}
			
			forward();
			forward=true;
			rueckwaerts=false;
		} 
// wenn Feld genau 2 Ausgnge besitzt und der Hamster nicht zu Hause ist 
		if ((i==2)&&(!atHome())&&(!forward)){
			if (MerkeAusgang[0]==2)
				feld=MerkeAusgang[1];
			else 
				feld=MerkeAusgang[0];
				
			if (feld==4){
				turn(TURN_LEFT);
				MerkeDrehung=5;
			}
			if (feld==3){
				turn(TURN_LEFT);turn(TURN_LEFT);
				MerkeDrehung=4;
			}
			if (feld==0){
				turn(TURN_RIGHT);
				MerkeDrehung=2;
			}
			if (feld==1){
				turn(TURN_RIGHT);turn(TURN_RIGHT);
				MerkeDrehung=3;
			}
			if (feld==5)
				MerkeDrehung=1;
			forward();
			forward=true;
		}
// wenn Feld genau 2 bzw 1 Ausgnge besitzt und der Hamster zu Hause ist   
		if (((i==2)||(i==1))&&(atHome())&&(!forward)){
			if (MerkeAusgang[0]==4){
				turn(TURN_LEFT);
				MerkeDrehung=5;
			}
			if (MerkeAusgang[0]==3){
				turn(TURN_LEFT);turn(TURN_LEFT);
				MerkeDrehung=4;
			}
			if (MerkeAusgang[0]==0){
				turn(TURN_RIGHT);
				MerkeDrehung=2;
			}
			if (MerkeAusgang[0]==1){
				turn(TURN_RIGHT);turn(TURN_RIGHT);
				MerkeDrehung=3;
			}
			if (MerkeAusgang[0]==5)
				MerkeDrehung=1;
				
			if (MerkeAusgang[0]==2){
				turn(TURN_RIGHT);turn(TURN_RIGHT);turn(TURN_RIGHT);
				MerkeDrehung=6;
			}
			i=0;
			forward();
			forward=true;
		}
// wenn Feld genau 1 Ausgang besitzt und der Hamster nicht zu Hause ist  	   
		if((i==1)&&(!atHome())&&(!forward)){
			
			MerkeDrehung=6;
			rueckwaerts=true;
		}
		
// mit Feld_merkeDrehung merkt sich der Hamster, welchen Ausgang er gewhlt hat		
		Feld_merkeDrehung[laufVar]=MerkeDrehung;
		SetRichtung(MerkeDrehung);
		
// mit Feld_merkeKreuzung merkt sich der Hamster, welches Feld mehr als zwei Ausgnge hat
		Feld_merkeKreuzung[laufVar]=merkeKreuzung;
		merkeKreuzung=false;
			
			laufVar++;
// Rckwrtsabarbeiten von den Feldern Feld_merkeKreuzung[] und Feld_merkeDrehung[].

		if (rueckwaerts){ 
			i2++;
			laufVar--;
			
			while(!Feld_merkeKreuzung[laufVar]){
				goRueckwaerts();
				laufVar--;
				if (atHome()) break;
				
				
			}
			if (Feld_merkeDrehung[laufVar]==2){
				turn(TURN_RIGHT);turn(TURN_RIGHT);
			}
			if (Feld_merkeDrehung[laufVar]==5){
				turn(TURN_LEFT);turn(TURN_LEFT);
			}
			if (Feld_merkeDrehung[laufVar]==3){
				turn(TURN_RIGHT);
			}
			if (Feld_merkeDrehung[laufVar]==4){
				turn(TURN_LEFT);
			}
			if (Feld_merkeDrehung[laufVar]==1){
				turn(TURN_RIGHT);turn(TURN_RIGHT);turn(TURN_RIGHT);
			}
		}
		if (getAvailableCorn()>0){
			i2=0;
			
		}
// Aufnehmen der gesamten Krner eines Feldes 
		take(CORNCARRY_MAX);
		if (getCarriedCorn() == CORNCARRY_MAX) {
			full = true;
		}
// Luft der Hamster zufllig ber sein Heimatfeld, lscht er den Ausgang, durch den er gekommen ist.
		if ((atHome())&&(!isgoinghome)){
			k=0;
			if (richtung==1) ausgang=5;
			if (richtung==2) ausgang=0;
			if (richtung==3) ausgang=1;
			if (richtung==4) ausgang=2;
			if (richtung==5) ausgang=3;
			if (richtung==6) ausgang=4;
			k=HomeArray[6];
			for (int l=0;l<k;l++){
				if (HomeArray[l]==ausgang)
					AusgangNochVorhanden=true;
			}
			k=0;
			if (AusgangNochVorhanden){		
				while(HomeArray[k]!=ausgang){
					k++;
				
				}
			
				while(k<6){
					HomeArray[k]=HomeArray[(k+1)];
					k++;
				}
			
				k=HomeArray[6];
				k--;
				HomeArray[6]=k;
			}
			AusgangNochVorhanden=false;
			i=0;
			i2=0;
			laufVar=0;
			rueckwaerts=false;

			if (richtung==6){
				turn(TURN_RIGHT);
				SetRichtung(2);
			}
			if (richtung==5){
			     	
			     	turn(TURN_RIGHT);
				turn(TURN_RIGHT);
				SetRichtung(3);
			}
			if (richtung==4){
				turn(TURN_RIGHT);
				turn(TURN_RIGHT);
			 	turn(TURN_RIGHT);
			 	SetRichtung(6);
			}
			if (richtung==2){
			        turn(TURN_LEFT);
			        SetRichtung(5);
			}
			if (richtung==3){
				turn(TURN_LEFT);
		   		turn(TURN_LEFT);
		   		SetRichtung(4);
			}
			laufVar=0;
			isgoinghome=true;
		}
// ABBRUCH WENN KEINE AUSGNGE MEHR VORHANDEN SIND
		if ((HomeArray[6]==0)){
			end=true;
			break;
		}
	}
		
}
/**
 * Legt alles ab, was er an Mais hat.
 */
public void dropAll() {
	int dropped = dropHere(CORNCARRY_MAX);
}

public void goHome(){
		isgoinghome=true;
	  	laufVar--;
		boolean foundCorn=true;	
		while(!atHome()){
			wert=Feld_merkeDrehung[laufVar];

			laufVar--;
			
			if (foundCorn==true){
				turn(TURN_RIGHT);turn(TURN_RIGHT);turn(TURN_RIGHT);forward();
			}
			foundCorn=false; 

			
			if (laufVar!=-1){
				if (wert==3){
	   				turn(TURN_LEFT);
	   				turn(TURN_LEFT);
					forward();
		 		}
				if (wert==2){
				     	turn(TURN_LEFT);
				     	forward();
				}
				if (wert==1){
		     			forward();
				}
				if (wert==4){
				        turn(TURN_RIGHT);
					turn(TURN_RIGHT);
		     			forward();
				}
				if (wert==5){
					turn(TURN_RIGHT);
					forward();
				}
				if (wert==6){
				        turn(TURN_RIGHT);
		     			turn(TURN_RIGHT);
		     			turn(TURN_RIGHT);
		     			forward();
				}
			}
		
		}
		
}

public void goRueckwaerts(){
	
	if (Feld_merkeDrehung[laufVar]==2){
		turn(TURN_LEFT);
	}
	if (Feld_merkeDrehung[laufVar]==5){
		turn(TURN_RIGHT);
	}
	if (Feld_merkeDrehung[laufVar]==3){
		turn(TURN_LEFT);turn(TURN_LEFT);
	}
	if (Feld_merkeDrehung[laufVar]==4){
		turn(TURN_RIGHT);turn(TURN_RIGHT);
	}
	if (Feld_merkeDrehung[laufVar]==6){
		turn(TURN_RIGHT);turn(TURN_RIGHT);turn(TURN_RIGHT);
	}
	forward();
}
// Mit Hilfe der SetRichtung-Methode wei der Hamster immer, in welche Himmelsrichtung er gerade schaut. 

public void SetRichtung(int r){
	int temp=0;
	
	if(richtung==1 && r==1)
		temp=1;
	if(richtung==1 && r==2)
		temp=2;
	if(richtung==1 && r==3)
		temp=3;
	if(richtung==1 && r==4)
		{temp=5;}
	if(richtung==1 && r==5)
		temp=6;
	if(richtung==1 && r==6)
		temp=4;
	if(richtung==2 && r==1)
		temp=2;
	if(richtung==2 && r==2)
		temp=3;
	if(richtung==2 && r==3)
		temp=4;
	if(richtung==2 && r==4)
		temp=6;
	if(richtung==2 && r==5)
		temp=1;
	if(richtung==2 && r==6)
		temp=5;
	if(richtung==3 && r==1)
		temp=3;
	if(richtung==3 && r==2)
		temp=4;
	if(richtung==3 && r==3)
		temp=5;
	if(richtung==3 && r==4)
		temp=1;
	if(richtung==3 && r==5)
		temp=2;
	if(richtung==3 && r==6)
		temp=6;
	if(richtung==4 && r==1)
		temp=4;
	if(richtung==4 && r==2)
		temp=5;
	if(richtung==4 && r==3)
		temp=6;
	if(richtung==4 && r==4)
		temp=2;
	if(richtung==4 && r==5)
		temp=3;
	if(richtung==4 && r==6)
		temp=1;
	if(richtung==5 && r==1)
		temp=5;
	if(richtung==5 && r==2)
		temp=6;
	if(richtung==5 && r==3)
		temp=1;
	if(richtung==5 && r==4)
		temp=3;
	if(richtung==5 && r==5)
		temp=4;
	if(richtung==5 && r==6)
		temp=2;
	if(richtung==6 && r==1)
		temp=6;
	if(richtung==6 && r==2)
		temp=1;
	if(richtung==6 && r==3)
		temp=2;
	if(richtung==6 && r==4)
		temp=4;
	if(richtung==6 && r==5)
		temp=5;
	if(richtung==6 && r==6)
		temp=3;
	richtung=temp;
}
/** Autoren des Hamsters. */
public String getHamsterAuthor() { return "Sven Langer und Torsten Berger"; }

/** Datum der Hamsterversion. */
public String getHamsterDate() { return "01.04.2002"; }

/** Hamsterversion. */
public String getHamsterVersion() { return "1.0"; }				
}
	
			
