import algds.c2002.*;
/**
 * Copyright:     Copyright (c) 2002
 * @author: Matthias Neupert
 * @version 8.4
 */

public class Schalander extends Hamster
  {
    boolean finished = false;
    int zaehler = 0;
    int zahl = 1;
    int[][] plan = new int[10][99999];
  public void run()
  {
    finished = false;
    while(!finished)
    {
      einsammeln();
      heimgehen(plan);
      ablegen();
    }
  }
  public int[][] einsammeln()
  {
    boolean voll = false;
    int dreh = 0;
    while(!voll)
    {
      while(zahl <= 49)
      {
        if((lookForward() & WALLMASK) == WALL)
        {
          plan[0][zaehler]= 6;
        }
        else plan[0][zaehler] = 12;
          turn(TURN_RIGHT);
        if((lookForward() & WALLMASK) == WALL)
        {
          plan[1][zaehler]= 6;
        }
        else plan[1][zaehler]= 12;
          turn(TURN_RIGHT);
        if((lookForward() & WALLMASK) == WALL)
        {
          plan[2][zaehler]= 6;
        }
        else plan[2][zaehler]= 12;
          turn(TURN_RIGHT);
          turn(TURN_RIGHT);
          turn(TURN_RIGHT);
        if((lookForward() & WALLMASK) == WALL)
        {
          plan[3][zaehler]= 6;
        }
        else plan[3][zaehler]= 12;
          turn(TURN_LEFT);
        if((lookForward() & WALLMASK) == WALL)
        {
          plan[4][zaehler]= 6;
        }
        else plan[4][zaehler]= 12;
          turn(TURN_LEFT);
        if((lookForward() & WALLMASK) == WALL)
        {
          plan[5][zaehler]=6;
        }
        else plan[5][zaehler]= 12;
          turn(TURN_RIGHT);
          turn(TURN_RIGHT);
          turn(TURN_RIGHT);
//HINWEIS_3 beginnt
        if(!atHome())
        {
          take(CORNCARRY_MAX);
        }
        if (getCarriedCorn() == CORNCARRY_MAX)
        {
          voll = true;
          return plan;
        }
        zaehler = zaehler + 1;
//HINWEIS_3 ist beendet
//HINWEIS_1 beginnt
        dreh = 0;
        while ((lookForward() & WALLMASK) == WALL)
        {
          turn(TURN_RIGHT);
          plan[dreh][zaehler]= 3;
          dreh = dreh + 1;
          if(dreh > 2)
          {
            turn(TURN_LEFT);
            turn(TURN_LEFT);
            turn(TURN_LEFT);
            turn(TURN_LEFT);
            for (int a=3; a<7; a++)
              plan[a][zaehler]= 9;
              if ((lookForward() & WALLMASK) == WALL)
              {
                turn(TURN_LEFT);
                plan[7][zaehler]= 9;
              }
              if ((lookForward() & WALLMASK) == WALL)
              {
                turn(TURN_LEFT);
                plan[8][zaehler]= 9;
              }
            break;
                //turning=0;
          }
          zaehler = zaehler + 1;
        }
//HINWEIS_1 ist beendet.

//HINWEIS_2 beginnt.
        forward();
        dreh = 0;
        plan[0][zaehler] = 24;
        zaehler = zaehler + 1;
        zahl = zahl + 1;
//HINWEIS_2 ist beendet.
        if (zahl == 50)
        {
          voll = true;
        }
      }
    }
    return plan;
  }
  public int[][] heimwegmacher(int plan[][])
  {
    int[][] heimweg = new int [10][zaehler];
    for(int a=0; a<zaehler; a++)
    {
      for(int b=0; b<9; b++)
      {
        if (plan[b][a] == 3)
           heimweg[b][a] = 9;
        if (plan[b][a] == 9)
           heimweg[b][a] = 3;
        if (plan[b][a] == 24)
           heimweg[b][a] = 24;
      }
    }
    return heimweg;
  }
  public void heimgehen (int[][] plan)
  {
    turn(TURN_RIGHT);
    turn(TURN_RIGHT);
    turn(TURN_RIGHT);
    int[][] heimfeldfinder = new int[10][zaehler];
    heimfeldfinder = heimwegmacher(plan);
    while(!atHome())
    {
      for(int a=zaehler-1; a>=0; a--)
      {
        for(int b=0; b<9; b++)
        {
          if(heimfeldfinder[b][a] == 24)
          {
            forward();
            if(atHome()) return;
          }
          if(heimfeldfinder[b][a] == 9)
          {
            turn(TURN_LEFT);
          }
          if(heimfeldfinder[b][a] == 3)
          {
            turn(TURN_RIGHT);
          }
        }
      }
    }
  }
  public void ablegen()
  {
    dropHere(CORNCARRY_MAX);
    if (zahl < 49)
    {
      zahl = 0;
    }
    if (zahl >= 49)
    {
    finished = true;
    }
    turn(TURN_RIGHT);
  }
public String getHamsterAuthor() { return "Matthias Neupert"; }
public String getHamsterDate() { return "28.04.2002"; }
public String getHamsterVersion() { return "8.4"; }
}
