package baldur;

// Koordinaten intern speichern als: (x|y) -> AABB = (x+50)*100 + (y+50)

import java.util.*;

public class Memory {

// -------------------------------------------------------------------------
// -------------------------------------------------------------------------
// -------------------------------------------------------------------------

HashSet TabooList = new HashSet(10);
HashMap Bergauf   = new HashMap();   // die Distanz ('Hoehe') zum Nest

// -------------------------------------------------------------------------

Memory() 
{
  Add_Distance(0, 0, 0);
}

// -------------------------------------------------------------------------
// -------------------------------------------------------------------------
// -------------------------------------------------------------------------

// Feld mit Koordinaten myX, myY wird zur Tabooliste hinzugefuegt

public void Add2TabooList (int myX, int myY) 
{
  int ort = Pos2Int (myX, myY);	
  TabooList.add(new Integer(ort));
}

// -------------------------------------------------------------------------

// Hamster guckt ob Feld auf Tabooliste ist

public boolean IsOnTabooList (int myX, int myY) 
{
  int ort = Pos2Int (myX, myY);
  boolean flag = false;
  Iterator it = TabooList.iterator();

  while (it.hasNext())
  {
    if ( ((Integer)it.next()).intValue() == ort )
      return (true);
  }
  return (false);
}

// -------------------------------------------------------------------------
// -------------------------------------------------------------------------

// Distanz zum Nest wird gesetzt, falls sie kleiner als die vorhandene

public void Add_Distance (int myX, int myY, int height) 
{
  int ort = Pos2Int (myX, myY);
  int blubb = height;
  int old_height;
  Integer KeyOb = new Integer(ort);

  if (Bergauf.containsKey(KeyOb))
  {
    if ( ((Integer)Bergauf.get(KeyOb)).intValue() > height)
      Bergauf.put( new Integer(ort), new Integer(blubb) );
  } else
  {
    Bergauf.put( new Integer(ort), new Integer(blubb) );
  }
}

// -------------------------------------------------------------------------

// Entfernung zum Nest holen, falls keine gespeichert -1 als Rueckgabe

public int Get_Distance (int myX, int myY) 
{
  int ort = Pos2Int (myX, myY);
  Integer KeyOb = new Integer(ort);

  if (Bergauf.containsKey(KeyOb))
  {
    return ( ((Integer)Bergauf.get(KeyOb)).intValue() );
  } else
  {
    return (-1);
  }
}

// -------------------------------------------------------------------------
// -------------------------------------------------------------------------

// Uebersetzen der Koordinaten ins interne Datenformat

public int Pos2Int (int myX, int myY) 
{
  return ((myX+50)*100 + (myY+50));
}

// -------------------------------------------------------------------------
// -------------------------------------------------------------------------

}
