package bommel;
import algds.c2002.Hamster2;
import bommel.Const;
/**
 * Eine Klasse, um Info's ber Felder nebenan zu
 * sammeln, um den Weg nach Hause zu suchen. 
 */
class Infopoint implements Const {
    public int[][] info;
    
    /**
     * Standartkonstruktor
     */
    public Infopoint() {
        this.info = new int[7][2];
    }
    
    /**
     * initialisieren des Feldes
     */
    public void init_Info() {
        for(int i = 0; i < this.info.length; i++)
            for(int j = 0; j < this.info[0].length; j++)
                this.info[i][j] = MAX_VALUE;
    }
    
    /** nur fr log()
     */
    public String print_Info() {
        String s = "";
        for(int i = 0; i < this.info.length; i++){
            s = s + " " + i +":";
            for(int j = 0; j < this.info[0].length; j++)
                s = s + this.info[i][j];
        }
        return s;
    }
    
    /**
     * holt sich Infos aus den umstehenden Feldern
     */
    public void fuell_Info(int x, int y, Map map){
        for(int j = 0; j < this.info.length - 1; j++){
            this.info[j][0] = map.get_value_Map(x, y, j);
            if(j == 0 && this.info[0][0] != WALL_YES &&
                         this.info[0][0] != CLIFF_UP){
                this.info[0][1] = map.get_value_Map(x, y-1, DIST);
                this.info[0][0] = map.get_value_Map(x, y-1, SEE);
            }
            if(j == 1 && this.info[1][0] != WALL_YES &&
                         this.info[1][0] != CLIFF_UP){
                this.info[1][1] = map.get_value_Map(x+1, y, DIST);
                this.info[1][0] = map.get_value_Map(x+1, y, SEE);
            }
            if(j == 2 && this.info[2][0] != WALL_YES && 
                         this.info[2][0] != CLIFF_UP){
                this.info[2][1] = map.get_value_Map(x+1, y+1, DIST);
                this.info[2][0] = map.get_value_Map(x+1, y+1, SEE);
            }
            if(j == 3 && this.info[3][0] != WALL_YES && 
                         this.info[3][0] != CLIFF_UP){
                this.info[3][1] = map.get_value_Map(x, y+1, DIST);
                this.info[3][0] = map.get_value_Map(x, y+1, SEE);
            }
            if(j == 4 && this.info[4][0] != WALL_YES &&
                         this.info[4][0] != CLIFF_UP){
                this.info[4][1] = map.get_value_Map(x-1, y, DIST);
                this.info[4][0] = map.get_value_Map(x-1, y, SEE);
            }
            if(j == 5 && this.info[5][0] != WALL_YES &&
                         this.info[5][0] != CLIFF_UP){
                this.info[5][1] = map.get_value_Map(x-1, y-1, DIST);
                this.info[5][0] = map.get_value_Map(x-1, y-1, SEE);
            }
        }
        this.info[6][1] = map.get_value_Map(x, y, DIST);
        this.info[6][0] = map.get_value_Map(x, y, SEE);
    }// fuell_Info(int x, int y, Map map)
    
    /**
     * sucht sich den besten Weg aus
     */
    public int bestWay_Info(int x, int y, Map map) {
        init_Info();
        fuell_Info(x, y, map);
        int a = 6;
        
        for(int i = 0; i < this.info.length - 1; i++)
            if(this.info[i][1] == 0) 
                return i;
        for(int i = 0; i < this.info.length - 1; i++)
            if(this.info[i][0] == INDIZ && 
                this.info[i][1] < this.info[a][1])
                a = i;
        if(a != 6)
            return a;
        for(int i = 0; i < this.info.length - 1; i++)
            if(this.info[i][0] == VISIT && 
                this.info[i][1] < this.info[a][1])
                a = i;
        if(a != 6)
            return a;
        for(int i = 0; i < this.info.length - 1; i++)
            if(this.info[i][0] == INDIZ && 
                this.info[i][1] == this.info[6][1])
                return i;
        for(int i = 0; i < this.info.length - 1; i++)
            if(this.info[i][0] == VISIT && 
                this.info[i][1] == this.info[6][1])
                return i;
        for(int i = 0; i < this.info.length - 1; i++)
            if(this.info[i][0] == INDIZ && 
                this.info[i][1] >= this.info[6][1])
                return i;
        for(int i = 0; i < this.info.length - 1; i++)
            if(this.info[i][0] == VISIT && 
                this.info[i][1] >= this.info[6][1])
                return i;
        return 1;        
    }// bestWay_Info()
}// Infopoint