
package corncadger;

import java.awt.*;
import java.awt.event.*;

public class DebugWindow extends Frame implements ActionListener {

    boolean pressed = false;

    protected DebugWindow(String _str) {
	super("CornCadger Debug");
	this.setLayout(new BorderLayout());
	this.add(new TextArea(_str), BorderLayout.CENTER);

	Button ok = new Button("Ok");
	ok.addActionListener(this);
	
	this.add(ok, BorderLayout.SOUTH);
	this.setSize(200,100);
	this.setLocation(200,200);

	this.addWindowListener(new WindowListener() {
		public void windowOpened(WindowEvent _e) {}
		public void windowClosing(WindowEvent _e) {
		    pressed = true;
		}
		public void windowClosed(WindowEvent _e) {}
		public void windowIconified(WindowEvent _e) {}
		public void windowDeiconified(WindowEvent _e) {}
		public void windowActivated(WindowEvent _e) {}
		public void windowDeactivated(WindowEvent _e) {}
	    });

	this.show();
    }

    public void actionPerformed(ActionEvent _e) {
	this.pressed = true;
    }

    public static void debug(String _str) {
	DebugWindow window = new DebugWindow(_str);

	try {
	    while (!window.pressed)
		Thread.sleep(10);
	}
	catch (Exception _e) {
	    System.out.println("Failed, waiting for button pressed");
	}
	window.dispose();
    }

}
