
/*
 *
 * initializing the map
 *
 */

package corncadger.search;

import corncadger.Map;
import corncadger.Path;
import corncadger.Field;

import java.util.Enumeration;

public class MapInit {
    // initializing map
    public static void initMap(Map _m) {
        PathSet        paths;
        FieldPathCrawl crawl = PathSearch.mapInitCrawl(_m);
        paths = crawl.currentPaths();
        int cnt = 0;

        while (true) {
            // no more paths
            if (paths.count() == 0) 
                return;

            Enumeration e = paths.paths();
            while (e.hasMoreElements())
                ((Path)(e.nextElement())).end().setRadius(cnt);
            cnt++;
            paths = crawl.extendPathsByOneStep(false);
        }
    }

}
