package dierennsemmel;

public class Node2{

  private Field element;

  private Node2 next;
  private Node2 parent;

  public Node2() {
    this(null,null,null);
  }

  public Node2(Field f) {
    this(f,null,null);
  }

  public Node2(Node2 p) {
    this(null,null,p);
  }

  public Node2(Field e, Node2 n,Node2 p){
    element = e;
    next = n;
    parent = p;
  }

  Field getElement() {
    return element;
  }

  Node2 getNext() {
    return next;
  }

  Node2 getParent() {
    return parent;
  }

  void setElement(Field newElem) {
    element = newElem;
  }

  void setNext(Node2 newNext) {
    next = newNext;
  }

  void setParent(Node2 p) {
    parent = p;
  }
}