
//Titel:        Dighty-Hamster
//Version:
//Copyright:    Copyright (c) 1999
//Autor:       Stoneyard
//Firma:
//Beschreibung:  Programmierwettbewerb 2002
package dighty;
import algds.c2002.Hamster2;
import algds.c2002.Constants;
/**
  Hamster aktuallisiert sein Wissen ueber das Feld, das vor ihm liegt
 */
public class CHamsterGetFeldInfo {
  public static void run(Hamster2 cHamster, CDightyData cD) {
    int iForward = cHamster.lookForward();
    cD.Access().m_iRahmen[cD.m_iDirection] = iForward; // <-- jetziges Feld
    cD.Access_opt().m_iRahmen[cD.m_iDirection] = iForward;
    int iBX = cD.m_iPosX + CLabyrinth_ly0.c_iMoveX[cD.m_iDirection];
    int iBY = cD.m_iPosY + CLabyrinth_ly0.c_iMoveY[cD.m_iDirection];
    // Hoehe speichern
    CFeld cFeld = cD.m_cpFelder.Access(iBX, iBY);
    CFeld cFeld_opt;
    cFeld_opt = cD.m_cpFelder_Optimal == null ? cD.m_cpFelder.Access(iBX, iBY) : cD.m_cpFelder_Optimal.Access(iBX, iBY);
    if ((iForward & Constants.WALLMASK) != 2)  cFeld_opt.m_iHoehe = cFeld.m_iHoehe = cD.Access().m_iHoehe + cHamster.getHeightDifference();
    if (cHamster.getHeightDifference() != 0) cD.m_cpFelder.m_bIsExtendedLyb = true;
    // umwandeln der Daten fuer das Feld gegenueber
    iForward = (((iForward & Constants.WALLMASK) == Constants.WALL) || ((iForward & Constants.WALLMASK) == 0)) ? iForward : iForward ^ 2;
    cFeld_opt.m_iRahmen[CLabyrinth_ly0.Reflect(cD.m_iDirection)] = cFeld.m_iRahmen[CLabyrinth_ly0.Reflect(cD.m_iDirection)] = iForward; //<-- das Feld vor dem Hamster
    if (((iForward & Constants.CORNMASK) == Constants.CORN) && (cFeld.m_iAnz_Koerner == CLabyrinth_ly0.c_iUnexploreCornData))
     cFeld_opt.m_iAnz_Koerner = cFeld.m_iAnz_Koerner = CLabyrinth_ly0.c_iUnexploredCornCount;
    if ((((iForward & Constants.WALLMASK) == Constants.SLOPEDOWN) || ((iForward & Constants.WALLMASK) == Constants.CLIFFDOWN)) && (cFeld.m_iAnz_Koerner == CLabyrinth_ly0.c_iUnexploreCornData))
     cFeld_opt.m_iAnz_Koerner = cFeld.m_iAnz_Koerner = CLabyrinth_ly0.c_iUnexploredCornCount;
    // Wenn ein Feld von aussen total erkundet wurde, markiere es als bekannt
    if (!cFeld.m_bBekanntheitsgrad)
    {
      if(cFeld.m_iAnz_Koerner != CLabyrinth_ly0.c_iUnexploredCornCount)
      {
        int j = 0;
        int iPosX, iPosY;
        for (int i = 0; i < CLabyrinth_ly0.c_iMovepossibilities; i++)
        {
          iPosX = iBX + CLabyrinth_ly0.c_iMoveX[i];
          iPosY = iBY + CLabyrinth_ly0.c_iMoveY[i];
          if ((iPosX < 0 ) || (iPosY < 0) || (iPosX >= CLabyrinth_ly0.Transform_KoordXRet(CLabyrinth_ly0.c_iMaxSizeX)) || (iPosY >= CLabyrinth_ly0.Transform_KoordYRet(CLabyrinth_ly0.c_iMaxSizeY))) {
            j++;
            continue;
          }
          CFeld cTestFeld = cD.m_cpFelder.Access(iPosX, iPosY);
          if ((cTestFeld.m_iAnz_Koerner >= 0) && /*((cFeld.m_iRahmen[i] & 2) == 0) &&*/ (cFeld.m_iRahmen[i] != CLabyrinth_ly0.c_iUnexploreCornData))
            j++;
          else
            break;
        }
        if ((j == CLabyrinth_ly0.c_iMovepossibilities)/* && (cD.Access().m_iAnz_Koerner != CLabyrinth_ly0.c_iUnexploredCornCount)*/)
          cFeld_opt.m_bBekanntheitsgrad = cFeld.m_bBekanntheitsgrad = true;
      }
      // bestimmen der maximalen Ausdehnung
    }
  }
}
