
//Titel:        Dighty-Hamster
//Version:
//Copyright:    Copyright (c) 1999
//Autor:       Stoneyard
//Firma:
//Beschreibung:  Programmierwettbewerb 2002
package dighty;
import algds.c2002.Hamster2;

/**
  Hamster bewegt sich zu einem bestimmten Feld, fals moeglich
*/
public class CHamsterMoveTo {

  static protected final CPathFinder_A cPathfinder = new CPathFinder_A();
  public static void run(Hamster2 cHamster, CDightyData cD, int iToX, int iToY) { run(cHamster, cD, iToX, iToY, false); }
  public static void run(Hamster2 cHamster, CDightyData cD, int iToX, int iToY, boolean bLog) {
    CHamsterDoAStep.RestorePos(cHamster, cD);
    CPath cPath = cPathfinder.go(cD.m_cpFelder, cD.m_iPosX, cD.m_iPosY, iToX, iToY, bLog || cHamster.verbose());
    // hohle Korninformationen
    CHamsterGetCornInfo.run(cHamster, cD);
    while (cPath.size() != 0)
    {
      // hohlen der Richtung
      int iDir = ((Integer)(cPath.pop())).intValue();
      // drehen, falls noetig
      CHamsterLockTo.run(cHamster, cD, iDir);

      // laufen
      if (!CHamsterDoAStep.run(cHamster, cD, false))
      {
        // sollte eigentlich nie Eintreten, falls doch muss dafuer gesorgt werden, das die internen Daten stimmig bleiben
        cHamster.logln("!!Kollision; X: " + Integer.toString(cD.m_iPosX) + " Y: " + Integer.toString(cD.m_iPosY) + " D: " + Integer.toString(cD.m_iDirection));
        cD.m_iDirection = ((cD.m_iDirection - 1) + CLabyrinth_ly0.c_iMovepossibilities) % CLabyrinth_ly0.c_iMovepossibilities;
      }
      // hohle Korninformationen
      CHamsterGetCornInfo.run(cHamster, cD);
      if (cHamster.atHome()) cHamster.dropHere(cHamster.getCarriedCorn());
      if (CHamsterLockAround.run(cHamster, cD))
      {
        cD.m_cpFelder.DistanceBuffering(true);
        cPath = cPathfinder.go(cD.m_cpFelder, cD.m_iPosX, cD.m_iPosY, iToX, iToY, bLog || cHamster.verbose());
      }
    }
    if ((cD.m_iPosX != iToX) || (cD.m_iPosY != iToY))
      cHamster.logln(" Zielfeld nicht erreicht!: TX " + Integer.toString(iToX) + " TY: "  + Integer.toString(iToY) + " AX: " + Integer.toString(cD.m_iPosX) + " AY: " + Integer.toString(cD.m_iPosY));
  }
  public static void run(int x, Hamster2 cHamster, CDightyData cD, int iToX, int iToY) {
    CPath cPath = cPathfinder.go(cD.m_cpFelder, cD.m_iPosX, cD.m_iPosY, iToX, iToY, false);
    // hohle Korninformationen
    while (cPath.size() != 0) {
      int iDir = ((Integer)(cPath.pop())).intValue();
      CHamsterLockTo.run(cHamster, cD, iDir);
      // laufen
      if (!CHamsterDoAStep.run(cHamster, cD, false))  {
        cD.m_iDirection = ((cD.m_iDirection - 1) + CLabyrinth_ly0.c_iMovepossibilities) % CLabyrinth_ly0.c_iMovepossibilities;
      }
      // hohle Korninformationen
      CHamsterLockAround.run(cHamster, cD);
    }
    if ((cD.m_iPosX != iToX) || (cD.m_iPosY != iToY)) cHamster.logln(" Zielfeld nicht erreicht!: TX " + Integer.toString(iToX) + " TY: "  + Integer.toString(iToY) + " AX: " + Integer.toString(cD.m_iPosX) + " AY: " + Integer.toString(cD.m_iPosY));
  }
}