
//Titel:        Dighty-Hamster
//Version:
//Copyright:    Copyright (c) 1999
//Autor:       Stoneyard
//Firma:
//Beschreibung:  Programmierwettbewerb 2002
package dighty;
import algds.c2002.Hamster2;
import algds.c2002.Constants;
import java.lang.Thread;
/** einfache Klasse die 2 Integerwerte fasst*/
public class CHamsterTimeOutSaver extends Thread{

  Hamster2 m_cHamster;
  CDightyData m_cD;
  static final int c_iMaxSleepCount = 40 - 1;
  static final long c_iSleepTime = (Constants.INFINITE_LOOP - 10)  / (c_iMaxSleepCount + 1);
  boolean bDoStop = false;
  boolean m_bTimeOutWarned = false;
  public CHamsterTimeOutSaver(Hamster2 cHamster, CDightyData cD)
  {
    m_cHamster = cHamster;  m_cD = cD;
    m_cD.m_bTimeOutWarning = false;
  }
  public void DoStop()
  {
    bDoStop = true;
  }
  public void run()
  {
    int iStopedCount = 0;
    long lStartTime = System.currentTimeMillis();
    while (!bDoStop)
    {
      try {
        sleep(c_iSleepTime);
      } catch (InterruptedException e) {
        m_cHamster.logln(" !TimeOutSaver interupted! <-- not handled");
      }
      if (m_cD.m_bMoved)
      {
        iStopedCount = 0;
        m_cD.m_bMoved = false;
        lStartTime = System.currentTimeMillis();
        m_cD.m_bTimeOutWarning2 = false;
      }else
      {
        iStopedCount++;
        if (lStartTime + Constants.INFINITE_LOOP - System.currentTimeMillis() - c_iSleepTime - 100 < 0)
        {
          m_cHamster.logln(" !TimeOutSaver activated -> execute emergency program (costs: min 1 point!)");
          CHamsterDoAStep.run(m_cHamster, m_cD, true);
          m_cD.m_bMoved = false;
          iStopedCount = 0;
          lStartTime = System.currentTimeMillis();
          m_bTimeOutWarned = false;
          m_cD.m_bTimeOutWarning2 = false;
        } else
        {
          if ((lStartTime + Constants.INFINITE_LOOP - System.currentTimeMillis() - 3 * c_iSleepTime - 100 < 0))
          {
            m_cD.m_bTimeOutWarning2 = true;
            if ((!m_bTimeOutWarned) && (!m_cD.m_bMovedTimeOutSaver)) {
              m_cD.m_bTimeOutWarning = true;
              m_bTimeOutWarned = true;
            }
          }
          if (iStopedCount > c_iMaxSleepCount * 7 / 8)
          m_cHamster.logln(" warning: timeout -> start emergency program in " + Integer.toString(c_iMaxSleepCount - iStopedCount) + " times" );
        }
      }
    }
  }



}
