
//Titel:        Dighty-Hamster
//Version:
//Copyright:    Copyright (c) 1999
//Autor:       Stoneyard
//Firma:
//Beschreibung:  Programmierwettbewerb 2002
package dighty;
/**
  implementation der Schnittstelle fuer alle Pfadfindrotienen
*/
abstract public class CPathFinder {
  protected CLabyrinth_ly0 m_cpFelder = null;
  protected int m_iStartX = 0;
  protected int m_iStartY = 0;
  protected int m_iEndX = 0;
  protected int m_iEndY = 0;
  abstract public CPath go(boolean bLog);
  public CPath go() {return go(false); }
  public CPath go(int iSX, int iSY, int iEX, int iEY) { return go(iSX, iSY, iEX, iEY, false);}
  public CPath go(CLabyrinth_ly0 cpFelder, int iSX, int iSY, int iEX, int iEY) { return go(cpFelder, iSX, iSY, iEX, iEY, false);}
  public CPath go(int iSX, int iSY, int iEX, int iEY, boolean bLog)
  {
    m_iStartX = iSX;
    m_iStartY = iSY;
    m_iEndX   = iEX;
    m_iEndY   = iEY;
    return go(bLog);
  }
  abstract public int go_fast();
  public int go_fast(CLabyrinth_ly0 cpFelder, int iSX, int iSY, int iEX, int iEY) {m_cpFelder = cpFelder; return go_fast(iSX, iSY, iEX, iEY);}
  public int go_fast(int iSX, int iSY, int iEX, int iEY)
  {
    m_iStartX = iSX;
    m_iStartY = iSY;
    m_iEndX   = iEX;
    m_iEndY   = iEY;
    return go_fast();
  }
  public CPath go(CLabyrinth_ly0 cpFelder, int iSX, int iSY, int iEX, int iEY, boolean bLog)
  {
    m_cpFelder = cpFelder;
    return go(iSX, iSY, iEX, iEY, bLog);
  }
}
