package gau;

import java.util.*;


/**
 * @author Julia Schmiedel, Jens Knappe
 */

public class Map{

public Zelle [][] array;
public Stack way;

public Map (int x, int y){

	array = new Zelle [x][y];
}

public void setZelle(Koordinate xy, Zelle z){

	array [xy.getX()][xy.getY()] = z;
}

public Zelle getZelle(Koordinate xy){
	return array [xy.getX()][xy.getY()];
}

void changeAbstand(Koordinate xy){
	int abstand = 0;
	boolean test=true;
	Koordinate nachbar = new Koordinate(0,0);
	changeAbstandAll();
	Zelle a = array [xy.getX()][xy.getY()];
	a.setAbstand(abstand);
	array [xy.getX()][xy.getY()] = a;
	
	while(test==true){
	test=false;

	for (int i=0; i<array.length; i++){
		for (int j=0; j<array.length; j++){
			if (array [i][j] != null && array [i][j].getAbstand() == 9999)test=true;	
			if (array [i][j] != null && array [i][j].getAbstand() == abstand){
				Zelle z = array [i][j];
				xy.setXY(i,j);
				if (z.getWando() == false){
					nachbar = xy.getNachbarKoordinate(0);
					fuerChangeAbstand(nachbar,abstand);
				}
				if (z.getWandro() == false){
					nachbar = xy.getNachbarKoordinate(60);
					fuerChangeAbstand(nachbar,abstand);
				}
				if (z.getWandru() == false){
					nachbar = xy.getNachbarKoordinate(120);
					fuerChangeAbstand(nachbar,abstand);
				}
				if (z.getWandu() == false){
					nachbar = xy.getNachbarKoordinate(180);
					fuerChangeAbstand(nachbar,abstand);
				}
				if (z.getWandlu() == false){
					nachbar = xy.getNachbarKoordinate(240);
					fuerChangeAbstand(nachbar,abstand);
				}
				if (z.getWandlo() == false){
					nachbar = xy.getNachbarKoordinate(300);
					fuerChangeAbstand(nachbar,abstand);
				}
			}
		}
	}
	abstand++;
	}
}

void changeAbstandAll(){
	for (int i=0; i<array.length; i++){
		for (int j=0; j<array.length; j++){
			if (array [i][j] != null){
				Zelle z = array [i][j];
				z.setAbstand(9999);
				array [i][j] = z;
			}
		}
	}

}

void fuerChangeAbstand(Koordinate ab, int abstand){
	if(array [ab.getX()][ab.getY()].getAbstand() > (abstand)){
		Zelle b = array [ab.getX()][ab.getY()];
		b.setAbstand(abstand+1);
		array [ab.getX()][ab.getY()] = b;
	}
}

Stack wayFrom(Koordinate start){
	way = new Stack();
	Stack wayout = new Stack();
	fuerwayFrom1(start);
	while (way.isEmpty()==false) wayout.push(way.pop());
	return wayout;
}

Stack fuerwayFrom1(Koordinate start){
	Zelle z = array [start.getX()][start.getY()];
	int abstand = z.getAbstand();
		if(z.getWando() == false && array [start.getNachbarKoordinate(0).getX()][start.getNachbarKoordinate(0).getY()].getAbstand() < abstand){
			way.push(new Integer(0));
			//System.out.println("0");
			fuerwayFrom1(start.getNachbarKoordinate(0));
		}
		else if(z.getWandro() == false && array [start.getNachbarKoordinate(60).getX()][start.getNachbarKoordinate(60).getY()].getAbstand() < abstand){
			way.push(new Integer(60));
			//System.out.println("60");
			fuerwayFrom1(start.getNachbarKoordinate(60));
		}
		else if(z.getWandru() == false && array [start.getNachbarKoordinate(120).getX()][start.getNachbarKoordinate(120).getY()].getAbstand() < abstand){
			way.push(new Integer(120));
			//System.out.println("120");
			fuerwayFrom1(start.getNachbarKoordinate(120));
		}
		else if(z.getWandu() == false && array [start.getNachbarKoordinate(180).getX()][start.getNachbarKoordinate(180).getY()].getAbstand() < abstand){
			way.push(new Integer(180));
			//System.out.println("180");
			fuerwayFrom1(start.getNachbarKoordinate(180));
		}
		else if(z.getWandlu() == false && array [start.getNachbarKoordinate(240).getX()][start.getNachbarKoordinate(240).getY()].getAbstand() < abstand){
			way.push(new Integer(240));
			//System.out.println("if240");
			fuerwayFrom1(start.getNachbarKoordinate(240));
		}
		else if(z.getWandlo() == false && array [start.getNachbarKoordinate(300).getX()][start.getNachbarKoordinate(300).getY()].getAbstand() < abstand){
			way.push(new Integer(300));
			//System.out.println("300");
			fuerwayFrom1(start.getNachbarKoordinate(300));
		}
	return way;
}

Koordinate waySearch2(Koordinate aktuell){
	int abstand = 0;
	changeAbstand(aktuell);
	abstand = 0;
	while (abstand != 400){
		for (int i=0; i<array.length; i++){
			for (int j=0; j<array.length; j++){
				if (array [i][j] != null && array[i][j].getAbstand() == abstand){
 					if (array[i][j].getStatus() == 2 && array[i][j].getCornstatus()==true)
						return new Koordinate(i,j);
					else if(array[i][j].getStatus() == 1 && array[i][j].getCornstatus()==true)
						return new Koordinate(i,j);
					else if(array[i][j].getStatus() == 1)
						return new Koordinate(i,j);
				}
			}
		}
	abstand++;
	}
        //System.out.println("murks");
	return new Koordinate(0,0);
}

Koordinate waySearch(Koordinate aktuell){
	int abstand = 0;
	changeAbstand(aktuell);
	while (abstand != 10){
		for (int i=0; i<array.length; i++){
			for (int j=0; j<array.length; j++){
				if (array [i][j] != null && array[i][j].getAbstand() == abstand && array[i][j].getStatus() == 2 && array[i][j].getCornstatus()==true){
					return new Koordinate(i,j);
				}
								
			}
		}
	abstand++;
	}
	abstand = 0;
	while (abstand != 10){
		//System.out.print("2");
		for (int i=0; i<array.length; i++){
			for (int j=0; j<array.length; j++){
				if (array [i][j] != null && array[i][j].getAbstand() == abstand && array[i][j].getStatus() == 1 && array[i][j].getCornstatus()==true){
					return new Koordinate(i,j);
				}
				
			}
		}
	abstand++;
	}
	abstand = 0;
	while (abstand != 180){
		//System.out.print("3");
		for (int i=0; i<array.length; i++){
			for (int j=0; j<array.length; j++){
				
				if (array [i][j] != null && array[i][j].getAbstand() == abstand && array[i][j].getStatus() == 1){
					return new Koordinate(i,j);
				}
			}
		}
	abstand++;
	}
        //System.out.println("murks");
	
	
	return new Koordinate(0,0);
}
void abstand100(int ab){
	changeAbstand(new Koordinate(30,30));
	for (int k=0; k<array.length; k++){
		for (int l=0; l<array.length; l++){
			if (array [k][l] != null && array [k][l].getAbstand() >= ab+1){
				array [k][l].status=0;
				array [k][l].setCornstatus(false);
				array [k][l].setCorn(0);
				//System.out.print("a");
			}
		}
	}
}
void sinnvollextra(Koordinate ak){
	for (int k=0; k<array.length; k++){
		for (int l=0; l<array.length; l++){
			if (array [k][l] != null && array [k][l].getStatus()==2 && array [k][l].getCornstatus()==true){
				int corn = array [k][l].cornanzahl;
				int schritte = corn*5;
				changeAbstand(new Koordinate(k,l));
				boolean change = true;
				if (array [30][30].getAbstand()<=schritte) change = false;
				if (array [ak.x][ak.y].getAbstand()<=schritte) change = false;
				for(int ab=1; ab<=schritte; ab++){
				if(change==true){
					for (int c=0; c<array.length; c++){
						for (int d=0; d<array.length; d++){
							if (array [c][d] != null && array [c][d].getAbstand() == ab){
								if (array [c][d].getStatus() == 1) change = false;
								if (array [c][d].getStatus() == 2 && array [c][d].getCornstatus()==true) change=false;
							}
						}
					}
				}}
				
				if (change==true) {
					//System.out.println("ex");
					array [k][l].setCorn(0);
					array [k][l].setCornstatus(false);
				}
						
				
			}
		}
	}
}

void sinnvoll(){
	int i;
	int j;
	for (int k=0; k<array.length; k++){
		for (int l=0; l<array.length; l++){
			if (array [k][l] != null && array [k][l].getStatus()==1 && array [k][l].getCornstatus()==false){
				int status0=0;
				int status1=0;
				int status2=0;

				i=k;
				j=l+1;
				if (array [i][j] != null ){
					if (array [i][j].getStatus()==2) status2++;
					else if (array [i][j].getStatus()==1) status1++;
					else if (array [i][j].getStatus()==0) status0++;
				}
				i=k+1;
				j=l+1;
				if (array [i][j] != null ){
					if (array [i][j].getStatus()==2) status2++;
					else if (array [i][j].getStatus()==1) status1++;
					else if (array [i][j].getStatus()==0) status0++;
				}
				i=k+1;
				j=l;
				if (array [i][j] != null ){
					if (array [i][j].getStatus()==2) status2++;
					else if (array [i][j].getStatus()==1) status1++;
					else if (array [i][j].getStatus()==0) status0++;
				}
				i=k;
				j=l-1;
				if (array [i][j] != null ){
					if (array [i][j].getStatus()==2) status2++;
					else if (array [i][j].getStatus()==1) status1++;
					else if (array [i][j].getStatus()==0) status0++;
				}
				i=k-1;
				j=l-1;

				if (array [i][j] != null ){
					if (array [i][j].getStatus()==2) status2++;
					else if (array [i][j].getStatus()==1) status1++;
					else if (array [i][j].getStatus()==0) status0++;
				}
				i=k-1;
				j=l;

				if (array [i][j] != null ){
					if (array [i][j].getStatus()==2) status2++;
					else if (array [i][j].getStatus()==1) status1++;
					else if (array [i][j].getStatus()==0) status0++;
				}
				int status01=status1+status0;
				int statusgesamt=status01+status2;
				if(statusgesamt==6){
					if(status01 <= 5) {
					array[k][l].status=0;
					//System.out.println(k+" "+l+" Status1"+" "+status1+" Status2"+" "+status2+" Status0"+" "+status0+" Status01"+" "+status01);
					}
				}
			}
		}
	}
}

/*void sinnvoll2(Koordinate xy){
	
	
	for (int a=0; a<6; a++){
	
		Koordinate nachbar = xy.getNachbarKoordinate(a*60).copy();
		if(array [nachbar.getX()][nachbar.getY()]!= null && array [nachbar.getX()][nachbar.getY()].getStatus()==1 && array [nachbar.getX()][nachbar.getY()].getCornstatus()==false){
				int status1=0;
				int status0=0;
				int status2=0;
				for (int k=0; k<6; k++){
					
					Koordinate nextnachbar=nachbar.getNachbarKoordinate(k*60).copy();
					int x=nextnachbar.getX();
					int y=nextnachbar.getY();
				
					if (array [x][y] != null ){
						if (array [x][y].getStatus()==2) status2++;
						else if (array [x][y].getStatus()==1) status1++;
						else if (array [x][y].getStatus()==0) status0++;
					}
				}
				
					int status01=status1+status0;
					int statusgesamt=status01+status2;
					if(statusgesamt==3){
						if(status01 <= 5) {
						array[nachbar.getX()][nachbar.getY()].status=0;
						//System.out.println(nachbar.getX()+" "+nachbar.getY()+" Status1"+" "+status1+" Status2"+" "+status2+" Status0"+" "+status0+" Status01"+" "+status01);
						
						}
			
					}
	
			
		}
	}	

}*/

void out(){
	for (int i=0; i<array.length; i++){
		for (int j=0; j<array.length; j++){
			if (array [i][j] != null){

				System.out.println(String.valueOf(i)+","+String.valueOf(j)+" "+array[i][j].toString());
			}
		}
	}	

}
}