package h2d2c;
import java.util.*;

/**
 * Dient der Sortierung von Cell-Objekten in PriorityQueue:
 * Ordnet sie nach "wayhome.distance" aufsteigend.
 */
class CompareWayHome implements Comparator {

static final Comparator COMPARATOR = new CompareWayHome();

public int compare(Object o1, Object o2) {
  Cell c1 = (Cell)o1, c2 = (Cell)o2;

  int res = (c1.wayhome.distance - c2.wayhome.distance);
  if (res!=0) return res;
  res = c1.getState()-c2.getState();
  if (res!=0) return res;
  return 0;
}

}
