package mort;

public class Pos {
  public int x;
  public int y;
  
  Pos(int _x, int _y) {
    x=_x; y=_y;
  }     
  
  public Object clone() {
    return new Pos(this.x,this.y);
  }
  
  public boolean equals(Pos other) {
    if (this.x!=other.x) return false;
    if (this.y!=other.y) return false;
    return true;
  }

  public void setNextPos(int which) {
    int neighborx[]={0,1,1,0,-1,-1};
    int neighbory[]={1,0,-1,-1,0,1};
    
    this.x+=neighborx[which];
    this.y+=neighbory[which];
  }
  
  public String toString() {
    return "("+x+"|"+y+")";
  }
  
  public double getX() {
    return ((double)x-30.0)*0.866;
  }
  
  public double getY() {
    return ((double)y-30.0)+((double)x-30.0)*0.5;
  }
}