
package nexus;


/**
 * Eine 2D-"2Bit"Map-ber dem Labyrinth um sich fr
 * ein Feld etwas zu merken, fr das man nicht unbedingt
 * eine Variable in Field einfgen will
 *
 * @author <a href="mailto:jensL81@gmx.de">Jens Lincke</a>
 */
class BinMap{

    private int MAP_LENGHT;
    private boolean[][] map;
    
    /**
     * Creates a new <code>BinMap</code> instance.
     *
     */
    BinMap(){
	MAP_LENGHT=(2*Nexus.MAZELENGTH_MAX)-1;

	map = new boolean[MAP_LENGHT][MAP_LENGHT];
	for(int i=0; i<MAP_LENGHT; i++)
	    for(int j=0; j<MAP_LENGHT; j++)
		map[i][j]=false;
	
    }
 
    /**
     * Describe <code>isExplored</code> method here.
     *
     * @param p a <code>Position</code> value
     * @return a <code>boolean</code> value
     */
    public boolean isExplored(Position p){
	return map[p.x+Nexus.MAZELENGTH_MAX-1][p.y+Nexus.MAZELENGTH_MAX-1];
    }
    /**
     * Describe <code>setExplored</code> method here.
     *
     * @param p a <code>Position</code> value
     */
    public void setExplored(Position p){
	map[p.x+Nexus.MAZELENGTH_MAX-1][p.y+Nexus.MAZELENGTH_MAX-1]=true;
    }
    
    /**
     * Describe <code>setUnExplored</code> method here.
     *
     * @param p a <code>Position</code> value
     */
    public void setUnExplored(Position p){
	map[p.x+Nexus.MAZELENGTH_MAX-1][p.y+Nexus.MAZELENGTH_MAX-1]=false;
    }


}



