
package nexus;

import java.util.Stack;

/**
 * Vielleicht der falsche Name fr eine Klasse die Gedacht war
 * um noch Korn auf Feldern einzusammeln, bei denen es sich allein
 * nicht lohnen wrde, wenn man sie zusammen mit Nachbarfeldern besucht
 * doch noch etwas positives bei rauskommen wrde.
 * Auf jeden Fall hat sich der Aufwand nich gelohnt. Eine nderung der
 * Punktzahl ist nur bei Synthetischen Benchmarks zu beobachten
 * 
 *
 */
class NextIntrestingFieldFrom extends NextIntrestingField {
    
    int corn_on_route;
    int pathlength;
    //    Stack visitedPositions; 
    BinMap visitedPositions;
           
    NextIntrestingFieldFrom(Nexus hamster, Position from, 
			    int corn_on_route, int waylength,
			    BinMap visitedPositions){
	super(hamster);
	start = from;
	this.corn_on_route = corn_on_route;
	this.pathlength = waylength;
	this.visitedPositions = visitedPositions;

    }
    
    public boolean hasCornRevenue(Path path){  
	    //super.hasCornRevenue(path)
	return  hasCornRevenueOnRoute(path);
    }


    public boolean hasCornRevenueOnRoute(Path path){
	Position p = path.position;
	Field f = hamster.map.getField(p);
	  
	if((f.corn <= 0) || p.isHome() || visitedPositions.isExplored(p)) 
	    return false;
	else {
	    int mycorn_on_route = this.corn_on_route + f.corn;  
	    Path pathhome= (new ShortestPathHomeFrom(hamster, p)).findPath();
	
	    // wer wei, vielleicht findet er ja kein heimweg
	    int mypathlength = pathlength + (pathhome == null ? 
					     0 : path.length());

	    if(hamster.verbose()){
		hamster.logln
			("POINTS+: " + (mycorn_on_route * POINTS_CORN) 
			 + " POINTS-: "  
			 + ((mypathlength + pathhome.length()) * POINTS_STEP)
			 + " corn_on_route: " + corn_on_route 
			 + " mycorn_on_route: " + mycorn_on_route 
			 + " mypathlength: " + mypathlength 
			 + " pathhome: " + pathhome.length());
	    }
	    
    
	    if(((Math.min(mycorn_on_route, CORNCARRY_MAX)   * POINTS_CORN) 
		+ (Math.min((mypathlength + pathhome.length()),
			    (CORNCARRY_MAX * POINTS_CORN)) * POINTS_STEP))
	       > 0) {
		return true;
	    }else{
		if(hamster.verbose())
		    hamster.logln("versuche es im nchsten Feld\n"
				  + "mycorn_on_route: " + mycorn_on_route
				  + " mypathlength: " + mypathlength);	
	    
		visitedPositions.setExplored(p);
		Path next = (new NextIntrestingFieldFrom
			     (hamster, p, 
			      mycorn_on_route,
			      mypathlength,
			      visitedPositions)).findPath();
		
		if(next == null){
		    //vorsicht endlosschleife grrr
		    //visitedPositions.setUnExplored(p);
		    return false;
		}	
	    }
	}
	return true;
    }
    
}
