import algds.c2002.*;
/**
 * berschrift:   Hamsterwettbewerb EAD WS01/02
 * Beschreibung:  Erstellung eines lauffhigen Hamsters fuer einfaches Labyrinth
 * Copyright:     Copyright (c) 2002
 * Organisation:
 * @author        Rocco Gasteiger
 * @version 1.0
 * Hinweis:
 */

public class roadrunner extends Hamster {
  boolean finished = false;
  boolean sackgasse=false;
  //die Formle bestimmt die Anzahlder Zeilen, abhngig von Seitenlange
  int groesse=((((2*MAZELENGTH_MAX-2)*((2*MAZELENGTH_MAX-2)+1))/2) -
              (((MAZELENGTH_MAX-1)*(MAZELENGTH_MAX))/2))*2 + (2*MAZELENGTH_MAX)-1;
  //das Protokoll, in welches der Hamster seine Informationen eintraegt
  int[][] protokoll = new int[10][groesse];
  //variable, die jedesmal vorn vorn neu zaehlt, wenn Korn
  //im Heimatfeld abgelegt worden ist, wenn counter groesser
  //zaehler ist, dann wird zaehler um 1 erhoeht
  int counter=0;
  //Variable, die nur mitlaeuft, wenn neue Felder, Drehungen
  //oder Umgebung erkundet wird
  int zaehler=0;
  // Variable fuer Schritte, die der Hamster nach Sackgasse
  //zurueckgehen mu, um an einen noch nicht besuchten Gang zu gelangen
  int steps=0;
  //wird benutzt um das Untersuchen der Nachbarfelder zuzulassen oder nicht
  //wichtig wenn der Hamster von einer Sackgasse zu einem neuen Abzweig kommt.
  //Da er auf diesem nicht die NAchbarfelder neu untersuchen soll,
  //sondern nur das Feld "schlieen" soll, welches zu Sackgasse fuehrt
  int schritte=0;
  //Zaehlvariablen
  int anzahl=0;
  int drehungen=9;
  int u=0;
  int t=0;

// die Hauptmethode. In dieser bewegt sich der Hamster, wenn diese verlassen wird haelt der Hamster an
public void run() {

//ChS
try{
//ChS

    while(!finished) {
      sammeln();
      gehNachHause();
      KornAblegen();
      if (finished == true)
        break;
      gehZumKorn();
   }

//ChS
}catch(RuntimeException ex){
  if (ex.getMessage().equals("Kollision!")) return;  // bei erster Kollision stoppen
  throw ex;  // andere Exceptions trotzdem werfen
}
//ChS

}
// die Erkundungs- und Sammelmethode. Hier sucht er das Labyrinth ab, sammelt Korn und schreibt sich in eine
// Karte, wo er ueberall schon war
public int[][] sammeln() {
    int turning=0;
    boolean maul = false;
    boolean test=false;
    if (verbose()) logln("Happa happa.");
     ab_da_weiter:    //breakmarke wenn das Maul voll ist

     while(!maul) {
        hier:         //breakmarke wenn Sackgasse erreicht ist
        while (sackgasse == false) {
          if(schritte == 0) {
            //Codezeilen 73 - 92 dienen zum erkunden der Nachbarfelder und des aufnehmens
            //der Koerner
            //Notbremse (Hamster geht wahrscheinlich im Kreis)
            if(zaehler >= groesse) {
              finished=true;
              maul=true;
              return protokoll;
            }
            if((lookForward() & WALLMASK) == WALL)  protokoll[0][zaehler]=5;
            else  protokoll[0][zaehler]=7;    //spezialisiert, da gerade aus keine Wand ist
            turn(TURN_RIGHT);
            if((lookForward() & WALLMASK) == WALL)  protokoll[1][zaehler]=5;
            else protokoll[1][zaehler]=4;
            turn(TURN_RIGHT);
            if((lookForward() & WALLMASK) == WALL)  protokoll[2][zaehler]=5;
            else protokoll[2][zaehler]=4;
            turn(TURN_LEFT);turn(TURN_LEFT);turn(TURN_LEFT);
            if((lookForward() & WALLMASK) == WALL)  protokoll[3][zaehler]=5;
            else protokoll[3][zaehler]=4;
            turn(TURN_LEFT);
            if((lookForward() & WALLMASK) == WALL)  protokoll[4][zaehler]=5;
            else protokoll[4][zaehler]=4;
            turn(TURN_LEFT);
            if((lookForward() & WALLMASK) == WALL)  protokoll[5][zaehler]=5;
            else protokoll[5][zaehler]=4;
            turn(TURN_RIGHT);turn(TURN_RIGHT);turn(TURN_RIGHT);
            if(!atHome()) {
              take(CORNCARRY_MAX);
              protokoll[9][zaehler-1]=getAvailableCorn();
            }
            //Ueberpruefung ob Sackgasse vorhanden ist
            if(!atHome()) {
              counter=0;
              for(int a=0; a<5; a++) {
                if(protokoll[a][zaehler] != 5) {
                  sackgasse = false;
                  break;
                }
                else {
                  sackgasse = true;
                  counter++;
                }
              }
              if(counter >= 5 && protokoll[9][zaehler-1] != 0) {
                sackgasse= false;
                break ab_da_weiter;
              }
              if(counter >= 5) break hier;
            }
            if (getCarriedCorn() == CORNCARRY_MAX) {
              maul=true;
              break ab_da_weiter;
            }

          zaehler++;

          }
          schritte=0;
          turning=0;
          //Notbremse, falls der Hamster nur im Kreis geht
          if(zaehler >= groesse) {
            finished=true;
            maul=true;
            return protokoll;
          }
          //es wird solange gedreht, bis keine Wand oder ein unbekanntes Feld
          //(freierZugang == true in Blickrichtung sich befindet
          while ((lookForward() & WALLMASK) == WALL || freierZugang(turning)) {
             turn(TURN_RIGHT);
             protokoll[turning][zaehler]=3;
             turning++;

             if(turning > 2) {
                turn(TURN_LEFT);turn(TURN_LEFT);turn(TURN_LEFT);turn(TURN_LEFT);
                for (int j=3; j<7; j++)
                  protokoll[j][zaehler]=2;

                if ((lookForward() & WALLMASK) == WALL || freierZugang(3)) {
                  turn(TURN_LEFT);
                  protokoll[7][zaehler]=2;

                }
                if ((lookForward() & WALLMASK) == WALL || freierZugang(4)) {
                  turn(TURN_LEFT);
                  protokoll[8][zaehler]=2;
                }
                break;

             }
             test=true; //wenn Drehungen erfolgen bis keine Wand ist, dann wird zaehler hochgezaehlt

          }
          if(test) {
            test=false;
            zaehler++;
          }
          //Notbremse, falls der Hamster nur im Kreis geht
          if(zaehler >= groesse) {
            finished=true;
            maul=true;
            return protokoll;
          }
          forward();
          protokoll[0][zaehler]=1;      // wenn forward, dann immer 1 in 1.Spalte
          zaehler++;                    //naechste Zeile

          //ist im Kreis gegangen
          if(atHome()) {
              turn(TURN_RIGHT);turn(TURN_RIGHT);turn(TURN_RIGHT);
              imKreisGegangen();
          }

        }
        //Sackgasse ist eingetreten
        if(verbose()) logln("Sackgasse");
        if(!atHome()) {
              take(CORNCARRY_MAX);
              protokoll[9][zaehler-1]=getAvailableCorn();
        }
        //lohnt es sich weiter zu suchen ??? ....
        if(ueberpruefeProtokoll()) {
          finished=true;
          if (verbose()) logln("Es gibt nichts mehr zu holen");
          break ab_da_weiter;
        }
        //.... wenn ja, dann geht es zum naechsten Abzweig
        turn(TURN_RIGHT);turn(TURN_RIGHT);turn(TURN_RIGHT);
        steps=rueckzug(); //Anzahl der Schritte fuer das zurueckgehen wird berechnet
        if (verbose()) logln(""+ steps);
        naechsterAbzweig(steps);
        if(protokoll[0][zaehler] == 1)
          zaehler--;
        if(protokoll[0][zaehler] == 2 || protokoll[0][zaehler] == 3)
          zaehler--;
        RestkarteLoeschen();      //Eintraege von Sackgasse bis neuem Abzweig werden "geloescht"
        int t=0;
        while(protokoll[t][zaehler] != 4 && t<5)
          t++;
        if(protokoll[0][zaehler] == 7)
          protokoll[0][zaehler] = 8;
        else  protokoll[t][zaehler]=8;
        //wenn Maul voll ist dann geht es vom Abzweig zum Heimatfeld und zurueck
        if (getCarriedCorn() == CORNCARRY_MAX) {
          turn(TURN_RIGHT); turn(TURN_RIGHT);turn(TURN_RIGHT);
          t=ausrichten();
          gehNachHause();
          KornAblegen();
          gehZumAbzweig(t);
        }
        //Codezeilen 215 - 236 dienen zum Ausrichten auf dem Abzweigfeld
        int e=4;
        for(int x=4; x >= 0; x--) {
          e=x;
          if(protokoll[x][zaehler] == 8)
            break;
        }
        if(e == 0) {
          turn(TURN_RIGHT);turn(TURN_RIGHT);turn(TURN_RIGHT);
        }
        if(e == 1) {
          turn(TURN_RIGHT);turn(TURN_RIGHT);
        }
        if(e == 2) {
          turn(TURN_RIGHT);
        }
        if(e == 3) {
          turn(TURN_LEFT);turn(TURN_LEFT);
        }
        if(e == 4) {
          turn(TURN_LEFT);
        }
        sackgasse = false;
        zaehler++;
        schritte=1;
        //Codezeilen 223 - 234 dienen dazu, das sich der Hamster "merkt" in wievielen
        //Richtungen er von seinem Hamsterfeld aus sich bewegt hat. Wenn 6 mal, dann
        //hat er alle durch => Ende des Laufes
        if(atHome()) {
          zaehler=0;
          anzahl++;
          schritte=0;
          turn(TURN_RIGHT);
          if(e>0) turn(TURN_RIGHT);
          while((lookForward() & WALLMASK) == WALL) {
            turn(TURN_RIGHT);
            anzahl++;
          }
          if(anzahl >= 6) {
            finished=true;
            break ab_da_weiter;
          }

        }

    }
    //wenn Maul voll ist wird die Methode verlassen
    if (verbose()) logln("Maul ist voll.");
    ausgabe();
    return protokoll;
}
//schreibt die bisherige Karte um, damit der Hamster wieder zurueck findet
//aus 3 wird 2 und umgekehrt
public int[][] ProtokollUmwandeln() {
  int[][] karte2 = new int[10][zaehler+1]; //neues Protokoll fuer Rueckweg
  for(int i=0; i<zaehler; i++) {
    for(int j=0; j<9; j++) {
      if (protokoll[j][i] == 3)   // aus Rechtsdrehungen (3) werden Linksdrehungen (2)
         karte2[j][i] = 2;
      if (protokoll[j][i] == 2)   // aus Linksdrehungen werden Rechtsdrehungen
         karte2[j][i] = 3;
      if (protokoll[j][i] == 1)
         karte2[j][i] = 1;
      if (protokoll[j][i] == 4 || protokoll[j][i] == 5  || protokoll[j][i] == 7 || protokoll[j][i] == 8)
         karte2[j][i] = 0;        // ueberschreiben der anderen Eintraege mit 0
    }
  }
  return karte2;
}
//nach CorncarrayMax oder "ueberpruefeProtokoll() = true ", geht der Hamster nach Hause
public void gehNachHause () {
  if (verbose()) logln("Gehe jetzt nach Hause");
  turn(TURN_RIGHT);turn(TURN_RIGHT);turn(TURN_RIGHT);
  int[][] protokoll_back= new int[10][zaehler];
  protokoll_back=ProtokollUmwandeln();
  while(!atHome()) {
    //Protokoll wird von hinten abgearbeitet
    for(int i=zaehler-1; i>=0; i--) {
      for(int j=0; j<9; j++) {
        if(protokoll_back[j][i] == 1) {
          forward();
          if(atHome()) return;
          break;
        }
        if(protokoll_back[j][i] == 2) {
          turn(TURN_LEFT);
        }
        if(protokoll_back[j][i] == 3) {
          turn(TURN_RIGHT);
        }

      }
    }
  }

}

//ueberprueft, ob noch Korn im Labyrinth liegt oder wo es noch unentdeckte Gaenge gibt
//wenn nicht, dann wird der Lauf des Hamster beendet
public boolean ueberpruefeProtokoll() {
  for (int i=0; i<zaehler; i++) {
    if(protokoll[0][i] == 1 || protokoll[0][i] == 2 || protokoll[0][i] == 3)
      continue; //Vortwaertsbewegungen und Drehungen werden ignoriert
    int x=0;
    if (protokoll[9][i] > 0)    //untersucht den Korneintrag auf noch liegengebliebenes Korn
        return false;
    for(int j=1; j<5; j++) {
      if (protokoll[j][i] == 4)
        x++;
    }
    if(x >= 2) {  //mindestens 1 unbetretenes Feld gibt es noch
      return false;
    }
    if(x == 1 && protokoll[0][i] == 7) {
      return false;
    }
  }
  return true;
}
//lagert das gesammelte Korn auf dem Heimatfeld ab
public void KornAblegen() {
  dropHere(CORNCARRY_MAX);
  if (verbose()) logln("Uff... Vorrat gesichert!!");
  turn(TURN_LEFT);turn(TURN_LEFT);turn(TURN_LEFT);
}

//fuehrt den Hamster an die Stelle zurueck, an der CornCarryMax erreicht wurde
public void gehZumKorn() {
  if (verbose()) logln("Gehe jetzt wieder an die Arbeit");
  int g=0;
  if(protokoll[0][1] == 2 || protokoll[0][1] == 3)
    g=2;
  // vom 1.Eintrag bis zur letzten Zeile
  for(int i=g; i < zaehler; i++) {
    for(int j=0; j <= 8; j++) {
      if(protokoll[j][i] == 1)
        forward();
      if(protokoll[j][i] == 2)
        turn(TURN_LEFT);
      if(protokoll[j][i] == 3)
        turn(TURN_RIGHT);
    }
  }
  schritte=0;
  if (verbose()) logln("Bin da");
}

//wird ausgefuehrt, wenn CornCarryMax des Hamsters nach einer Sackgasse erreicht ist und er
//zum naechsten Abzweig gegangen ist. Fuehrt den Hamster zu dieser Position zurueck,
//wenn er das Korn abgeliefert hat
public void gehZumAbzweig (int t) {
  int k=0;
  if(protokoll[0][1] == 2 || protokoll[0][1] == 3)
    k=2;
  for(int i=k; i < zaehler; i++) {
    for(int j=0; j <= 8; j++) {
      if(protokoll[j][i] == 1)
        forward();
      if(protokoll[j][i] == 2)
        turn(TURN_LEFT);
      if(protokoll[j][i] == 3)
        turn(TURN_RIGHT);
      }
  }
  //Hamster wird in die Richtung ausgerichtet, die er hatte als er von einer
  //Sackgasse zu dem neuem Abzweig kam
  if(t == 0) {
    turn(TURN_LEFT);turn(TURN_LEFT);turn(TURN_LEFT);
  }
  if(t == 1) { turn(TURN_LEFT);turn(TURN_LEFT); }
  if(t == 2) { turn(TURN_LEFT); }
  if(t == 3) { turn(TURN_RIGHT);turn(TURN_RIGHT); }
  if(t == 4) { turn(TURN_RIGHT); }

  if (verbose()) logln("Bin da");
}

//dient zum Ausrichten des Hamster, nachdem er auf einen Feld mit neuem Abzweig
//steht. Die Ausrichtung erfolgt so, da er in Richtung des Feldes steht,
//welches zum Heimatfeld fuehrt
public int ausrichten() {

  for(int x=4; x >= 0; x--) {
          u=x;
          if(protokoll[x][zaehler] == 8)
            break;
  }
  if(u == 0) {
    turn(TURN_RIGHT);turn(TURN_RIGHT);turn(TURN_RIGHT);
    t=0;
  }
  if(u == 1) {
    turn(TURN_RIGHT);turn(TURN_RIGHT);
    t=1;
  }
  if(u == 2) {
    turn(TURN_RIGHT);
    t=2;
  }
  if(u == 3) {
    turn(TURN_LEFT);turn(TURN_LEFT);
    t=3;
  }
  if(u == 4) {
    turn(TURN_LEFT);
    t=5;
  }
  turn(TURN_RIGHT);turn(TURN_RIGHT);turn(TURN_RIGHT);
  return t;
}

//berechnet die Anzahl der Schritte bis zum naechsten Abzweig
public int rueckzug() {
  int x=0;
  int steps=0;
  for(int i=zaehler; i > 0; i--) {
    x=0;
    if(protokoll[0][i] == 1 || protokoll[0][i] == 2 || protokoll[0][i] == 3) {
      continue;
    }
    for(int j=1; j<5; j++) {    //Vorkommen der 4 (unbekanntes Feld) wird gezaehlt
      if(protokoll[j][i] != 4)  //pro Spalte je Zeile
        x++;
    }
    // Abzweig gefunden ; min. 2 unbekannte Felder grenzen an das untersuchte Feld an
    if((protokoll[0][i] == 7 && x == 3) || (protokoll[0][i] == 7 && x == 2)
        ||(protokoll[0][i] == 7 && x == 1 )) return steps;
    if(x >= 3)    //kein Abzweig gefunden, da nur 1 freies Feld an dem
        steps++;  //untersuchtem Feld angrenzt
    else return steps;

  }
  return steps;
}
//ueberprueft, ob ein schon besuchter Gang im freierZugang ist (8) oder nicht (4 oder 7)
public boolean freierZugang(int w) {
  if(w == 0) {
    if(protokoll[0][zaehler-1] == 7)
      return false;
    if(protokoll[0][zaehler-1] == 8)
      return true;
  }
  if(w == 1) {
    if(protokoll[w][zaehler-1] == 8)
      return true;
  }
  if(w == 2) {
    if(protokoll[w][zaehler-1] == 8)
      return true;
  }
  if(w == 3) {
    if(protokoll[w][zaehler-1] == 8)
      return true;
  }
  if(w == 4) {
    if(protokoll[w][zaehler-1] == 8)
      return true;

  }
  if(w == 5) {
    if(protokoll[w][zaehler-1] == 8)
      return true;
  }
  return false;


}


//fuehrt den Hamster zum naechsten Abzweig, da wo er noch nicht war
public void naechsterAbzweig (int steps) {
  if (verbose()) logln("Gehe jetzt zum naechsten Abzweig");
  int[][] protokoll_back= new int[10][zaehler];
  protokoll_back=ProtokollUmwandeln();
  zaehler--;
  ausgabe();
  while(steps > 0) {  //der Hamster geht die errechnetetn Schritte zurueck
    for(int j=0; j<9; j++) {
      if(protokoll_back[j][zaehler] == 1) {
        forward();
        steps--;
        break;
      }
      if(protokoll_back[j][zaehler] == 2) { turn(TURN_LEFT);  }
      if(protokoll_back[j][zaehler] == 3) { turn(TURN_RIGHT); }
    }
    zaehler--;
  }
}
//wird ausgefuehrt, wenn naechster Abzweig erreicht wurde. Loescht den Teil der Karte,
//der vom letzten bis zum neuen Abzweig beschrieben wurde, um Fehler beim Ueberschreiben
//zu vermeiden z.b 1 3 2 2
public int[][] RestkarteLoeschen() {
  for(int i=zaehler+1; i < 200; i++) {
    for(int j=0; j<9; j++) {
      protokoll[j][i] = 0;
    }
  }
  return protokoll;
}

//bringt den Hamster zum letzten Abzweig, nachdem er auf das Heimatfeld
//zurckgekommen ist, bei der Untersuchung der Karte und ist dabei vermutlich
//im Kreis gegangen.
//Danach wird er wieder wie in den Codezeilen 216 - 236 ausgerichtet
//siehe Methodenbeschreibung von "ausrichten() .
public void imKreisGegangen() {
  steps=rueckzug();
  int t=0;
  int e=4;
  if (verbose()) logln(""+ steps);
  naechsterAbzweig(steps);  // zurueck bis zum naechsten Abzweig wie oben beschrieben
  if(protokoll[0][zaehler] == 2 || protokoll[0][zaehler] == 3)
    zaehler--;
  RestkarteLoeschen();  // karte aktuallisieren wie oben beschrieben
  //Ausrichtung in die Richtung, die der Hamster hatte, als er zum
  //1. mal auf dieses Feld kam, wie in Codezeile 202 - 236
  while(protokoll[t][zaehler] != 4 && t<5)
    t++;
  if(protokoll[0][zaehler] == 7)
    protokoll[0][zaehler] = 8;
  else  protokoll[t][zaehler]=8;

  for(int x=4; x >= 0; x--) {
    e=x;
    if(protokoll[x][zaehler] == 8)
      break;
  }
  if(e == 0) {
    turn(TURN_RIGHT);turn(TURN_RIGHT);turn(TURN_RIGHT);
  }
  if(e == 1) {
    turn(TURN_RIGHT);turn(TURN_RIGHT);
  }
  if(e == 2) {
    turn(TURN_RIGHT);
  }
  if(e == 3) {
    turn(TURN_LEFT);turn(TURN_LEFT);
  }
  if(e == 4) {
    turn(TURN_LEFT);
  }
  sackgasse = false;
  zaehler++;
  schritte=1;
}

// dient zur Ausgabe des Protokolls
public void ausgabe() {
  for(int k=0; k<zaehler; k++) {
      for(int z=0; z<9; z++) {
        if(protokoll[z][k] == 8) {
          if (verbose()) log(" 8");
        }
        if(protokoll[z][k] == 7) {
          if (verbose()) log(" 7");
        }
        if(protokoll[z][k] == 6) {
          if (verbose()) log(" 6");
        }
        if(protokoll[z][k] == 5) {
          if (verbose()) log(" 5");
        }
        if(protokoll[z][k] == 4) {
          if (verbose()) log(" 4");
        }
        if(protokoll[z][k] == 3) {    // fuer Rechtsdrehungen wird TR ausgegeben
          if (verbose()) log(" TR");
        }
        if(protokoll[z][k] == 2) {    // fuer Linksdrehungen wird TL ausgegeben
          if (verbose()) log(" TL" );
        }
        if(protokoll[z][k] == 1) {    // fuer Vorwrtsbewegungen wird f ausgegeben
          if (verbose()) log(" f");
        }
      }
      if (verbose()) log("    " +protokoll[9][k]);
      if(verbose()) logln("");
    }
}

//ChS
public boolean forward() {
  boolean res = super.forward();
  if (!res) {
    throw new RuntimeException("Kollision!");
  }
  return res;
}
//ChS

//Author des Hamsters
public String getHamsterAuthor() { return "Rocco Gasteiger"; }

// Datum der Hamsterversion.
public String getHamsterDate() { return "24.04.2002"; }

// Hamsterversion.
public String getHamsterVersion() { return "7.0"; }

}
