package spiderman;

import algds.c2002.Hamster;
import java.util.LinkedList;

public class Spiderman extends Hamster{
    
    public int view = 0;
    boolean finished = false, full = false;
    Point home = new Point(0,0),  Koord = home;
    Zelle Start = new Zelle(home), Cell = Start;
    LinkedList Weg = new LinkedList();
    Object[] Heimweg = {new Point(50,50)} ;
    
    public void run() {
        Cell.setUmfeld(lookAround(Cell));
        Weg.add(Cell);
        while (!finished){
            if (full) Cell = goHome(Cell);
            else Cell = erkunden(Cell);
            if (atHome()) dropAll();
        }
        dropAll();
    }
    
    public Zelle erkunden(Zelle aktuell){
        if (verbose()) logln("Spiderman geht auf Erkundung");
        
        Object Blick ;
        int counter= 0;
        Zelle temp;
        
        Blick=aktuell.getPoint(view);
        while (isBekannt(Blick,Weg)){
            if (!atHome())turnright();
            else turnleft();
            //turnright(); 
            counter++;
            if (counter>5 ) {
                if(atHome() && Weg.size() > 1){
                    finished=true; 
                    return aktuell;
                }
                aktuell = suchZelle(goBack(aktuell),Weg);
                return aktuell; 
            }
            Blick=aktuell.getPoint(view);
        }
        Koord = (Point)Blick;
        
        forward(); turnleft(); turnleft();
        takeAll();
        
        temp = new Zelle(Koord);
        temp.setUmfeld(lookAround(temp));
        Weg.add(temp);
        aktuell = temp;
        return aktuell;
    }
    
    public Point goBack(Zelle aktuell){
        LinkedList Weg2 = new LinkedList();
        
            Zelle temp, ersatz = aktuell;
            Object[] umfeld = aktuell.getUmfeld(),shweg;
            int b, c=1, ort = Weg.indexOf(aktuell);
            
            if (Weg.size()>2610) return goHome(aktuell).getPoint();
            Weg2.add(ersatz);
            while (c<=ort){
                temp= (Zelle) Weg.get(ort-c);
                b = ersatz.richtung(temp.getUmfeld());
                if (b != -1){
                    Weg2.add(temp);
                    ersatz=temp;
                    umfeld =temp.getUmfeld();
                    if (isUnBekannt(umfeld,Weg)) break;
                }
                c++;
            }
            shweg = shortTrek(Weg2);
            Koord = goTheWay(aktuell,shweg);
            //turnleft();turnleft();  //turnleft();
            return Koord;
    }
    
    public Zelle goHome(Zelle aktuell){
        if (verbose()) logln("Spiderman geht jetzt nach Hause");
       
        LinkedList Weg2 = new LinkedList();
        Zelle temp, ersatz, vergleich;
        int size, corn  = getAvailableCorn(), backup = view;
        
        int test = isDeadEnd(aktuell);
        while (test != -1 && corn <=1){
            Point P = (Point)aktuell.getUmfeld()[test];
            Weg.remove(aktuell);
            while (view != test)  turnright();
            forward();
            aktuell = suchZelle(P,Weg);
            test = (test+3) %6;
            aktuell.changeUmfeld(null,test);
            test = isDeadEnd(aktuell);
        }
        ersatz = aktuell; vergleich = ersatz;
        
        Object[] umfeld = aktuell.getUmfeld(), shweg = umfeld;
        if ( ! ((Point)Heimweg[0]).equals(aktuell.getPoint())){
            int b, c=1, ort = Weg.indexOf(ersatz);
            if( !isUnBekannt(umfeld,Weg) && corn <= 1 && Weg.size()<2610){
                Weg2.add(ersatz);
                while (!isUnBekannt(umfeld,Weg) && c<=ort){
                    temp= (Zelle) Weg.get(ort-c);
                    b = ersatz.richtung(temp.getUmfeld());
                    //if (b != -1){
                        Weg2.add(temp);
                        ersatz=temp;
                        umfeld =ersatz.getUmfeld();
                    //}
                    c++;
                }
            }
            else{
                Weg2.add(ersatz);
                while (!ersatz.equals(Start)){
                    temp= (Zelle) Weg.get(ort-c);
                    Weg2.add(temp);
                    ersatz=temp;
                    c++;
                }
            }
            Heimweg= shortTrek(Weg2);
        }
        aktuell = suchZelle(goTheWay(aktuell,Heimweg),Weg);
        if (!aktuell.equals(Start)){
            return goHome(aktuell);
        }
        else{
            dropAll();
            turnleft();turnleft();turnleft();
            if (Heimweg.length >100){ 
            	finished = true;
                return aktuell;
            }
            umfeld = vergleich.getUmfeld();
            
            if( corn >= 1 || isUnBekannt(umfeld,Weg)){
                size = Heimweg.length -1;
                Object[] reverse = new Object[size+1];
                for (int i=0; i<=size; i++)
                    reverse[i] = Heimweg[size-i];
                aktuell = suchZelle(goTheWay(aktuell, reverse),Weg);
                takeAll();
                while (view != backup) turnleft();
            }
        }
        return aktuell;
    }
    
    public Object[] shortTrek(LinkedList lngWeg){
        LinkedList shWeg = new LinkedList();
        Zelle temp1 = (Zelle)lngWeg.getFirst(),Z;
        Point   ziel = ((Zelle)lngWeg.getLast()).getPoint() ,P , T;
        Point T1 = temp1.getPoint(), Comp = T1;
        
        shWeg.add(temp1);
        while(! T1.equals(ziel)){
            Point [] suche = {null,null,null,null,null,null};
            int i=0;
            Object[] umfeld = temp1.getUmfeld();
            for (int u=0; u<=5; u++)
                if (umfeld[u]!= null){
                    T=(Point)umfeld[u];
                    if(inList(T,lngWeg) && !inList(T,shWeg) && !T.equals(Comp))
                        suche[i++]= T;
                    if (T.equals(ziel)){
                        shWeg.add((Zelle)lngWeg.getLast());
                        return shortestTrek(shWeg);
                    }
                }
            if (suche[0] == null){
                Comp = T1;
                shWeg.removeLast();
                if(!lngWeg.isEmpty()) clear(temp1,lngWeg);
                temp1 = (Zelle)shWeg.getLast();
                T1 = temp1.getPoint();
                continue;
            }
            i=0;
            P= suche[i++];
            while( suche[i] != null && (i+1)<=5)
                P=detect(P,suche[i++],ziel);
            temp1 = suchZelle(P,lngWeg);
            if (!shWeg.contains(temp1)) shWeg.add(temp1);
            T1 = P;
        }
        return shortestTrek(shWeg);
    }
    
    public Object[] shortestTrek(LinkedList shWeg){
        LinkedList Punkte = new LinkedList();
        Zelle start = (Zelle)shWeg.getFirst(), ziel = (Zelle)shWeg.getLast();
        Point P;
        Object[] umfeld = start.getUmfeld();
        int[] vergleich = new int[6];
        
        
        Punkte.add(start.getPoint());
        while(!start.equals(ziel)){
            int a=0;
        for (int i =0; i<=5;i++){
            P = (Point)umfeld[i];
            if ( P!= null )
                if( inList((Point)P,shWeg)&& !((Point)P).inList(Punkte))
                    vergleich[a++]= shWeg.indexOf(suchZelle((Point)P,shWeg));
        }
        a=0;
        int test = vergleich[a++];
        while (vergleich[a] != 0 && (a+1)<=5){
            if (test < vergleich[a]) test = vergleich[a];
            a++;
        }
        start = (Zelle)shWeg.get(test);
        umfeld=start.getUmfeld();
        Punkte.add(start.getPoint());
        }
        return Punkte.toArray();
    }
    
    /*public LinkedList searchUnknown(Zelle aktuell){
        LinkedList Search = new LinkedList();
        Zelle temp = aktuell;
        int pos = Weg.indexOf(aktuell), c=1, b, size = Weg.size();
        Object[] umfeld;
        
        Search.add(temp);
        for (int ind = 1;ind< size; ind++){
            umfeld =temp.getUmfeld();
            if(isUnBekannt(umfeld,Weg)) return Search;
            if (atHome()) temp = (Zelle)Weg.get(pos+ind);
            else temp = (Zelle)Weg.get(pos-ind);
            Search.add(temp);
        }
        return Search;
    }*/
    
    public Point goTheWay(Zelle z, Object[] weg){
        Object [] suche;
        int laenge =weg.length-1;
        Point last = (Point)weg[0];
        
        for (int i=1; i<=laenge; i++){
                suche = z.getUmfeld();
                last = (Point)weg[i];
                for (int ind = 0; ind<=5; ind++){
                    if (z.getPoint(view) != null)
                        if (((Point)z.getPoint(view)).equals(last)) {
                            forward();
                            if (!full) takeAll();
                            break;
                        }
                    turnright();
                }
                z = suchZelle(last,Weg);
            }
        return last;
    }
    
    public Point clear(Zelle aktuell, LinkedList l){
        int ort = l.indexOf(aktuell);
        Point P = aktuell.getPoint();
        l.remove(ort);
        return P;
    }
    
    public Point detect(Point P1,Point P2,Point ziel){
        int p1 = P1.Pythag(ziel); 
        int p2 =  P2.Pythag(ziel);
        if ( p1 != p2){
            if ( p1 < p2) return P1;
            else return P2;
        }
        else return P1.compare(P2);
        
    }
    
    public boolean isUnBekannt(Object [] arr,LinkedList l){
        for (int i=0; i<=5; i++)
            if (arr[i] != null)
                if (!inList( (Point)arr[i],l)) return true;
        return false;
    }
    
    public boolean isBekannt(Object o,LinkedList l){
        if (o == null) return true;
        if (inList( (Point)o,l)) return true;
        return false;
    }
    
    public int isDeadEnd(Zelle aktuell){
        Object[] umfeld = aktuell.getUmfeld();
        int c=0, temp = 0;
        for (int i =0; i<=2; i++){
            if (umfeld[i] != null){ c++; temp = i;}
            if (umfeld[3+i] != null){ c++; temp = 3+i;}
            if ( c>1 ) return -1;
        }
        return temp;
    }
    
    public boolean inList(Point p, LinkedList l){
        if (l.isEmpty()) return false;
        int laenge = l.size()-1;
        for (int i = 0; i<=laenge; i++)
            if (((Zelle)l.get(i)).containsP(p)) return true;
        return false;
    }
    
    public Zelle suchZelle(Point p, LinkedList l){
        int size = l.size()-1;
        Zelle test = Cell;
        for (int i = 0; i<=size; i++)
            if (((Zelle)l.get(i)).containsP(p)) {
                test = (Zelle)l.get(i);
                return test;
            }
        return test;
    }
    
    public Object [] lookAround(Zelle aktuell){
        Object [] look = new Object[6];
        
        for (int a = 0;a<=5;a++){
            look[view] = ((lookForward() & WALLMASK) != WALL) ?
                aktuell.nextZelle(view) : null;
            turnright();
        }
        return look; 
    }
    
    public void turnright(){
        turn(TURN_RIGHT);
        view++;
        if (view == 6) view = 0;
    }
    
    public void turnleft(){
        turn(TURN_LEFT);
        view--;
        if (view == -1) view = 5;
    }
    
    public void dropAll() {
	int dropped = dropHere(CORNCARRY_MAX);
	if (verbose()) log(dropped + " corn dropped.\n");
        full = false;
    }
    
    public void takeAll(){
        if (!atHome()) take(CORNCARRY_MAX);
                if (getCarriedCorn() == CORNCARRY_MAX) 
                    full = true;
    }
    
/** Autor(en) des Hamsters. */
    public String getHamsterAuthor() { return "Christian Zeitz"; }
/** Datum der Hamsterversion. */
    public String getHamsterDate() { return "20.04.2002"; }
/** Hamsterversion. */
    public String getHamsterVersion() { return "1.00.5"; }        
}