package spiderman;

public class Zelle {
    
    private Point Punkt;
    private Object [] Umfeld;
    
    /** Creates new Zelle */
    public Zelle() {}
    
    public Zelle(Point p) {
        Punkt = p;
        Umfeld = null;
    }
    
    public Zelle(Point p, Object[] umfeld) {
        Punkt = p;
        Umfeld = umfeld;
    }
    
    public Object [] getUmfeld(){
        return Umfeld;
    }
    
    public Point getPoint(){
        return Punkt;
    }
    
    public Point getPoint(int index){
        return (Point)Umfeld[index];
    }
    
    public void setPoint(Point newPoint){
        Punkt = newPoint;
    }
    
    public void setUmfeld(Object [] newUmfeld){
        Umfeld = newUmfeld;
    }
    
    public Object[] changeUmfeld(Object e, int pos){
        Umfeld[pos] = e;
        return Umfeld;
    }
    
    public Point nextZelle(int i){
        int x = getPoint().xkoord, y = getPoint().ykoord;
        
        switch (i) {
                case 0: x++; y++; break;
                case 1: x++; break;
                case 2: y--; break;
                case 3: x--; y--; break;
                case 4: x--; break;
                case 5: y++; break;
            }
        return new Point(x,y);
    }
    
    public boolean containsP(Point p){
        return getPoint().equals(p);        
    }
    
    /*public boolean containsP(Object [] arr){
        for (int a=0; a<=5;a++)
            if (arr[a] != null)
                if (getPoint().equals( (Point)arr[a])) return true;
        return false;
    }*/

    public boolean equals(Zelle z){
        return (getPoint().equals(z.getPoint()));
    }
    public int richtung(Object [] arr){
        for (int i=0; i<=2; i++){
            if (arr[i] != null)
                if (getPoint().equals( (Point)arr[i])) return i;
            if (arr[3+i] != null)
                if (getPoint().equals( (Point)arr[3+i])) return 3+i;
        }
        return -1;
    }
    
    public String toString(){
        String tmp ="";
        for (int i=0; i<=5;i++)
            tmp += Umfeld[i] + " ";
        return Punkt +"/ "+ tmp;
    } 
}