package warhamster40K;
import algds.c2002.*;
import java.awt.Point;
import java.util.*;
/**
Erweiterung einer Hashtable, um Hexfield Objekte zu speichern.
Koordinaten werden als schluessel verwendet.
*/
class HexfieldHash extends Hashtable{
    //**********************Constructors**********************
	/**Standardkonstruktor.*/
    public HexfieldHash(){
	super();
    }
    /**Standardkonstruktor.*/
    public HexfieldHash(int initialCapacity){
	super(initialCapacity);
    }
    /**Standardkonstruktor.*/
    public HexfieldHash(int initialCapacity,float loadFactor){
	super(initialCapacity,loadFactor);
    }
	/**Standardkonstruktor.*/
    public HexfieldHash(Map t){
	super(t);
    }
    //********************MemberFunctions*********************
	/**Standardselektor spezialisiert durch casting auf Hexfield und Point als argument.*/
    public Hexfield	get(Point Key){
	return (Hexfield)super.get(Key);
    }
    /**Ruft spezialisierten standardselektor {@link #get(Point Key)} auf.
	Argument wird aus x,y konstruiert.*/
    public Hexfield	get(int x, int y){
	return get(new Point(x,y));
    }
}