package warhamster40K;
import algds.c2002.*;
/**Stellt eigene Konstanten zur verfuegung.*/
public interface Hexfield_Constants
extends Constants{
    /**Byte repraesentation von NORDEN.*/
    public static final byte NORTH = 0;
    /**Byte repraesentation von NORDOSTEN.*/
    public static final byte NEAST = 1;
    /**Byte repraesentation von SUEDOSTEN.*/
    public static final byte SEAST = 2;
    /**Byte repraesentation von SUEDEN.*/
    public static final byte SOUTH = 3;
    /**Byte repraesentation von SUEDWESTEN.*/
    public static final byte SWEST = 4;
    /**Byte repraesentation von NORDWESTEN.*/
    public static final byte NWEST = 5;
    /**Spezialwert, der als ersatz fuer den wert von feldern benutzt wird, die hinter mauern und
    klippen liegen.*/
    public static final double WALLVALUE = 0d;
    /**Wert der feldern zugewiesen wird, auf denen kein korn liegt.*/
    public static final double NULLVALUE = 5d;
    /**Wert der feldern zugewiesen wird, von denen nur bekannt ist, dass auf ihnen korn liegt.*/
    public static final double CORNVALUE = 200d;
    /**Wert der feldern zugewiesen wird, die unbekannt (ungesehen) sind, aber existieren.*/
    public static final double UNKNOWNVALUE = 100;
    /**Unbenutzt. Wert der feldern zugewiesen wird, die als sehr schlecht gelten.*/
    public static final double BADFIELD  = 1/100;
    /**Konstanter wert des heimatfeldes.*/
    public static final double HOMEVALUE = 20;
    /**Wird fuer weglanegen benutzt, um die wege als unbrauchbar zu markieren.
    Eine solche weglaenge kann nicht erreicht werden.*/
    public static final int LONGWAY = 99999999;
}