package Eatmaster;
	import algds.c2002.Hamster;
	import java.util.Stack;
	public class eatmaster extends Hamster {
//Hilfsvariablen
	boolean finished = false;
	int schritte;
	int nochmal=0;
	int h=0;	//h steht fr Drehungen auf dem Heimatfeld
	int turns;
	Stack moves = new Stack();
//Hilfsmethode turnAround dreht den Hamster um 180 Grad
	public void turnAround(){
		turn(TURN_RIGHT);
		turn(TURN_RIGHT);
		turn(TURN_RIGHT);
	}
//Hauptmethoden
	public void run() {
		finished = false;
		while (!finished) {
			goShopping();			
		}
	}
//Methode goShopping lsst den Hamster rekursiv die Hauptachsen abgehen
	public void goShopping(){
		log("goShopping\n");
		turn(TURN_RIGHT);
		turn(TURN_RIGHT);
		
		//falls an dem Heimatfeld eine Wand angrenzt dreht er sich
		//einmal nach links und macht weiter 
		
		if ((lookForward() & WALLMASK) == WALL){
			turnAround();
			h++;
			while(h!=6){	
				goShopping();
			}
			return;
		}
		
		//falls nicht, geht die Hauptachse lang und sucht nach Abzweigungen
		
		walking();
		
		//wenn er auf eine Wand trifft, die ihn hindert auf der Hauptachse
		//weiterzugehen, bzw. die Auenkante des Labyrinthes erreicht, kehrt er um
		
		turnAround();
		goBack(nochmal,0);
		h++;
			
		//der Hamster dreht sich maximal 6 mal auf dem Heimatfeld entsprechend
		//den 6 mglichen Richtungen
			
		while(h!=6){
			goShopping();
		}
		finished=true;
	}
//Methode walking aus goShopping lsst den Hamster rekursiv alle Felder der
//Hauptachsen abgehen und prft in welche Richtungen er gehen kann
	public void walking(){
		log("walking\n");
		schritte=0;
		if ((lookForward() & WALLMASK) != WALL){
			forward();			//vordefinierte Methode forward
			turn(TURN_LEFT);	//vordefinierte Methode turn
			turns=0;
			schritte=0;
			findway();
			turns=0;
			schritte=0;
			findway();
			turn(TURN_RIGHT);
			turn(TURN_RIGHT);
			turns=0;
			schritte=0;
			findway();
			turns=0;
			schritte=0;
			findway();
			turn(TURN_LEFT);
			walking();
		}
		if (atHome()&&(lookForward() & WALLMASK) == WALL){
			return;
		}
		if (!atHome()&&(lookForward() & WALLMASK) == WALL){
			
			nochmal=0;
			turnAround();
			while (!atHome()){
				
				//der Hamster nimmt soviel Korn auf, wie er tragen kann
				
				take(CORNCARRY_MAX);
				
				//falls irgendwo mehr Krner rumliegen als der Hamster tragen
				//kann, wird nochmal auf 1 gesetzt damit er spter zurck geht
				//um sie zu holen
				
				if((getAvailableCorn()+getCarriedCorn())>CORNCARRY_MAX && !atHome()){
					nochmal=1;
				}
				forward();
			}
		}
	}
//Methode goBack aus goShopping lsst den Hamster zum Heimatfeld zurckgehen

	public void goBack(int nochmal,int schritte){
		log("goBack\n");
		turnAround();
		while(schritte>0){
			schritte--;
			forward();
		}
		if (atHome()){
			dropHere(getCarriedCorn());
			
		}
		
		//falls der Hamster nochmal zurckgehenn soll, wird gerade aufgerufen
		
		if (nochmal == 1){
			turnAround();
			gerade();
		}
	}
//Methode gerade aus goBack: der Hamster geht nochmal auf der Hauptachse entlang
//und sammelt weiter Korn
	public void gerade(){
		log("gerade\n");
		int schritte=0;
		while((lookForward() & WALLMASK) != WALL){
			forward();
			schritte++;
			take(CORNCARRY_MAX);
			if (getCarriedCorn()==CORNCARRY_MAX){
				goBack(nochmal,schritte);
				return;
			}
		}
		goBack(0,schritte);
		return;
		
	}
//Methode findway aus goShopping: der Hamster sucht sich einen Weg abseits der 
//Hauptachsen, falls er auf eine Wand trifft, dreht er sich nach links, wieder
//nach links, dreht sich um, dreht sich nach rechts, es sei denn er hat keine 
//Wand mehr vor sich, dann geht er in diese Richtung. Falls der Hamster in eine
//Sackgasse kommt, oder sich bereits 5 mal gedreht hat, geht er zurck 
//smtliche Bewegungen abseits der Haupachse werden in einem Stack gespeichert
	public void findway(){
		log("findway\n");
		nochmal=0;
		if (turns>=5){
			log("zu oft gedreht\n");
			goBack(0,moves);
			return;
		}
		if(((lookForward() & WALLMASK) == WALL)&&schritte==0){
			log("Wand\n");
			turnAround();
			return;
		}
		while((lookForward() & WALLMASK) != WALL){
			forward();
			schritte=1;
			log("schritte=1\n");
			moves.push("forward");
		}
		if (getCarriedCorn()==CORNCARRY_MAX){
			goBack(nochmal,moves);
			return;
		}
		if(((lookForward() & WALLMASK) == WALL&&schritte==1)){
			turn(TURN_LEFT);
			moves.push("right");
			if((lookForward() & WALLMASK) == WALL){
				turn(TURN_LEFT);
				moves.push("right");
				if((lookForward() & WALLMASK) == WALL){
					turnAround();
					moves.push("turnAround");
					if((lookForward() & WALLMASK) == WALL){
						turn(TURN_RIGHT);
						moves.push("left");
						if((lookForward() & WALLMASK) == WALL){
							log("Sackgasse\n");
							goBack(0,moves);
							return;
						}
						else 
							log("turn\n");
							turns++;
							findway(); 
							return;
					}
					else 
						log("turn\n");
						turns++;
						findway(); 
						return;
				}
				else 
					log("turn\n");
					turns++;
					findway(); 
					return;
			}
			else 
				log("turn\n");
				turns++;
				findway(); 
				return;
		}
	}
//Methode goBack aus findway: der Hamster dreht sich um, ruft die Bewegungen
//aus dem Stack auf, und fhrt diese umgekehrt aus, geht also zurck, und sammelt
//dabei Korn auf, falls mehr Korn vorhanden ist als er tragen kann, geht er mit
//findway nochmal zurck
	public void goBack(int nochmal,Stack moves){
		log("goBack\n");
		schritte=0;
		turns=0;
		turnAround();
		while(!moves.empty()){
			if((getAvailableCorn()+getCarriedCorn())>CORNCARRY_MAX){
				nochmal=1;
			}
			take(getAvailableCorn());
			if((String)moves.peek()=="forward"){
				forward();
				moves.pop();
			}
			if(moves.empty()){
				log("moves.empty\n");
				if ((getAvailableCorn() + getCarriedCorn()>CORNFIELD_MAX)){
					dropHere(CORNFIELD_MAX - getCarriedCorn());
					log("Dieses Feld ist voll !\n");
					nochmal = 0;
					return;
				}
				dropHere(CORNFIELD_MAX);
				if (nochmal == 1){
					turnAround();
					findway();
					return;
				}
				if (nochmal == 0){
				log("nicht nochmal\n");
					return;
				}
			}
			if((String)moves.peek()=="right"){
				turn(TURN_RIGHT);
				moves.pop();
				if(moves.empty()){
					return;
				}
			}
			if((String)moves.peek()=="left"){
				turn(TURN_LEFT);
				moves.pop();
				if(moves.empty()){
					return;
				}
			}
			if((String)moves.peek()=="turnAround"){
				turnAround();
				moves.pop();
				if(moves.empty()){
					return;
				}
			}
		}
	}
/** Autor(en) des Hamsters. */
	public String getHamsterAuthor() { return "Martin Lauenroth und Sebastian Blask"; }
	
/** Datum der Hamsterversion. */
	public String getHamsterDate() { return "25.02.2002"; }
	
/** Hamsterversion. */
	public String getHamsterVersion() { return "2.2"; }
	}