import algds.c2002.Hamster2;

public class Krtek extends Hamster2 {

  public void run() {
    for (int i=0;i<6;i++) { // alle sechs Richtungen checken, ggf. Todessprung
      if (((lookForward() & WALLMASK) != WALL)
      && ((lookForward() & WALLMASK) != CLIFFUP) && ((lookForward() & WALLMASK) != CLIFFDOWN)
      && ((lookForward() & CORNMASK) == CORN)) {
        todesSprung();
        dropHere(getCarriedCorn());
      }
      turn(TURN_LEFT);
    }
  }
  
  private void todesSprung() { // geht vorwrts, dreht sich und geht wieder zurck
    forward();                 // ach ja und sammelt dabei Korn bis Anschlach
    take(getAvailableCorn());
    for (int i=0;i<6;i++) {
      while (((lookForward() & WALLMASK) != WALL)
      && ((lookForward() & WALLMASK) != CLIFFUP) && ((lookForward() & WALLMASK) != CLIFFDOWN)
      && ((lookForward() & CORNMASK) == CORN) && (getCarriedCorn()<CORNCARRY_MAX)) {
        if (getCarriedCorn()<CORNCARRY_MAX) todesSprung();
      }
      turn(TURN_RIGHT);
    }
    for (int i=0;i<3;i++) turn(TURN_RIGHT);
    forward();
    for (int i=0;i<3;i++) turn(TURN_RIGHT);
  }

  public String getHamsterAuthor() { 
    return "Fachschaftsrat Elektrotechnik"; 
  }

  public String getHamsterDate() { 
    return "30.04.02"; 
  }

  public String getHamsterVersion() { 
    return "nu, padaschditje! (beta gold)";
  }
  
}
