package bommel;
import algds.c2002.Hamster2;
import	bommel.Const;

/**
 * Diese Klasse dient zur Orientierung im Array
 */
class Coordinate implements Const {
    int x;
    int y;
    /**
     * Defaultkonstruktor
     */
    protected Coordinate(){
        this.x = 0;
        this.y = 0;
    }
    /**
     * Konstruktor, setzt auf die Koordinaten
     */
    protected Coordinate(int x, int y){
        this.x = x;
        this.y = y;
    }
    /**
     * Vergleich zweier Coordinaten
     */
    public boolean equals(Coordinate c){
        return(this.x==c.x && this.y==c.y);
    }
    /**
     * Rckgabe der der einzelnen Positionen von 
     * x und y.
     */
    public int get_x(){
        return this.x;
    }
    public int get_y(){
        return this.y;
    }
    /**
     * setzt die Coordinate auf das Heimatfeld,
     * sollte in der Mitte sein
     */
    public void set_Home(){
        this.x = HOME_X;
        this.y = HOME_Y;
    }
    /**
     * setzt die Coordinate auf ein Feld(Zielfeld)
     */
    public void set_Field(int x, int y){
        this.x = x;
        this.y = y;
    }
    /**
     * verschiedene Richtungen, die im array 
     * gegangen werden
     */
    public void go_N(){
        this.y = this.y - 1;
    }
    public void go_NE(){
        this.x = this.x + 1;
    }
    public void go_SE(){
        this.x = this.x + 1;
        this.y = this.y + 1;
    }
    public void go_S(){
        this.y = this.y + 1;
    }
    public void go_SW(){
        this.x = this.x - 1;
    }
    public void go_NW(){
        this.x = this.x - 1;
        this.y = this.y - 1;
    }
    public void go(Direction dir, Map map, Coordinate c){
        switch (dir.get_Dir()){
            case 0:
                c.go_N();
                break;
            case 1:
                c.go_NE();
                break;
            case 2:
                c.go_SE();
                break;
            case 3:
                c.go_S();
                break;
            case 4:
                c.go_SW();
                break;
            case 5:
                c.go_NW();
                break;
        }// switch
    }// go
}// Coordinate