
package corncadger.search;

import corncadger.Path;
import corncadger.Map;

import java.util.Vector;

class InverseWayPathSet extends WayPathSet {

    private static Vector _wayCriterias = null;
    private Vector wayCriterias() {
	if (_wayCriterias == null) {
	    Vector v = new Vector();
	    v.addElement(Criteria.shorterPathCriteria);
	    v.addElement(Criteria.moreUnknownNeighborsCriteria);
	    v.addElement(Criteria.moreUnknownWallsCriteria);
	    _wayCriterias = v;
	}
	return _wayCriterias;
    }

    public Path bestPath(Map _m) {
	return null;
    }

    public PathSet newInstance() {
	return new InverseWayPathSet();
    }

    public boolean isWalkable() { return false; }

}
