package dighty;
import algds.c2002.Constants;
import java.util.Arrays;
/**
  Implementation des Basisfeldes
*/

public class CFeld {

  public int []m_iRahmen;             // speichert die Art der Grenze zum naechsten Feld
  public int m_iAnz_Koerner;          // speichert die Anzahl von Koerner
  public int m_iHoehe;                // die relative hoehe des Feldes
  public boolean m_bBekanntheitsgrad; // speichert, ob das Feld schon aktiv erkundschaftet wurde
  public char [][] m_piDistanceBuf;    // Puffer, der Entfernungen zwischen 2 Feldern Speichert, zwecks Verschnellerung der Wegfindrotiene
  /** Standartkonstruktor, erstellt ein Feld mit unbekannten Inhalt, Parameter giebt an, Ob ein Disctancebuggerspeicher alloziiert werden soll*/
  public CFeld(boolean bBuffering) {
    // belegen der Variablen mit Standartwerten
    m_iAnz_Koerner = CLabyrinth_ly0.c_iUnexploreCornData;
    m_bBekanntheitsgrad  = false;
    m_iRahmen = new int [CLabyrinth_ly0.c_iMovepossibilities];
    for (int i = 0 ; i < CLabyrinth_ly0.c_iMovepossibilities; i++) m_iRahmen[i] = CLabyrinth_ly0.c_iUnexploreCornData;
    m_iHoehe = CLabyrinth_ly0.c_iStartHoehe;
    // erstellen des entfernungsPuffers
//    if (bBuffering) m_piDistanceBuf = new char [CLabyrinth_ly0.c_iMaxSizeX][CLabyrinth_ly0.c_iMaxSizeY];
  }
  public char GetBufItem(int iX, int iY)
  {
    if (m_piDistanceBuf == null) {
      m_piDistanceBuf = new char [CLabyrinth_ly0.c_iMaxSizeX][CLabyrinth_ly0.c_iMaxSizeY];
      for (int x = 0; x < CLabyrinth_ly0.c_iMaxSizeX; x++) Arrays.fill(m_piDistanceBuf[x], (char)(0));
    }
    return m_piDistanceBuf[iX][iY];
  }
  public void SetBufItem(int iX, int iY, char iValue)
  {
    if (m_piDistanceBuf == null) {
      m_piDistanceBuf = new char [CLabyrinth_ly0.c_iMaxSizeX][CLabyrinth_ly0.c_iMaxSizeY];
      for (int x = 0; x < CLabyrinth_ly0.c_iMaxSizeX; x++) Arrays.fill(m_piDistanceBuf[x], (char)(0));
    }
    m_piDistanceBuf[iX][iY] = iValue;
  }
  /** leoscht den DistancePuffer */
  public void ClearDistanceBuffer()
  {
    m_piDistanceBuf = null;
  }
}
