
//Titel:        Dighty-Hamster
//Version:
//Copyright:    Copyright (c) 1999
//Autor:       Stoneyard
//Firma:
//Beschreibung:  Programmierwettbewerb 2002
package dighty;
import algds.c2002.Hamster2;
import algds.c2002.Constants;
/** eine Klasse, die die Bewegung Threadsicher macht, so kann die Klasse CHasmterTimeOutSaver sicher arbeiten
    der Booleanparameter erfuellt die Aufgabe, den Schutzthread und den Hamster unterscheiden zu koennen*/
public class CHamsterDoAStep {
  static int m_iOldDirection;
  static int m_iDirection;
  public synchronized static  boolean run(Hamster2 cHamster, CDightyData cD, boolean bReturn)
  {
    cD.m_bMoved = true;
    if (bReturn)
    {
      if (!cD.m_bMovedTimeOutSaver)  {
        // bewegen um ein Feld
        cD.m_bMovedTimeOutSaver = true;
        m_iOldDirection = cD.m_iDirection;
        // ermitteln einer moeglihen Marschrichtung
        for (m_iDirection = 0; m_iDirection < CLabyrinth_ly0.c_iMovepossibilities - 1; m_iDirection++)
          if (cD.m_cpFelder.canMove_known(cD.m_iPosX, cD.m_iPosY, m_iDirection) != -1)
            if (cD.m_cpFelder.canMove_known(cD.m_iPosX + CLabyrinth_ly0.c_iMoveX[m_iDirection] , cD.m_iPosY + CLabyrinth_ly0.c_iMoveY[m_iDirection], CLabyrinth_ly0.Reflect(m_iDirection))!= -1)
              break;
        CHamsterMoveTo.run(2, cHamster, cD, cD.m_iPosX + CLabyrinth_ly0.c_iMoveX[m_iDirection] , cD.m_iPosY + CLabyrinth_ly0.c_iMoveY[m_iDirection]);
      } else {
        RestorePos(cHamster, cD);
      }
    } else
    {
      if(!cHamster.forward()) return false;
      cD.Move();
    }
    return true;
  }
  public synchronized static void RestorePos(Hamster2 cHamster, CDightyData cD)
  {
    if (cD.m_bMovedTimeOutSaver)
    {
      CHamsterMoveTo.run(2, cHamster, cD, cD.m_iPosX + CLabyrinth_ly0.c_iMoveX[CLabyrinth_ly0.Reflect(m_iDirection)] , cD.m_iPosY + CLabyrinth_ly0.c_iMoveY[CLabyrinth_ly0.Reflect(m_iDirection)]);
      CHamsterLockTo.run(cHamster, cD, m_iOldDirection);
    }
    cD.m_bMovedTimeOutSaver = false;
  }
}
