package fitty;
import algds.c2002.Hamster;
import algds.c2002.Constants;
import java.util.*;


public class Fitty extends Hamster{

boolean erkundet=false;
boolean sammeln=false;

/**
*allgemeine Angaben zum Hamstervater und Version
*/
public String getHamsterAuthor(){return "Mathias Fiedler";}
public String getHamsterVersion(){return "1.1";}
public String setHamsterDate(){return "20.04.2002";}


Map map = new Map ();

/**als erstes wir eine Karte erzeugt.
*/

int akdir=1;
int akfeld=1;
int akring=0;

/**dem Hamster wird gesagt das er auf dem 
*Startfeld anfngt und i Richtung "1" schaut
*/

/**
*Hauptmethode
*/

public void run () { 

	map.startmap();

	while(!erkundet){

		check(akring,akfeld,akdir);
		
		nehmekorn(akfeld,akring);
			
		erkundet=erkundungsschritt(akring,akfeld,akdir);
		
		}


	while(!sammeln){
	
			
		map.resetentfernung();

		sammeln=kornfeldsuche(akfeld,akring,akdir);
		
		nehmekorn(akfeld,akring);
		
		if(getCarriedCorn()==CORNCARRY_MAX){
			map.resetentfernung();
			geheweg(gohome(akfeld,akring,akdir),akdir);
			}
		}


	if(akring!=0){
		map.resetentfernung();
		geheweg(gohome(akfeld,akring,akdir),akdir);
		}
}



public void nehmekorn(int akfeld, int akring){

/** Methode um von dem aktuellen Standort 
*so viel Korn wie mglich aufzuhemen 
*/

	if(getAvailableCorn()>0 && akring!=0){
		take(CORNCARRY_MAX);
		map.feldanderung(getAvailableCorn(),akfeld,akring);
		}
	
	map.feldanderung(getAvailableCorn(),akfeld,akring);
}


public void drehen ( int adir , int dir){

/**
Funktion um den Hamster zu drehen mit der eingabe 
*der aktuelle Richtung und der Wunschrichtung. Die 
*If-Abfrage dient nur kosmetischen Zwecken, sie 
*sorgt dafr das der Hamster sich effektiv dreht, 
*also nicht nur rechts rum.
*/

	if(dirr(adir,-1)==dir || dirr(adir,-2)==dir){
		while(adir!=dir){
			turn(TURN_LEFT);
			adir=dirr(adir,-1);
			}		
		}	
	else{	
		while(adir!=dir){		
			turn(TURN_RIGHT);
			adir=dirr(adir,+1);		
			}
		}
	akdir=dir;

}



public int dirr(int dir,int plus){

/**Berechnet die Richtung , 
*so zu sagen Modulo 7 ohne 0 
*/

	int erg;
	erg=dir+plus;
	if(erg>6) erg-=6;
	if(erg<1) erg+=6;
	return erg;
}


		
public void check (int akring, int akfeld , int akdir){

/** Methode zum erkunden der Umliegenden Felder
*der Hamster dreht sich einmal um sich selbst und
* kuckt dabie nach vorne und bergibt die so
* erlangten Informationen der Map
*/



	drehen(akdir,1);
	int dir=1;
	int adir=1;
	while(dir<=6){
		
		drehen(adir,dir);
		
		if(((lookForward() & CORNMASK) == CORN)){
		
			map.gesehenesfeld(1,Ber.feldnr(dir,akfeld,akring),Ber.ringnr(dir,akfeld,akring));
			
			map.unbekannt(false,Ber.feldnr(dir,akfeld,akring),Ber.ringnr(dir,akfeld,akring));	
			
			map.freir(dir,true,akfeld,akring);

				int x;
				if( dir<=3) x=dir+3;
				else x=dir-3;

				map.freir(x,true,Ber.feldnr(dir,akfeld,akring),Ber.ringnr(dir,akfeld,akring));		
			}
		else {	
			if(((lookForward() & WALLMASK) == WALL)) {
			
				map.gesehenesfeld(0,Ber.feldnr(dir,akfeld,akring),Ber.ringnr(dir,akfeld,akring));	
								
				map.freir(dir,false,akfeld,akring);
			
				int x;
				if( dir<=3) x=dir+3;
				else x=dir-3;

				map.freir(x,false,Ber.feldnr(dir,akfeld,akring),Ber.ringnr(dir,akfeld,akring));		
			
				}	
			
			else {
				map.gesehenesfeld(0,Ber.feldnr(dir,akfeld,akring),Ber.ringnr(dir,akfeld,akring));	
				map.freir(dir,true,akfeld,akring);

				int x;
				if( dir<=3) x=dir+3;
				else x=dir-3;

				map.freir(x,true,Ber.feldnr(dir,akfeld,akring),Ber.ringnr(dir,akfeld,akring));	
				map.unbekannt(false,Ber.feldnr(dir,akfeld,akring),Ber.ringnr(dir,akfeld,akring));	
				}
			}					
		
		adir=dir;
		dir++;	
	}
	

	drehen(dir-1,akdir);

	map.feldanderung(getAvailableCorn(),akfeld,akring);
	map.unbekannt(false,akfeld,akring);
	map.besucht(akfeld,akring);
}


public boolean erkundungsschritt (int akring, int akfeld, int dir){

/**Elementar Funktion des Hamsters um sich durch 
*unbekanntes Gelnde zu bewegen.
*/

	map.resetentfernung();
	map.felderrechnung();
	
	if(getCarriedCorn()==CORNCARRY_MAX){
		geheweg(gohome(akfeld,akring,akdir),dir);
		dropHere(Constants.CORNCARRY_MAX);
		return false;
		}
	
	if(map.gfreir(dir,akfeld,akring) && (!map.istbesucht(Ber.feldnr(dir,akfeld,akring),Ber.ringnr(dir,akfeld,akring)) || map.korn (Ber.feldnr(dir,akfeld,akring),Ber.ringnr(dir,akfeld,akring))>0 ) ){
		
		forward();
	
		int temp=akring;
		this.akring=Ber.ringnr(dir,akfeld,akring);
		this.akfeld=Ber.feldnr(dir,akfeld,akring);
		return false;

		}
	else{ 
		drehen(dir,dirr(dir,1));
		
	if(map.gfreir(dirr(dir,1),akfeld,akring) && 	(!map.istbesucht(Ber.feldnr(dirr(dir,1),akfeld,akring),Ber.ringnr(dirr(dir,1),akfeld,akring)) || map.korn (Ber.feldnr(dirr(dir,1),akfeld,akring),Ber.ringnr(dirr(dir,1),akfeld,akring))>0)  ){
			
		forward();
		int temp=akring;
		this.akring=Ber.ringnr(dirr(dir,1),akfeld,akring);
		this.akfeld=Ber.feldnr(dirr(dir,1),akfeld,akring);
		return false;

		}

		else{
			drehen(dirr(dir,1),dir);
			}		
		
		drehen(dir,dirr(dir,-1));
		if(map.gfreir(dirr(dir,-1),akfeld,akring) && (!map.istbesucht(Ber.feldnr(dirr(dir,-1),akfeld,akring),Ber.ringnr(dirr(dir,-1),akfeld,akring)) || map.korn (Ber.feldnr(dirr(dir,-1),akfeld,akring),Ber.ringnr(dirr(dir,-1),akfeld,akring))>0)  ){
			forward();
		
		
			

			int temp=akring;
			this.akring=Ber.ringnr(dirr(dir,-1),akfeld,akring);
			this.akfeld=Ber.feldnr(dirr(dir,-1),akfeld,temp);
			
			return false;
		}		
		else{drehen(dirr(dir,-1),dir);}	

		drehen(dir,dirr(dir,2));
		
		if(map.gfreir(dirr(dir,2),akfeld,akring) && (!map.istbesucht(Ber.feldnr(dirr(dir,2),akfeld,akring),Ber.ringnr(dirr(dir,2),akfeld,akring)) || map.korn (Ber.feldnr(dirr(dir,2),akfeld,akring),Ber.ringnr(dirr(dir,2),akfeld,akring))>0 ) ){
			forward();
		
			
			int temp=akring;
			this.akring=Ber.ringnr(dirr(dir,2),akfeld,akring);
			this.akfeld=Ber.feldnr(dirr(dir,2),akfeld,akring);
			
			return false;
		}		
		else{drehen(dirr(dir,2),dir);}		

		drehen(dir,dirr(dir,-2));
		
	
		
		if(map.gfreir(dirr(dir,-2),akfeld,akring) && (!map.istbesucht(Ber.feldnr(dirr(dir,-2),akfeld,akring),Ber.ringnr(dirr(dir,-2),akfeld,akring)) || map.korn (Ber.feldnr(dirr(dir,-2),akfeld,akring),Ber.ringnr(dirr(dir,-2),akfeld,akring))>0 ) ){
			forward();
			
		
		

			int temp=akring;			
			this.akring=Ber.ringnr(dirr(dir,-2),akfeld,akring);
			this.akfeld=Ber.feldnr(dirr(dir,-2),akfeld,akring);

					
			return false;

		}		
		else{drehen(dirr(dir,-2),dir);
	
	


	
	if(map.felderrechnung()){

	ArrayList temp =freifeldsuche(akfeld,akring);
	if(akring==0 && obj2int(temp.get(2))>100){
		return true;
	}
	geheweg(temp,dir);
	}

	else{
	return true;}

	
	
		}
		
		
	
return false;
	}
	
}

public void geheweg(ArrayList wegi,int akdir){


/** Wie der Name schon sagt: eine Methode die einen Angegeben Weg abluft
Der Weg wird dabei als ArrayList bergeben bei der die Positionen 0,1,2 Reservierrt sind 
und der Weg ab Platz drei in Formn von Zahlen liegt (1,2,3,4,5,6).
*/

	if(wegi==null) return;


		
	
	
	nehmekorn(akfeld,akring);
	
		while(wegi.size()>3){
	
		int dir=obj2int(wegi.get(3));
		drehen(akdir,dir);	
	
		akdir=dir;
		int takfeld=Ber.feldnr(dir,akfeld,akring);
		int takring=Ber.ringnr(dir,akfeld,akring);



		akfeld=takfeld;
		akring=takring;


		wegi.remove(3);
		forward();

		}
	
	if(akring==0){dropHere(Constants.CORNCARRY_MAX);

}

}



public ArrayList freifeldsuche(int akfeld, int akring){

/**Diese Methode gibt den Weg zum nchsten freien Feld von der aktuellen Position als ArrayList zurck
*/

		int [] ber = new int [4];

		int [] berak = new int[4];


	ArrayList weg = new ArrayList();
	
	ArrayList berlist = new ArrayList();

	boolean gefunden=false;

	berlist.add(0,int2obj(akfeld));
	berlist.add(1,int2obj(akring));
	berlist.add(2,"1");

 	map.entfernung (akfeld,akring,0);

	while(!gefunden){

	berak[0]=obj2int(berlist.get(0));
	berak[1]=obj2int(berlist.get(1));

	ber[0]=Ber.feldnr(1,obj2int(berlist.get(0)),obj2int(berlist.get(1)));
	ber[1]=Ber.ringnr(1,obj2int(berlist.get(0)),obj2int(berlist.get(1)));
	ber[2]=obj2int(berlist.get(2));
	
		if (map.gfreir(1,berak[0],berak[1]) && map.wentfernung(ber[0],ber[1])>ber[2] ){ 
	
			map.entfernung (ber[0],ber[1],ber[2]);
	
			ArrayList temp = new ArrayList();	
			temp.addAll(berlist);
			temp.set(0,int2obj(ber[0]));
			temp.set(1,int2obj(ber[1]));
			temp.set(2,int2obj(ber[2]));
			temp.add("1");
			weg.add(temp);
	
			if((!map.istunbekannt(ber[0],ber[1]) && 											!map.istbesucht(ber[0],ber[1]))||map.korn(ber[0],ber[1])>0 && ber[1]!=0){	
		
				gefunden=true;
				continue;		
				}
		}




	ber[0]=Ber.feldnr(2,obj2int(berlist.get(0)),obj2int(berlist.get(1)));
	ber[1]=Ber.ringnr(2,obj2int(berlist.get(0)),obj2int(berlist.get(1)));
	ber[2]=obj2int(berlist.get(2));

		if (map.gfreir(2,berak[0],berak[1]) &&map.wentfernung(ber[0],ber[1])>ber[2]){ 

			map.entfernung (ber[0],ber[1],ber[2]);
	
			ArrayList temp = new ArrayList();	
			temp.addAll(berlist);
			temp.set(0,int2obj(ber[0]));
			temp.set(1,int2obj(ber[1]));
			temp.set(2,int2obj(ber[2]));
			temp.add("2");
			weg.add(temp);

			if((!map.istunbekannt(ber[0],ber[1]) &&
			!map.istbesucht(ber[0],ber[1]))||map.korn(ber[0],ber[1])>0 && ber[1]!=0){
		
				gefunden=true;
				continue;		
			}
		}

	
	ber[0]=Ber.feldnr(3,obj2int(berlist.get(0)),obj2int(berlist.get(1)));
	ber[1]=Ber.ringnr(3,obj2int(berlist.get(0)),obj2int(berlist.get(1)));
	ber[2]=obj2int(berlist.get(2));

	if (map.gfreir(3,berak[0],berak[1]) &&map.wentfernung(ber[0],ber[1])>ber[2] ){ 

		map.entfernung (ber[0],ber[1],ber[2]);
	
		ArrayList temp = new ArrayList();	
		temp.addAll(berlist);
		temp.set(0,int2obj(ber[0]));
		temp.set(1,int2obj(ber[1]));
		temp.set(2,int2obj(ber[2]));
		temp.add("3");
		weg.add(temp);
	
		if((!map.istunbekannt(ber[0],ber[1]) && 
		!map.istbesucht(ber[0],ber[1]))||map.korn(ber[0],ber[1])>0 && ber[1]!=0){

			gefunden=true;
			continue;		
		}
	}


	ber[0]=Ber.feldnr(4,obj2int(berlist.get(0)),obj2int(berlist.get(1)));
	ber[1]=Ber.ringnr(4,obj2int(berlist.get(0)),obj2int(berlist.get(1)));
	ber[2]=obj2int(berlist.get(2));

	if (map.gfreir(4,berak[0],berak[1]) &&map.wentfernung(ber[0],ber[1])>ber[2] ){ 
		
		map.entfernung (ber[0],ber[1],ber[2]);
	
		ArrayList temp = new ArrayList();	
		temp.addAll(berlist);
		temp.set(0,int2obj(ber[0]));
		temp.set(1,int2obj(ber[1]));
		temp.set(2,int2obj(ber[2]));
		temp.add("4");
		weg.add(temp);

		if((!map.istunbekannt(ber[0],ber[1]) && 
		!map.istbesucht(ber[0],ber[1]))||map.korn(ber[0],ber[1])>0 && ber[1]!=0){
		
			gefunden=true;
			continue;		
		}
	}


	ber[0]=Ber.feldnr(5,obj2int(berlist.get(0)),obj2int(berlist.get(1)));
	ber[1]=Ber.ringnr(5,obj2int(berlist.get(0)),obj2int(berlist.get(1)));
	ber[2]=obj2int(berlist.get(2));

	if (map.gfreir(5,berak[0],berak[1]) &&map.wentfernung(ber[0],ber[1])>ber[2] ){ 
	
		map.entfernung (ber[0],ber[1],ber[2]);
	
		ArrayList temp = new ArrayList();	
		temp.addAll(berlist);
		temp.set(0,int2obj(ber[0]));
		temp.set(1,int2obj(ber[1]));
		temp.set(2,int2obj(ber[2]));
		temp.add("5");
		weg.add(temp);

		if((!map.istunbekannt(ber[0],ber[1]) &&
		!map.istbesucht(ber[0],ber[1]))||map.korn(ber[0],ber[1])>0 && ber[1]!=0){
		
			gefunden=true;
			continue;		
		}
	}


	ber[0]=Ber.feldnr(6,obj2int(berlist.get(0)),obj2int(berlist.get(1)));
	ber[1]=Ber.ringnr(6,obj2int(berlist.get(0)),obj2int(berlist.get(1)));
	ber[2]=obj2int(berlist.get(2));

	if (map.gfreir(6,berak[0],berak[1]) &&map.wentfernung(ber[0],ber[1])>ber[2] ){ 
	
		map.entfernung (ber[0],ber[1],ber[2]);
	
		ArrayList temp = new ArrayList();	
		temp.addAll(berlist);
		temp.set(0,int2obj(ber[0]));
		temp.set(1,int2obj(ber[1]));
		temp.set(2,int2obj(ber[2]));
		temp.add("6");
		weg.add(temp);

		if((!map.istunbekannt(ber[0],ber[1]) &&
		!map.istbesucht(ber[0],ber[1]))||map.korn(ber[0],ber[1])>0 && ber[1]!=0){
		
			gefunden=true;
			continue;		
		}
	}


	
	berlist.clear();
	berlist=(ArrayList)weg.get(0);

	weg.remove(0);

	int temp = obj2int(berlist.get(2));
	temp++;

	berlist.set(2,int2obj(temp));

	}


	return berlist;

}


public ArrayList gohome(int akfeld,int akring,int akdir){

/**sucht den krzesten Weg zum Heimatfeld und gibt den Weg wie beider Freifelsuche als 
ArryList zurck*/

	int [] ber = new int [4];

	int [] berak = new int[4];

	ArrayList weg = new ArrayList();

	ArrayList berlist = new ArrayList();

	boolean gefunden=false;

	berlist.add(0,int2obj(akfeld));
	berlist.add(1,int2obj(akring));
	berlist.add(2,"1");

	if(akring==0){
		return null;
	}	

	map.entfernung (akfeld,akring,0);

	while(!gefunden){


	berak[0]=obj2int(berlist.get(0));
	berak[1]=obj2int(berlist.get(1));

	ber[0]=Ber.feldnr(1,obj2int(berlist.get(0)),obj2int(berlist.get(1)));
	ber[1]=Ber.ringnr(1,obj2int(berlist.get(0)),obj2int(berlist.get(1)));
	ber[2]=obj2int(berlist.get(2));

	if (map.gfreir(1,berak[0],berak[1]) && map.wentfernung(ber[0],ber[1])>ber[2] ){ 

		map.entfernung (ber[0],ber[1],ber[2]);
	
		ArrayList temp = new ArrayList();	
		temp.addAll(berlist);
		temp.set(0,int2obj(ber[0]));
		temp.set(1,int2obj(ber[1]));
		temp.set(2,int2obj(ber[2]));
		temp.add("1");
		weg.add(temp);

		if(ber[0]==1 && ber[1]==0){	
	
			gefunden=true;
			return temp;
		}

	}


	ber[0]=Ber.feldnr(2,obj2int(berlist.get(0)),obj2int(berlist.get(1)));
	ber[1]=Ber.ringnr(2,obj2int(berlist.get(0)),obj2int(berlist.get(1)));
	ber[2]=obj2int(berlist.get(2));

	if (map.gfreir(2,berak[0],berak[1]) &&map.wentfernung(ber[0],ber[1])>ber[2] ){ 

		map.entfernung (ber[0],ber[1],ber[2]);
	
		ArrayList temp = new ArrayList();	
		temp.addAll(berlist);
		temp.set(0,int2obj(ber[0]));
		temp.set(1,int2obj(ber[1]));
		temp.set(2,int2obj(ber[2]));
		temp.add("2");
		weg.add(temp);

		if(ber[0]==1 && ber[1]==0){
			gefunden=true;
	        	return temp;
		}

	}


	ber[0]=Ber.feldnr(3,obj2int(berlist.get(0)),obj2int(berlist.get(1)));
	ber[1]=Ber.ringnr(3,obj2int(berlist.get(0)),obj2int(berlist.get(1)));
	ber[2]=obj2int(berlist.get(2));

	if (map.gfreir(3,berak[0],berak[1]) &&map.wentfernung(ber[0],ber[1])>ber[2] ){ 

		map.entfernung (ber[0],ber[1],ber[2]);
	
		ArrayList temp = new ArrayList();	
		temp.addAll(berlist);
		temp.set(0,int2obj(ber[0]));
		temp.set(1,int2obj(ber[1]));
		temp.set(2,int2obj(ber[2]));
		temp.add("3");
		weg.add(temp);
	
		if(ber[0]==1 && ber[1]==0){	

			gefunden=true;
        		return temp;
		}

	}


	ber[0]=Ber.feldnr(4,obj2int(berlist.get(0)),obj2int(berlist.get(1)));
	ber[1]=Ber.ringnr(4,obj2int(berlist.get(0)),obj2int(berlist.get(1)));
	ber[2]=obj2int(berlist.get(2));

	if (map.gfreir(4,berak[0],berak[1]) &&map.wentfernung(ber[0],ber[1])>ber[2] ){ 
	
		map.entfernung (ber[0],ber[1],ber[2]);
	
		ArrayList temp = new ArrayList();	
		temp.addAll(berlist);
		temp.set(0,int2obj(ber[0]));
		temp.set(1,int2obj(ber[1]));
		temp.set(2,int2obj(ber[2]));
		temp.add("4");
		weg.add(temp);
		
		if(ber[0]==1 && ber[1]==0){

			gefunden=true;
			return temp;
		}

	}



	ber[0]=Ber.feldnr(5,obj2int(berlist.get(0)),obj2int(berlist.get(1)));
	ber[1]=Ber.ringnr(5,obj2int(berlist.get(0)),obj2int(berlist.get(1)));
	ber[2]=obj2int(berlist.get(2));

	if (map.gfreir(5,berak[0],berak[1]) &&map.wentfernung(ber[0],ber[1])>ber[2] ){ 
	
		map.entfernung (ber[0],ber[1],ber[2]);
	
		ArrayList temp = new ArrayList();	
		temp.addAll(berlist);
		temp.set(0,int2obj(ber[0]));
		temp.set(1,int2obj(ber[1]));
		temp.set(2,int2obj(ber[2]));
		temp.add("5");
		weg.add(temp);

		if(ber[0]==1 && ber[1]==0){	
			gefunden=true;
			return temp;
		}

	}


	ber[0]=Ber.feldnr(6,obj2int(berlist.get(0)),obj2int(berlist.get(1)));
	ber[1]=Ber.ringnr(6,obj2int(berlist.get(0)),obj2int(berlist.get(1)));
	ber[2]=obj2int(berlist.get(2));

	if (map.gfreir(6,berak[0],berak[1]) && map.wentfernung(ber[0],ber[1])>ber[2] ){ 
	
		map.entfernung (ber[0],ber[1],ber[2]);
	
		ArrayList temp = new ArrayList();	
		temp.addAll(berlist);
		temp.set(0,int2obj(ber[0]));
		temp.set(1,int2obj(ber[1]));
		temp.set(2,int2obj(ber[2]));
		temp.add("6");
		weg.add(temp);

		if(ber[0]==1 && ber[1]==0){	
			gefunden=true;
			return temp;
		}

	}


berlist.clear();


berlist=(ArrayList)weg.get(0);

weg.remove(0);

int temp = obj2int(berlist.get(2));
temp++;

berlist.set(2,int2obj(temp));

}

return null;

}


public boolean kornfeldsuche (int akfeld,int akring,int akdir){

/** Dient zum Schlu, wenn alles vollstndig erkundet ist, dazu die letzten Felder 
auf denen Korn liegt zu finden und gleich dort hin zu gehen. 
Hat von Rckgabewert gleich wichtige Stellung wie Erkundungschritt
*/

	int [] ber = new int [4];

	int [] berak = new int[4];
	
	ArrayList weg = new ArrayList();
	ArrayList berlist = new ArrayList();

	boolean gefunden=false;

	berlist.add(0,int2obj(akfeld));
	berlist.add(1,int2obj(akring));
	berlist.add(2,"1");

	map.entfernung (akfeld,akring,0);

	while(!gefunden){

	berak[0]=obj2int(berlist.get(0));
	berak[1]=obj2int(berlist.get(1));

	ber[0]=Ber.feldnr(1,obj2int(berlist.get(0)),obj2int(berlist.get(1)));
	ber[1]=Ber.ringnr(1,obj2int(berlist.get(0)),obj2int(berlist.get(1)));
	ber[2]=obj2int(berlist.get(2));
	
	if (map.gfreir(1,berak[0],berak[1]) && map.wentfernung(ber[0],ber[1])>ber[2] ){ 
	
		map.entfernung (ber[0],ber[1],ber[2]);
	
		ArrayList temp = new ArrayList();	
		temp.addAll(berlist);
		temp.set(0,int2obj(ber[0]));
		temp.set(1,int2obj(ber[1]));
		temp.set(2,int2obj(ber[2]));
		temp.add("1");
		weg.add(temp);
	

		if(akring==0 && obj2int(temp.get(2))>100){
			return true;
		}
		

		if(map.korn(ber[0],ber[1])>=1){	
		
			geheweg(temp,akdir);
			return false;
		
		}
	}


	ber[0]=Ber.feldnr(2,obj2int(berlist.get(0)),obj2int(berlist.get(1)));
	ber[1]=Ber.ringnr(2,obj2int(berlist.get(0)),obj2int(berlist.get(1)));
	ber[2]=obj2int(berlist.get(2));

	if (map.gfreir(2,berak[0],berak[1]) &&map.wentfernung(ber[0],ber[1])>ber[2]){ 

		map.entfernung (ber[0],ber[1],ber[2]);
	
		ArrayList temp = new ArrayList();	
		temp.addAll(berlist);
		temp.set(0,int2obj(ber[0]));
		temp.set(1,int2obj(ber[1]));
		temp.set(2,int2obj(ber[2]));
		temp.add("2");
		weg.add(temp);

		if(akring==0 && obj2int(temp.get(2))>100){
			return true;
		}


		if(map.korn(ber[0],ber[1])>=1){	
	
			geheweg(temp,akdir);
			return false;	
		}
	}


	ber[0]=Ber.feldnr(3,obj2int(berlist.get(0)),obj2int(berlist.get(1)));
	ber[1]=Ber.ringnr(3,obj2int(berlist.get(0)),obj2int(berlist.get(1)));
	ber[2]=obj2int(berlist.get(2));

	if (map.gfreir(3,berak[0],berak[1]) &&map.wentfernung(ber[0],ber[1])>ber[2] ){ 

		map.entfernung (ber[0],ber[1],ber[2]);
	
		ArrayList temp = new ArrayList();	
		temp.addAll(berlist);
		temp.set(0,int2obj(ber[0]));
		temp.set(1,int2obj(ber[1]));
		temp.set(2,int2obj(ber[2]));
		temp.add("3");
		weg.add(temp);

		if(akring==0 && obj2int(temp.get(2))>100){
			return true;
		}	

		if(map.korn(ber[0],ber[1])>=1){	
		
			geheweg(temp,akdir);
			return false;	
		}
	}


	ber[0]=Ber.feldnr(4,obj2int(berlist.get(0)),obj2int(berlist.get(1)));
	ber[1]=Ber.ringnr(4,obj2int(berlist.get(0)),obj2int(berlist.get(1)));
	ber[2]=obj2int(berlist.get(2));

	if (map.gfreir(4,berak[0],berak[1]) &&map.wentfernung(ber[0],ber[1])>ber[2] ){ 

		map.entfernung (ber[0],ber[1],ber[2]);
	
		ArrayList temp = new ArrayList();	
		temp.addAll(berlist);
		temp.set(0,int2obj(ber[0]));
		temp.set(1,int2obj(ber[1]));
		temp.set(2,int2obj(ber[2]));
		temp.add("4");
		weg.add(temp);

		if(akring==0 && obj2int(temp.get(2))>100){
			return true;
		}


		if(map.korn(ber[0],ber[1])>=1){	
	
			geheweg(temp,akdir);
			return false;
		}
	}


	ber[0]=Ber.feldnr(5,obj2int(berlist.get(0)),obj2int(berlist.get(1)));
	ber[1]=Ber.ringnr(5,obj2int(berlist.get(0)),obj2int(berlist.get(1)));
	ber[2]=obj2int(berlist.get(2));

	if (map.gfreir(5,berak[0],berak[1]) &&map.wentfernung(ber[0],ber[1])>ber[2] ){ 
	
		map.entfernung (ber[0],ber[1],ber[2]);
	
		ArrayList temp = new ArrayList();	
		temp.addAll(berlist);
		temp.set(0,int2obj(ber[0]));
		temp.set(1,int2obj(ber[1]));
		temp.set(2,int2obj(ber[2]));
		temp.add("5");
		weg.add(temp);

		if(akring==0 && obj2int(temp.get(2))>100){
			return true;
		}


		if(map.korn(ber[0],ber[1])>=1){		
	
			geheweg(temp,akdir);
			return false;
		}
	}


	ber[0]=Ber.feldnr(6,obj2int(berlist.get(0)),obj2int(berlist.get(1)));
	ber[1]=Ber.ringnr(6,obj2int(berlist.get(0)),obj2int(berlist.get(1)));
	ber[2]=obj2int(berlist.get(2));

	if (map.gfreir(6,berak[0],berak[1]) &&map.wentfernung(ber[0],ber[1])>ber[2] ){ 
	
		map.entfernung (ber[0],ber[1],ber[2]);
	
		ArrayList temp = new ArrayList();	
		temp.addAll(berlist);
		temp.set(0,int2obj(ber[0]));
		temp.set(1,int2obj(ber[1]));
		temp.set(2,int2obj(ber[2]));
		temp.add("6");
		weg.add(temp);
		
		if(akring==0 && obj2int(temp.get(2))>100){
			return true;
		}


		if(map.korn(ber[0],ber[1])>=1){	
	
			geheweg(temp,akdir);
			return false;	
		}
	}

	
	if(weg.size()==0){
	
		return true;
	}

	berlist.clear();
	berlist=(ArrayList)weg.get(0);

	weg.remove(0);

	int temp = obj2int(berlist.get(2));
	temp++;
	berlist.set(2,int2obj(temp));

}

	return true;

}


/**Diese Beiden Methoden dienen mir zum casten um die Zahlen 
fr den Weg als Objecte in die ArrayList zu bekommen
(nicht sehr elegant)*/

public int obj2int(Object obj){
	return Integer.parseInt(String.valueOf(obj));

}
public Object int2obj(int in){
	return ""+in;
}



}