package fitty;
/**
Die Map meines Hamsters
Die Karte wird hierzu in Kreise die um den Sartpunkt verlaufen aufgeteilt. 
Die Felder in einem Kreis realisiere ich mit einem Arry die Kreise selbst mit einer ArryList
Zustzlich sind in dieser Klasse alle Methoedn fr den Zugriff auf Feldeigenschaften und
die Methode felderrechnung, die den Hamster effizienter macht.
*/

import java.util.*;
import algds.c2002.Constants;
import algds.c2002.Hamster;

public class Map  {

	int ringanzahl = 0;

	ArrayList karte = new ArrayList();
	Felder start = new Felder();

Felder [] akfeld;

/**
Konstruktor der Map 
*/

public void Map () { 
	
}


public void startmap(){

	Felder [] akfeld = new Felder[2];
	akfeld[0] = new Felder();
	akfeld[1] = new Felder();
	karte.add(akfeld); 
		

	unbekannt(false,1,0);
	besucht(1,0);
}



public int kartenindex(){

	return karte.size();
}









public void gesehenesfeld(int korn ,int feldnr, int ringnr){

	
	if (ringanzahl < ringnr) {
		
		int x = ringnr*6;  // Wieviele Felder hat der Aktuelle Ring? 
	
		Felder [] akfeld = new Felder [x+1];

		int y=0;
		while(y<x+1){
			akfeld[y] = new Felder();
			y++;
		}
		
		karte.add(akfeld) ;
		ringanzahl ++;		

	}
	

	
	if(korn(feldnr,ringnr)==0){

	feldanderung(korn,feldnr,ringnr);}


}

public void feldanderung (int korn ,int feldnr, int ringnr){
	
	akfeld = (Felder[])karte.get(ringnr);
	akfeld[feldnr].korn=korn; 

}

public int korn (int feldnr, int ringnr){
	
	akfeld = (Felder[])karte.get(ringnr);
	return akfeld[feldnr].korn;
}

public void unbekannt (boolean ja,int feldnr, int ringnr){
	
	akfeld = (Felder[])karte.get(ringnr);
	akfeld[feldnr].unbekannt=ja;
}

public boolean istunbekannt(int feldnr, int ringnr){

	if(ringnr>=kartenindex()) return true; 
	akfeld = (Felder[])karte.get(ringnr);
	return akfeld[feldnr].unbekannt;
}

public void besucht (int feldnr, int ringnr){

	akfeld = (Felder[])karte.get(ringnr);
	akfeld[feldnr].besucht=true;	
}

public boolean istbesucht (int feldnr, int ringnr){

	if(ringnr>=kartenindex()) return false ; 
	else{
	akfeld = (Felder[])karte.get(ringnr);
	return akfeld[feldnr].besucht;}
}

public void entfernung (int feldnr, int ringnr,int entf){

	akfeld = (Felder[])karte.get(ringnr);
	akfeld[feldnr].entfernung=entf;
}

public int wentfernung (int feldnr, int ringnr) {

	akfeld = (Felder[])karte.get(ringnr);
	return akfeld[feldnr].entfernung;
}

public void resetentfernung(){

	int ringzahl=kartenindex();
	int x=0;
	int y=0;
	akfeld=(Felder[])karte.get(0);
	akfeld[1].entfernung=999999;
	while(x<ringzahl){
	y=0;
		akfeld=(Felder[])karte.get(x);
		
		while(y<x*6){
		
			y++;

			akfeld[y].entfernung=999999;
			}
		x++;
		}
		
}	
	

public void freir(int richtung, boolean frei,int feldnr, int ringnr){

switch(richtung){

case 1:

	akfeld = (Felder[])karte.get(ringnr);
	akfeld[feldnr].nord=frei;
	
break;


case 2:

	akfeld = (Felder[])karte.get(ringnr);
	akfeld[feldnr].nordost=frei;

break;

case 3: 

	akfeld = (Felder[])karte.get(ringnr);
	akfeld[feldnr].sdost=frei;

break;

case 4: 

	akfeld = (Felder[])karte.get(ringnr);
	akfeld[feldnr].sd=frei;

break;

case 5:

	akfeld = (Felder[])karte.get(ringnr);
	akfeld[feldnr].sdwest=frei;

break;

case 6:

	akfeld = (Felder[])karte.get(ringnr);
	akfeld[feldnr].nordwest=frei;

break;

}
}


public boolean gfreir(int richtung,int feldnr, int ringnr){

switch(richtung){

case 1:
	
	akfeld = (Felder[])karte.get(ringnr);
	return akfeld[feldnr].nord;
	



case 2:

	akfeld = (Felder[])karte.get(ringnr);
	return akfeld[feldnr].nordost;



case 3: 

	akfeld = (Felder[])karte.get(ringnr);
	return akfeld[feldnr].sdost;



case 4: 

	akfeld = (Felder[])karte.get(ringnr);
	return akfeld[feldnr].sd;



case 5:

	akfeld = (Felder[])karte.get(ringnr);
	return akfeld[feldnr].sdwest;



case 6:

	akfeld = (Felder[])karte.get(ringnr);
	return akfeld[feldnr].nordwest;

default: return false;

}
}

public boolean felderrechnung(){
/**Rechnet bekannte Felder "raus" und gibt zurck ob berhaupt noch freie Felder vorhanden sind
*/



int ringzahl=kartenindex();
	int x=0;
	int y=0;
	boolean nochfreie=false;
	
	while(x<kartenindex()){
		
		y=0;
	
		akfeld=(Felder[])karte.get(x);

		while(y<x*6){
		
			y++;

	
		
		if(!istunbekannt(y,x) && !istbesucht (y,x)){

			int p=0;
			int i=0;
			if(istbesucht(Ber.feldnr(1,y,x),Ber.ringnr(1,y,x))){p++;}
if(!istunbekannt(Ber.feldnr(1,y,x),Ber.ringnr(1,y,x))){p++;}

			if(istbesucht(Ber.feldnr(2,y,x),Ber.ringnr(2,y,x))){p++;}if(!istunbekannt(Ber.feldnr(2,y,x),Ber.ringnr(2,y,x)))	{p++;}

			if(istbesucht(Ber.feldnr(3,y,x),Ber.ringnr(3,y,x))){p++;}if(!istunbekannt(Ber.feldnr(3,y,x),Ber.ringnr(3,y,x))){p++;}

			if(istbesucht(Ber.feldnr(4,y,x),Ber.ringnr(4,y,x))){p++;}if(!istunbekannt(Ber.feldnr(4,y,x),Ber.ringnr(4,y,x))){p++;}

			if(istbesucht(Ber.feldnr(5,y,x),Ber.ringnr(5,y,x))){p++;}if(!istunbekannt(Ber.feldnr(5,y,x),Ber.ringnr(5,y,x))){p++;}

		if(istbesucht(Ber.feldnr(6,y,x),Ber.ringnr(6,y,x))){p++;}
if(!istunbekannt(Ber.feldnr(6,y,x),Ber.ringnr(6,y,x))){p++;}

		
			if(korn(y,x)==0 && p>=11 )
			
			{
	
			besucht(y,x);
			unbekannt(false,y,x);
			}

			
	
		}
		
		if(!istbesucht(y,x) && !istunbekannt(y,x)){ 
			nochfreie=true;
		}		
	
		}	
		
		x++;
		}


return nochfreie;


}



}