package frisswienix;
import algds.c2002.Hamster;

public class HamsterLog  {
    
    public static Hamster hamster;

    public static void log(String msg) {
	if (hamster.verbose())
	    hamster.logln(msg);
    }

    public static String putCoords(HamsterCell cell) {
	return Integer.toString(cell.getX()) + ", " +
	    Integer.toString(cell.getY());
    }

    public static String putLoc(HamsterLocation loc) {
	return putCoords(loc.cell) + "; " + putOrient(loc.orientation);
    }

    public static String putOrient(int orientation) {
	String dir = "??";
	switch (orientation) {
	case HamsterMap.DIRECTION_NO: dir = "N"; break;
	case HamsterMap.DIRECTION_NE: dir = "NE"; break;
	case HamsterMap.DIRECTION_SE: dir = "SE"; break;
	case HamsterMap.DIRECTION_SO: dir = "S"; break;
	case HamsterMap.DIRECTION_SW: dir = "SW"; break;
	case HamsterMap.DIRECTION_NW: dir = "NW"; break;
	}
	return dir;
    }
    
} // HamsterLog
