package gau;
import algds.c2002.Hamster;
import java.util.*;

/**
 * @author Julia Schmiedel, Jens Knappe
 */

public class GAU extends Hamster{

public int richtung;
public Map labyrinth;
public Koordinate aktuelleKoor;
public Koordinate nachbarKoor;
public Koordinate goTo;
public Koordinate home;
public Stack way;
public boolean test;

public void run() {

	anfang();
	moveAround2();
}

void anfang(){
	richtung = 0;
	labyrinth = new Map (61,61);
	aktuelleKoor = new Koordinate (30,30);
	home = new Koordinate (30,30);
	labyrinth.setZelle(aktuelleKoor.copy(), new Zelle(2));
	lookAround();
	Zelle homeZelle = labyrinth.getZelle(aktuelleKoor.copy());
	homeZelle.setCornstatus(false);
	homeZelle.setCorn(0);
	labyrinth.setZelle(aktuelleKoor.copy(), homeZelle);
}

void cornTest(){
	int AvailableCorn = 0;
	int CarriedCorn = 0;
	int canCarrie = 0;
	int taked = 0;
	
	if (((lookHere() & CORNMASK) == CORN) & ((aktuelleKoor.getX()==30 & aktuelleKoor.getY()==30)==false)){
	
		Zelle aktuelleZelle = labyrinth.getZelle(aktuelleKoor);
		AvailableCorn = getAvailableCorn();
		CarriedCorn = getCarriedCorn();
		canCarrie = CORNCARRY_MAX  - CarriedCorn;
		taked = take(canCarrie);
			if (AvailableCorn > taked){
				aktuelleZelle.setCorn(AvailableCorn-taked);
				labyrinth.setZelle(aktuelleKoor,aktuelleZelle);
				goHome();
			}
			else {
				aktuelleZelle.setCorn(0);
				aktuelleZelle.setCornstatus(false);
				labyrinth.setZelle(aktuelleKoor,aktuelleZelle);

				if(getCarriedCorn()==CORNCARRY_MAX) goHome();
			}
	}
}

boolean moveNext(){

	boolean gehtweiter=false;
	Zelle aktuelleZelle = labyrinth.getZelle(aktuelleKoor);
				
	if (aktuelleZelle.getWando() == false && labyrinth.getZelle(aktuelleKoor.getNachbarKoordinate(0)).getCornstatus()==true){
		gehtweiter=true;
		changeRichtung(0);
		goForward();cornTest();
	}
	else if (aktuelleZelle.getWandro() == false && labyrinth.getZelle(aktuelleKoor.getNachbarKoordinate(60)).getCornstatus()==true){
		gehtweiter=true;
		changeRichtung(60);
		goForward();cornTest();
	}
	else if (aktuelleZelle.getWandru() == false && labyrinth.getZelle(aktuelleKoor.getNachbarKoordinate(120)).getCornstatus()==true){
		gehtweiter=true;
		changeRichtung(120);
		goForward();cornTest();
	}
	else if (aktuelleZelle.getWandu() == false && labyrinth.getZelle(aktuelleKoor.getNachbarKoordinate(180)).getCornstatus()==true){
		gehtweiter=true;
		changeRichtung(180);
		goForward(); cornTest();
	}
	else if (aktuelleZelle.getWandlu() == false && labyrinth.getZelle(aktuelleKoor.getNachbarKoordinate(240)).getCornstatus()==true){
		gehtweiter=true;
		changeRichtung(240);
		goForward(); cornTest();
	}
	else if (aktuelleZelle.getWandlo() == false && labyrinth.getZelle(aktuelleKoor.getNachbarKoordinate(300)).getCornstatus()==true){
		gehtweiter=true;
		changeRichtung(300);
		goForward();  cornTest();
	}
	else if (aktuelleZelle.getWando() == false && labyrinth.getZelle(aktuelleKoor.getNachbarKoordinate(0)).getStatus()==1){
		gehtweiter=true;
		changeRichtung(0);
		goForward();  cornTest();
	}
	else if (aktuelleZelle.getWandro() == false && labyrinth.getZelle(aktuelleKoor.getNachbarKoordinate(60)).getStatus()==1){
		gehtweiter=true;
		changeRichtung(60);
		goForward(); cornTest();
	}
	else if (aktuelleZelle.getWandru() == false && labyrinth.getZelle(aktuelleKoor.getNachbarKoordinate(120)).getStatus()==1){
		gehtweiter=true;
		changeRichtung(120);
		goForward(); cornTest();
	}
	else if (aktuelleZelle.getWandu() == false && labyrinth.getZelle(aktuelleKoor.getNachbarKoordinate(180)).getStatus()==1){
		gehtweiter=true;
		changeRichtung(180);
		goForward(); cornTest();
	}
	else if (aktuelleZelle.getWandlu() == false && labyrinth.getZelle(aktuelleKoor.getNachbarKoordinate(240)).getStatus()==1){
		gehtweiter=true;
		changeRichtung(240);
		goForward(); cornTest();
	}
	else if (aktuelleZelle.getWandlo() == false && labyrinth.getZelle(aktuelleKoor.getNachbarKoordinate(300)).getStatus()==1){
		gehtweiter=true;
		changeRichtung(300);
		goForward(); cornTest();
	}
	return gehtweiter;
}


void moveAround(){
	
	boolean test=false;
	while(test==false){
		labyrinth.sinnvollextra(aktuelleKoor.copy());
		goTo = labyrinth.waySearch(aktuelleKoor.copy());
		if (goTo.getX()==0 && goTo.getX()==0) {goHome(); test=true;}
		else goTo();
		cornTest();
	}
}


void moveAround2(){
	while(test==false){
		while(moveNext()==true);
		labyrinth.sinnvollextra(aktuelleKoor.copy());
		goTo = labyrinth.waySearch2(aktuelleKoor.copy());
		if (goTo.getX()==0 && goTo.getX()==0) {goHome(); test=true;}
		else goTo();
		cornTest();
		moveAround2();
	}

}

void goHome(){
	labyrinth.changeAbstand(new Koordinate(30,30));
	way=labyrinth.wayFrom(aktuelleKoor.copy());
	while (way.isEmpty()==false){
		Integer i = (Integer) way.pop();
		int j = i.intValue();
		changeRichtung(j);
		goForward();
	}
	if (atHome())
	dropHere(getCarriedCorn());	
	else goHome();
	labyrinth.abstand100(100);
	labyrinth.sinnvoll();	
}

void goTo(){
	labyrinth.changeAbstand(goTo.copy());
	way=labyrinth.wayFrom(aktuelleKoor.copy());
	while (way.isEmpty()==false){
			Integer i = (Integer) way.pop();
			int j = i.intValue();
			changeRichtung(j);
			goForward();
	}
}

void changeRichtung(int rneu){
	rneu=(rneu-richtung)/60;
	if (rneu < 0) rneu = 6+rneu;
	rechtsRum(rneu);
}

void rechts() {
	if (richtung == 300){
		richtung = 0;
		turn(TURN_RIGHT);
	}
	else {
		richtung += 60;
		turn(TURN_RIGHT);
	}
}

void rechtsRum(int anzahl) {
	for(int i =0; i < anzahl; i++){
		rechts();
	}
}

void goForward(){
	if (atHome())
	dropHere(getCarriedCorn());
	aktuelleKoor = aktuelleKoor.getNachbarKoordinate(richtung).copy();
	forward();
	if (labyrinth.getZelle(aktuelleKoor).getStatus() != 2)
	lookAround();	
}

void lookAround(){
	Zelle aktuelleZelle = labyrinth.getZelle(aktuelleKoor);
	aktuelleZelle.setStatus();
	aktuelleZelle.setAllWalls(false);

	if (((lookHere() & CORNMASK) == CORN)) {
			aktuelleZelle.setCornstatus(true);
			aktuelleZelle.setCorn(getAvailableCorn());
	}
	for(int i = 0; i < 6; i++){
		if (((lookForward() & WALLMASK) == WALL)) {
			aktuelleZelle.setWand(richtung);
		}
		else {				
			Zelle nachbarZelle = new Zelle (1);
			nachbarZelle.setAllWalls(true);
			nachbarKoor = aktuelleKoor.getNachbarKoordinate(richtung);
	
			if (labyrinth.getZelle(nachbarKoor) != null && labyrinth.getZelle(nachbarKoor).getStatus()==1){
				nachbarZelle = labyrinth.getZelle(nachbarKoor);
				nachbarZelle.delWandNachbar(richtung);
				labyrinth.setZelle(nachbarKoor,nachbarZelle);
			}
			if (labyrinth.getZelle(nachbarKoor) == null){
				if (((lookForward() & CORNMASK) == CORN)) {
					nachbarZelle.setCornstatus(true);
				}
				nachbarZelle.delWandNachbar(richtung);
				nachbarZelle.setAbstand(labyrinth.getZelle(aktuelleKoor).getAbstand() + 1);
				labyrinth.setZelle(nachbarKoor,nachbarZelle);
			}
			
		}				
	rechts();
	}
	labyrinth.setZelle(aktuelleKoor,aktuelleZelle);
	labyrinth.abstand100(200);
	labyrinth.sinnvoll();
	
}
public String getHamsterAuthor() {
  	return "Julia Schmiedel, Jens Knappe";
}
public String getHamsterVersion() {
	  return "Gold ";
}
public String getHamsterDate() {
	  return "30.04.2001";
}
}
