package h2d2c;

//---------------------------------------------------------------------
//----- Interface H2D2Constants
//---------------------------------------------------------------------
public interface H2D2Constants extends h2d2c.util.DirConstants {

  /** Wand- und Klippen- Konstanten. */
  static final int
    CUNKNOWN = 0,
    CFREE = 1,
    CWALL = 2,
    CUP =   3,
    CDOWN = 4;
  static final String[] BORDERSTRING = {"-","F","W","U","D"};

  /** Status eines Feldes: Ungesehen, gesehen, betreten. */
  // Wichtig fuer Cell.incState(int) ist NOTSEEN<JUSTSEEN<ENTERED
  static final int NOTSEEN = 0, JUSTSEEN = 1, ENTERED = 2;

  /** Unbekannte Kornzahl (aber mindestens eins) auf einem Feld. */
  static final int UNKNOWNCORNAMOUNT = -2;

  /** Unbekannt ob Korn auf einem Feld. */
  static final int UNKNOWNCORNSTATE = -1;
}
