package h2d2c.util;

//---------------------------------------------------------------------
//----- Klasse IntPoint
//---------------------------------------------------------------------
public class IntPoint implements DirConstants {
  public final int x, y;

  public IntPoint(int x, int y) {
    this.x = x; this.y = y;
  }

  public IntPoint getNeighbor(int dir) {
    return new IntPoint(x+WALKLUT[dir][X], y+WALKLUT[dir][Y]);
  }

  public String toString() {
    return "("+x+","+y+")";
  }
}
