package jay;

/**
 * Cell enthaelt Informationen fr jedes Feld des Labyrinth
 */

public class Cell {
	public boolean[] wall;
	public boolean visited;
	public boolean seenCorn;

	public int corn;
	public int[] distance;

	public Cell(){
		// Konstruktor
		
		wall = new boolean[6];		// 6 Seiten des Feldes vermauert?
		distance = new int[2620];	// Distanz zu bis zu 2620 verschiedenen Feldern
									// wird beim Laufen protokolliert
		for (int i=0;i<=5;i++){
			wall[i] = false;
		}
		for (int i=0;i<2620;i++){	// dauert beim Start recht lange :(
			distance[i] = 10000;
		}
		visited = false;			// Feld schon besucht
		seenCorn = false;			// vom Nchbarfeld aus Mais gesehen?
		corn = 0;					// wieviel Mais auf Feld
	} // Cell()
	
	public void setWall(int side){
		// setze Mauer auf Feldseite
		wall[side] = true;
	} // setWall

	public boolean isWall(int side){
		// Seite vermauert?
		if (side < 0) side += 6;
		if (side > 5) side -= 6;
		return wall[side];
	} // isWall
} // class Cell
