package jim_panse;

import algds.c2002.Hamster2;
import java.util.Vector;

public class Jim_Panse extends Hamster2{
boolean  finished        =false;                 //solange 'false',bis Labyrinth vollkommn erkundet
HexField memory[][]      =new HexField[200][200];//das Gedchtniss des Hamsters
int      hamsterPos[]    ={31,31,0};             //X-Koord.,Y-Koord und Richtung des Hamsters
int      homePos[]       ={31,31};               //Start- und Endposition des Hamsters
int      aimPos[]        ={-2,-2};               //angepeilte Zielkoordinaate
Vector   way             =new Vector();          //Vector enthlt Wegbeschreibung zu einem Punkt(x,y) 
int      corns_have      =0;                     //Anzahl der Krner,die Hamster im Maul trgt  
boolean  throw_when_there=false;                 //Wenn 'true' und er am Ziel ankommt,schmeit er Krner vorwrts

/*------------------------------Hamster-initialisieren--------------------------------*/
public void init_variables(){
  //Hamster-Position festlegen (X- Und Y-Ort im Array und die Richtung):
  hamsterPos[0]=memory.length/2;
  hamsterPos[1]=memory[0].length/2;
  hamsterPos[2]=0;
  //Heimatfeld merken:
  homePos[0]=hamsterPos[0];homePos[1]=hamsterPos[1];
  //Das Gedchtniss initialisieren:
  for(int i=0;i<memory.length;i++)
  	for(int j=0;j<memory[0].length;j++)
      memory[i][j]=new HexField();
}

/*---------------Einen-Schritt-vorwrts-gehen-und-neue-Position-errechnen-------------*/
public void move_forward(){
	forward();
	hamsterPos[0]=getNextX(hamsterPos[0],hamsterPos[1],hamsterPos[2]);
	hamsterPos[1]=getNextY(hamsterPos[1],hamsterPos[2]);
}

/*------------------------Hamster-soll-sich-nach-links-drehen-------------------------*/
public void turn_left(){
  turn(TURN_LEFT);
  hamsterPos[2]=(hamsterPos[2]+5)%6;
}

/*------------------------Hamster-soll-sich-nach-rechts-drehen------------------------*/
public void turn_right(){
  turn(TURN_RIGHT);
  hamsterPos[2]=(hamsterPos[2]+1)%6;
}

/*------------X_Position-des-nchsten-HexFields-in-Richtung-direction-ermitteln-------*/
public int getNextX(int xPos,int yPos,int direction){
  if(yPos % 2!=0){  //ungerade Zeile im Array
    if(direction<=3)return xPos;
    else return xPos-1;
  } 
  else{             //gerade Zeile im Array
    if(direction==0)return xPos;
    else if(direction==1 || direction==2)return xPos+1;
    else return xPos;
  }
}

/*------------Y_Position-des-nchsten-HexFields-in-Richtung-direction-ermitteln-------*/
public int getNextY(int yPos,int direction){
  if(direction==0)return yPos-2;
  else if(direction==1)return yPos-1;
  else if(direction==2)return yPos+1;
  else if(direction==3)return yPos+2;
  else if(direction==4)return yPos+1;
  else return yPos-1;
}

/*----------------------------Hamster-soll-sich-umschauen-----------------------------*/
public void look_around(){
//Wurde Feld noch nicht betreten, dreht er sich um 360 und schaut sich die angrenzenden Felder an:
if(memory[hamsterPos[0]][hamsterPos[1]].isEntered()==false){
  memory[hamsterPos[0]][hamsterPos[1]].setEntered();
    for(int direc=1;direc<=6;direc++){
      turn_left();
      //sieht er eine Schrge nach oben bzw. nach unten?
      if((lookForward() & WALLMASK)==SLOPEDOWN){
     	  memory[hamsterPos[0]][hamsterPos[1]].setPassable(hamsterPos[2]);
        memory[getNextX(hamsterPos[0],hamsterPos[1],hamsterPos[2])]
        	    [getNextY(hamsterPos[1],hamsterPos[2])].setPassable((hamsterPos[2]+3)%6);
      }
      else if((lookForward() & WALLMASK)==SLOPEUP){
      	memory[hamsterPos[0]][hamsterPos[1]].setPassable(hamsterPos[2]);
        memory[getNextX(hamsterPos[0],hamsterPos[1],hamsterPos[2])]
        	    [getNextY(hamsterPos[1],hamsterPos[2])].setPassable((hamsterPos[2]+3)%6);
      }   
      //sieht er eine Klippe aufwrts oder runter?
      else if((lookForward() & WALLMASK)==CLIFFUP){
        memory[getNextX(hamsterPos[0],hamsterPos[1],hamsterPos[2])]
        	    [getNextY(hamsterPos[1],hamsterPos[2])].setPassable((hamsterPos[2]+3)%6);
      }
      else if((lookForward() & WALLMASK)==CLIFFDOWN){
       	memory[hamsterPos[0]][hamsterPos[1]].setPassable(hamsterPos[2]);
      }   
      //sieht er freien Weg ?
      else if((lookForward() & WALLMASK)!=WALL){
       	memory[hamsterPos[0]][hamsterPos[1]].setPassable(hamsterPos[2]);
        memory[getNextX(hamsterPos[0],hamsterPos[1],hamsterPos[2])]
        	    [getNextY(hamsterPos[1],hamsterPos[2])].setPassable((hamsterPos[2]+3)%6);
      }
      
      //Ist das angrenzende Feld weniger als 100 Schritte von 'home' entfernt ist es erreichbar:
      if(((lookForward() & WALLMASK)!=CLIFFUP) && ((lookForward() & WALLMASK)!=WALL) &&
      	 memory[getNextX(hamsterPos[0],hamsterPos[1],hamsterPos[2])]
    		       [getNextY(hamsterPos[1],hamsterPos[2])].isReachable()==false &&
    		   (way_length(get_way(getNextX(hamsterPos[0],hamsterPos[1],hamsterPos[2]),
    		   	                   getNextY(hamsterPos[1],hamsterPos[2]),hamsterPos[2],homePos[0],homePos[1]))<100 ||
    		   	(way_length(get_way(getNextX(hamsterPos[0],hamsterPos[1],hamsterPos[2]),
    		   		                  getNextY(hamsterPos[1],hamsterPos[2]),hamsterPos[2],homePos[0],homePos[1]))==100 &&
           (lookForward() & CORNMASK)==CORN))){
      	memory[getNextX(hamsterPos[0],hamsterPos[1],hamsterPos[2])][getNextY(hamsterPos[1],hamsterPos[2])].setReachable();}
      
      //Spezialfall (ist in der Methode erklrt, wie der aussieht):
      exclude_HexField();
    }
}

//Falls keine Krner auf diesem Feld hier liegen, so mu Feld als 'empty' betrachtet werden:
if(getAvailableCorn()==0 ||(homePos[0]==hamsterPos[0] && homePos[1]==hamsterPos[1])){
	memory[hamsterPos[0]][hamsterPos[1]].setEmpty();
}

//Wenn das Ziel des Hamster ein Feld ist, dass als Ziel ausgeschlossen werden kann, soll er nicht hingehen:
if(aimPos[0]==getNextX(hamsterPos[0],hamsterPos[1],hamsterPos[2])	&& 
	 aimPos[1]==getNextY(hamsterPos[1],hamsterPos[2]) && exclude_HexField()==true){
  aimPos[0]=-2;way=new Vector();
}

}

/*----------------Spezialfall:-Ein-Feld-kann-als-Ziel-ausgeschlossen-werden-----------*/
public boolean exclude_HexField(){
//Wurden alle Felder um dieses Feld (Feld in Blickrichtung des Hamsters) erkundet und der 
//Hamster sieht, dass kein Korn darauf ist, so sieht er es als 'entered' an, ohne es zu betreten:
  if(((lookForward() & CORNMASK)!=CORN) && ((lookForward() & WALLMASK)!=CLIFFUP) &&
  	((lookForward() & WALLMASK)!=SLOPEUP) && ((lookForward() & WALLMASK)!=WALL) &&
    memory[getNextX(hamsterPos[0],hamsterPos[1],hamsterPos[2])]
    		  [getNextY(hamsterPos[1],hamsterPos[2])].isEntered()==false &&
    memory[getNextX(hamsterPos[0],hamsterPos[1],(hamsterPos[2]+1)%6)]
    		  [getNextY(hamsterPos[1],(hamsterPos[2]+1)%6)].isEntered()==true &&
    memory[getNextX(hamsterPos[0],hamsterPos[1],(hamsterPos[2]+5)%6)]
    		  [getNextY(hamsterPos[1],(hamsterPos[2]+5)%6)].isEntered()==true &&
    memory[getNextX(getNextX(hamsterPos[0],hamsterPos[1],hamsterPos[2]),getNextY(hamsterPos[1],hamsterPos[2]),hamsterPos[2])]
    		  [getNextY(getNextY(hamsterPos[1],hamsterPos[2]),hamsterPos[2])].isEntered()==true  &&
    memory[getNextX(getNextX(hamsterPos[0],hamsterPos[1],hamsterPos[2]),getNextY(hamsterPos[1],hamsterPos[2]),(hamsterPos[2]+5)%6)]
    		  [getNextY(getNextY(hamsterPos[1],hamsterPos[2]),(hamsterPos[2]+5)%6)].isEntered()==true &&
    memory[getNextX(getNextX(hamsterPos[0],hamsterPos[1],hamsterPos[2]),getNextY(hamsterPos[1],hamsterPos[2]),(hamsterPos[2]+1)%6)]
    		  [getNextY(getNextY(hamsterPos[1],hamsterPos[2]),(hamsterPos[2]+1)%6)].isEntered()==true){	
    	memory[getNextX(hamsterPos[0],hamsterPos[1],hamsterPos[2])][getNextY(hamsterPos[1],hamsterPos[2])].setEntered();
    	memory[getNextX(hamsterPos[0],hamsterPos[1],hamsterPos[2])][getNextY(hamsterPos[1],hamsterPos[2])].setEmpty();
      return true;
  }
  else return false;
}

/*---Gebe-den-krzesten-Weg-von-einem-Startpunkt-zu-dem-Zielpunkt-in-einem-Vector-an---*/
public Vector get_way(int startX,int startY,int startDirec,int zielX,int zielY){
Vector possibleWay=new Vector();
//Start- und Zielpunkt mssen versch. und grer 0 sein, um mit dem Rechnen zu beginnen:
if(startX>0 && zielX>0 && (startX!=zielX || startY!=zielY)){
  //Mask erstelllen: 'false' heit: Feld wurde noch nicht beschritten
  boolean mask[][]=new boolean[memory.length][memory[0].length];
  for(int x=0;x<mask.length;x++)
  	for(int y=0;y<mask[0].length;y++)mask[x][y]=false;
  //
  mask[startX][startY]=true;
  //Vectoren erstellen (fr mgl. X-Koord.,Y-Koord. und Richtungen):
  Vector possibleX=new Vector();possibleX.add(new Integer(startX));
  Vector possibleY=new Vector();possibleY.add(new Integer(startY));
  Vector possibleDirec=new Vector();possibleDirec.add(new Integer(startDirec));
  possibleWay.add(new Vector());
  //Abbruchbedingung festlegen:
  boolean done=false;
  int vectorSize=0;//Damit kann die Gre eines Vectors gespeichert werden
  Vector tmpV=new Vector();//Vector fr temporre Operationen
  //Los gehts: Schritt I und Schritt II solange wiederholen, bis man am Ziel ankommt (done==true):
  while(done==false){
    //Schritt I: Die max. fnf anderen mglichen freien Wege in Vector schreiben:
    vectorSize=possibleX.size();
    for(int i=0;i<vectorSize;i++){
      int originalDirec=Integer.parseInt(String.valueOf(possibleDirec.elementAt(i)));
      for(int direcs=1;direcs<6;direcs++){
        if(memory[Integer.parseInt(String.valueOf(possibleX.elementAt(i)))]
      	         [Integer.parseInt(String.valueOf(possibleY.elementAt(i)))].isPassable((originalDirec+direcs)%6)==true){
          //Koordinaaten bergeben:
          possibleX.add(new Integer(Integer.parseInt(String.valueOf(possibleX.elementAt(i)))));
          possibleY.add(new Integer(Integer.parseInt(String.valueOf(possibleY.elementAt(i)))));
          possibleDirec.add(new Integer((originalDirec+direcs)%6));
          //alte Weg- und neue Weg-Instruktions bergeben:
          tmpV=(Vector)(((Vector)(possibleWay.elementAt(i))).clone());
          for(int j=1;j<=direcs;j++)tmpV.add(new Integer(2));
          possibleWay.add((Vector)(tmpV.clone()));
        }
      }
    }
    //Schritt II: berprfen ob nchste HexFeld noch nicht betreten wurde, sonst Mgl. lschen:
    vectorSize=possibleX.size();
    for(int i=0;i<vectorSize;i++){
      if(mask[getNextX(Integer.parseInt(String.valueOf(possibleX.elementAt(i))),
                       Integer.parseInt(String.valueOf(possibleY.elementAt(i))),
                       Integer.parseInt(String.valueOf(possibleDirec.elementAt(i))))]  
             [getNextY(Integer.parseInt(String.valueOf(possibleY.elementAt(i))),
    	                 Integer.parseInt(String.valueOf(possibleDirec.elementAt(i))))]==false
         && memory[Integer.parseInt(String.valueOf(possibleX.elementAt(i)))]
        	        [Integer.parseInt(String.valueOf(possibleY.elementAt(i)))].
      	          isPassable(Integer.parseInt(String.valueOf(possibleDirec.elementAt(i))))==true){
        //Weg frei, X und Y ein Schritt vorwrts setzen:
        possibleX.setElementAt(new Integer(getNextX(Integer.parseInt(String.valueOf(possibleX.elementAt(i))),
      	                                            Integer.parseInt(String.valueOf(possibleY.elementAt(i))),
      	                                            Integer.parseInt(String.valueOf(possibleDirec.elementAt(i))))),i);
        possibleY.setElementAt(new Integer(getNextY(Integer.parseInt(String.valueOf(possibleY.elementAt(i))),
      	                                            Integer.parseInt(String.valueOf(possibleDirec.elementAt(i))))),i);
        //Vorwrts-Schritt zu Instructions hinzufgen:
        tmpV=(Vector)(((Vector)(possibleWay.elementAt(i))).clone());
        tmpV.add(new Integer(0));
        possibleWay.setElementAt((Vector)(tmpV.clone()),i);
        //berprfen, ob man auf ZielFeld steht (Variable 'done' wird auf 'true' gesetzt):
        if(Integer.parseInt(String.valueOf(possibleX.elementAt(i)))==zielX && 
           Integer.parseInt(String.valueOf(possibleY.elementAt(i)))==zielY){
          possibleWay=(Vector)(possibleWay.elementAt(i));done=true;}
        //Feld in der mask mit 'true' belegen (d.h. Feld wurde schon mal beschritten):
        mask[Integer.parseInt(String.valueOf(possibleX.elementAt(i)))]
      	    [Integer.parseInt(String.valueOf(possibleY.elementAt(i)))]=true;
        }
      else{
        //Feld wurde schon mal betreten,diese Mglichkeit wird gelscht:
        possibleX.remove(i);possibleY.remove(i);possibleDirec.remove(i);possibleWay.remove(i);
        i=i-1;vectorSize=vectorSize-1;
      };
    if(possibleWay.size()==0)done=true;//ist ein Abbruch, falls keine Mgl. mehr existiert
    //Es kam zu einem Ergebniss, nun die 'for'-Schleife von Schritt II verlassen:
    if(done==true)break;
    }
  }
}

return possibleWay;
}

/*------------------Neues-Ziel,das-noch-nicht-erkundet-wurde,-finden------------------*/
public int[] find_a_Target(){
//Diese Methode ist der Methode get_way(....) sehr hnlich und gibt dem Hamster ein neues Ziel
  int koord[]={-2,-2};
  //Mask erstelllen: 'false' heit: wurde noch nicht als Ziel ausgeschlossen:
  boolean mask[][]=new boolean[memory.length][memory[0].length];
  for(int x=0;x<mask.length;x++)
	  for(int y=0;y<mask[0].length;y++)
	    if(memory[x][y].isReachable())mask[x][y]=false;else mask[x][y]=true;
  mask[hamsterPos[0]][hamsterPos[1]]=true;
  //Vectoren erstellen:
  Vector possibleX=new Vector();possibleX.add(new Integer(hamsterPos[0]));
  Vector possibleY=new Vector();possibleY.add(new Integer(hamsterPos[1]));
  Vector possibleDirec=new Vector();possibleDirec.add(new Integer(hamsterPos[2]));
  //Abbruchbedingung festlegen:
  boolean done=false;
  int vectorSize=0;
  int originalDirec=0;
  
  //Los gehts: Schritt I und Schritt II solange wiederholen, bis neues Ziel gefunden (done==true):
  while(done==false){
    //Schritt I: Die max. fnf anderen mglichen freien Wege in Vector schreiben:
    vectorSize=possibleX.size();
    for(int i=0;i<vectorSize;i++){
      originalDirec=Integer.parseInt(String.valueOf(possibleDirec.elementAt(i)));
      for(int direcs=1;direcs<6;direcs++){
        if(memory[Integer.parseInt(String.valueOf(possibleX.elementAt(i)))]
      	         [Integer.parseInt(String.valueOf(possibleY.elementAt(i)))].
      	       	 isPassable((originalDirec+direcs)%6)==true){
          //Weg frei, nun Koordinaaten bergeben:
          possibleX.add(new Integer(Integer.parseInt(String.valueOf(possibleX.elementAt(i)))));
          possibleY.add(new Integer(Integer.parseInt(String.valueOf(possibleY.elementAt(i)))));
          possibleDirec.add(new Integer((originalDirec+direcs)%6));
        }
      }
    }
    //Schritt II: berprfen ob nchste HexFeld noch nicht als Ziel betrachtet wurde:
    vectorSize=possibleX.size();
    for(int i=0;i<vectorSize;i++){
      if(mask[getNextX(Integer.parseInt(String.valueOf(possibleX.elementAt(i))),
                       Integer.parseInt(String.valueOf(possibleY.elementAt(i))),
                       Integer.parseInt(String.valueOf(possibleDirec.elementAt(i))))]  
             [getNextY(Integer.parseInt(String.valueOf(possibleY.elementAt(i))),
    	                 Integer.parseInt(String.valueOf(possibleDirec.elementAt(i))))]==false
         && memory[Integer.parseInt(String.valueOf(possibleX.elementAt(i)))]
          	      [Integer.parseInt(String.valueOf(possibleY.elementAt(i)))].
      	          isPassable(Integer.parseInt(String.valueOf(possibleDirec.elementAt(i))))==true){
        //Weg frei, X und Y ein Schritt vorwrts setzen:
        possibleX.setElementAt(new Integer(getNextX(Integer.parseInt(String.valueOf(possibleX.elementAt(i))),
      	                                            Integer.parseInt(String.valueOf(possibleY.elementAt(i))),
      	                                            Integer.parseInt(String.valueOf(possibleDirec.elementAt(i))))),i);
        possibleY.setElementAt(new Integer(getNextY(Integer.parseInt(String.valueOf(possibleY.elementAt(i))),
      	                                            Integer.parseInt(String.valueOf(possibleDirec.elementAt(i))))),i);
        //Feld in der mask mit 'true' belegen (d.h.wurde schon als mgl. Ziel betrachtet):
        mask[Integer.parseInt(String.valueOf(possibleX.elementAt(i)))]
      	    [Integer.parseInt(String.valueOf(possibleY.elementAt(i)))]=true;
        //berprfen, ob Feld als Ziel in Frage kommt:
        if(memory[Integer.parseInt(String.valueOf(possibleX.elementAt(i)))]
        	       [Integer.parseInt(String.valueOf(possibleY.elementAt(i)))].isEntered()==false ||
      	   (corns_have<CORNCARRY_MAX	&& memory[Integer.parseInt(String.valueOf(possibleX.elementAt(i)))]
      	    [Integer.parseInt(String.valueOf(possibleY.elementAt(i)))].isEmpty()==false)){
          //Ja, ist ein Ziel: (die Vectoren nun vom 'Schrott' befreien und Variable 'done' auf 'true' setzen)
          originalDirec=Integer.parseInt(String.valueOf(possibleX.elementAt(i)));
          possibleX=new Vector();
          possibleX.add(new Integer(originalDirec));
          originalDirec=Integer.parseInt(String.valueOf(possibleY.elementAt(i)));
          possibleY=new Vector();
          possibleY.add(new Integer(originalDirec));
      	  done=true;
        }
      }
      else{
      //Feld wurde schon abgefragt,diese Mglichkeit wird gelscht:
      possibleX.remove(i);possibleY.remove(i);possibleDirec.remove(i);
      i=i-1;vectorSize=vectorSize-1;
      };
    //Es gibt keine mglichen Ziele mehr, Ziel ist damit auch erreicht (und koord wird auf -1 gesetzt):
    if(possibleX.size()==0){koord[0]=-1;koord[1]=-1;done=true;}
    //Ziel gefunden, jetzt die for-Schleife verlassen:
    if(done==true)break;
    }
  }
  
  //Zielkoordinaten zuweisen: (wenn koord[0]==-1 ist, wird spter in der run-Methode entschieden, ob Hamster fertig ist)
  if(koord[0]!=-1){koord[0]=Integer.parseInt(String.valueOf(possibleX.elementAt(0)));
                 koord[1]=Integer.parseInt(String.valueOf(possibleY.elementAt(0)));}
  return koord;
}

/*------------------Weg-Lnge-ermitteln:-Wie-oft-geradeaus-gehen?---------------------*/
public long way_length(Vector plan){
//diese Methode gibt den Weg-Aufwand eines Vectors an:
long wLength=0;
  for(int i=0;i<plan.size();i++){
    if(Integer.parseInt(String.valueOf(plan.elementAt(i)))==0)wLength=wLength+1;
  }
return wLength;
}

/*---------------Der-Hamster-hat-das-Maul-voll:-Was-soll-er-jetzt-machen?-------------*/
public void find_possibility_to_get_rid_of_corns(){
  //Weg nach Hause berechnen:
  aimPos[0]=homePos[0];
  aimPos[1]=homePos[1];
  way=get_way(hamsterPos[0],hamsterPos[1],hamsterPos[2],aimPos[0],aimPos[1]);
  //Falls Weg nach Hause existiert, nun testen, ob mit dropForward() der Weg-Aufwand minimiert wird:
  if(way.size()>0){
    //imaginre Position, um den Hamster imaginr im Gedchtniss zu bewegen:
    int ipos[]={hamsterPos[0],hamsterPos[1],hamsterPos[2]};
    //minimalster Aufwand:
    long min_way_length=way_length(get_way(hamsterPos[0],hamsterPos[1],hamsterPos[2],homePos[0],homePos[1]))
    	                  +way_length(get_way(homePos[0],homePos[1],ipos[2],hamsterPos[0],hamsterPos[1]));
    //wenn minimalerer Aufwand gefunden, wird dies in diesen Koordinaaten gespeichert:
    int x_min=-2;int y_min=0;
    //Los geht der Test: Fr jeden einzelnen Wegpunkt wird getestet, ob's mit weniger Aufwand geht:
      while(way.size()>0){
        //Den Test, obs auch krzer geht:
        if(memory[getNextX(ipos[0],ipos[1],ipos[2])][getNextY(ipos[1],ipos[2])].isPassable((ipos[2]+3)%6)==false
           && 
           Integer.parseInt(String.valueOf(way.elementAt(0)))==0
           &&
        	 way_length(get_way(hamsterPos[0],hamsterPos[1],hamsterPos[2],ipos[0],ipos[1]))+
           way_length(get_way(ipos[0],ipos[1],ipos[2],hamsterPos[0],hamsterPos[1]))+
           way_length(get_way(getNextX(ipos[0],ipos[1],ipos[2]),getNextY(ipos[1],ipos[2]),ipos[2],homePos[0],homePos[1]))+
           way_length(get_way(homePos[0],homePos[1],ipos[2],getNextX(ipos[0],ipos[1],ipos[2]),getNextY(ipos[1],ipos[2])))	
           <  min_way_length ){
        	x_min=getNextX(ipos[0],ipos[1],ipos[2]);
        	y_min=getNextY(ipos[1],ipos[2]);
        	min_way_length=way_length(get_way(hamsterPos[0],hamsterPos[1],hamsterPos[2],ipos[0],ipos[1]))+
                         way_length(get_way(ipos[0],ipos[1],ipos[2],hamsterPos[0],hamsterPos[1]))+
                         way_length(get_way(getNextX(ipos[0],ipos[1],ipos[2]),getNextY(ipos[1],ipos[2]),ipos[2],homePos[0],homePos[1]))+
                         way_length(get_way(homePos[0],homePos[1],ipos[2],getNextX(ipos[0],ipos[1],ipos[2]),getNextY(ipos[1],ipos[2])));
        }
        //Zum nchsten Wegpunkt gehen:
        if(Integer.parseInt(String.valueOf(way.elementAt(0)))==0){
        		ipos[0]=getNextX(ipos[0],ipos[1],ipos[2]);ipos[1]=getNextY(ipos[1],ipos[2]);
        }
        else if(Integer.parseInt(String.valueOf(way.elementAt(0)))==1)ipos[2]=(ipos[2]+5)%6;
        else if(Integer.parseInt(String.valueOf(way.elementAt(0)))==2)ipos[2]=(ipos[2]+1)%6;
        way.removeElementAt(0);
      }
    
    //Test beendet.Falls Koord. fr minimaleren Weg existieren, so sind diese das neue Ziel:
    if(x_min!=-2){
      way=get_way(hamsterPos[0],hamsterPos[1],hamsterPos[2],x_min,y_min);
      //er soll vom Feld davor werfen, also muss letzte move_forward()-Befehl gelscht werden:
      way.removeElementAt(way.size()-1);
      throw_when_there=true;
      //Nur noch entscheiden, ob er nach Werfen wieder zurcklaufen soll, von wo er herkam:
      corns_have=corns_have-1;//sonst schliet find_a_Target() Felder mit Krnern als Ziel aus
      aimPos=find_a_Target();
        if(way_length(get_way(hamsterPos[0],hamsterPos[1],hamsterPos[2],aimPos[0],aimPos[1])) <
           way_length(get_way(homePos[0],homePos[1],hamsterPos[2],aimPos[0],aimPos[1]))  ){
          aimPos[0]=hamsterPos[0];aimPos[1]=hamsterPos[1];
        }
        else aimPos[0]=-2;
      corns_have=corns_have+1;
    }
    //Es gibt keine Koord fr minimaleren Weg....  ...schade eigentlich um die Rechenzeit.
    else way=get_way(hamsterPos[0],hamsterPos[1],hamsterPos[2],aimPos[0],aimPos[1]);
  }
  else aimPos=aimPos=find_a_Target();
}

/*---Der-Vector-way-hat-keine-Anweisungen-mehr,-nun-berlegen-was-er-jetzt-anstellt---*/
public void find_a_new_order(){
  if(corns_have<CORNCARRY_MAX){
	  aimPos=find_a_Target();
	}
  else{
    //Wenn er Anweisung hat, die Krner am Zielort vorwrts zu schmeissen, dann soll er es tun:
    if(throw_when_there==true){ 
  	  dropForward(corns_have);corns_have=0;
      throw_when_there=false;
      //Nun das Feld vor ihm nur als nicht leer deklarieren, wenn es nicht das Heimatfeld ist:
      if(homePos[0]!=getNextX(hamsterPos[0],hamsterPos[1],hamsterPos[2])|| homePos[1]!=getNextY(hamsterPos[1],hamsterPos[2]))
    		memory[getNextX(hamsterPos[0],hamsterPos[1],hamsterPos[2])][getNextY(hamsterPos[1],hamsterPos[2])].setNotEmpty();
      //Noch Krner im Maul behalten?
      if(getCarriedCorn()>0){move_forward();aimPos[0]=-2;corns_have=getCarriedCorn();}
      else way=get_way(hamsterPos[0],hamsterPos[1],hamsterPos[2],aimPos[0],aimPos[1]);
    }
  
    //Falls Maul voll und er nicht auf dem Weg nach Hause ist, testen er ob er jetzt nach Hause kann:
    else if(aimPos[0]!=homePos[0]|| aimPos[1]!=homePos[1]){
	    find_possibility_to_get_rid_of_corns();
	  }
  
  }
}

/*----------------------------Hauptmethode--------------------------------------------*/
/*------------------------------------------------------------------------------------*/
public void run() {
init_variables();//Hamster initialisieren
while (finished==false){
  //umschauen:
  look_around();
  
  //Weg zum gesetzten Ziel ermitteln:
  if(way.size()==0 && throw_when_there==false)way=get_way(hamsterPos[0],hamsterPos[1],hamsterPos[2],aimPos[0],aimPos[1]);
  
  //Bewegen oder neues Ziel suchen:
  if(way.size()>0){
    if(Integer.parseInt(String.valueOf(way.elementAt(0)))==0)move_forward();
    else if(Integer.parseInt(String.valueOf(way.elementAt(0)))==1)turn_left();
    else if(Integer.parseInt(String.valueOf(way.elementAt(0)))==2)turn_right();
    way.removeElementAt(0);}
  else find_a_new_order();
  
  //Wenn kein Ziel mehr gefunden wurde und er zu Hause ist, dann ist er fertig:
  if(aimPos[0]==-1 && hamsterPos[0]==homePos[0] && hamsterPos[1]==homePos[1]){finished = true;}
  //Wenn kein Ziel mehr gefunden wurde und er nicht zu Hause ist, dann muss er zurcklaufen:
  if(aimPos[0]==-1 && finished==false){aimPos[0]=homePos[0];aimPos[1]=homePos[1];}
  
  //Falls Krner auf aktueller Position sind, diese aufnehmen:
  if(corns_have<CORNCARRY_MAX && (homePos[0]!=hamsterPos[0] || homePos[1]!=hamsterPos[1])){
    corns_have=take(CORNCARRY_MAX)+corns_have; 
  }
  
  //Falls Hamster zu Hause ist, soll er alle Krner ablegen:
  if(homePos[0]==hamsterPos[0] && homePos[1]==hamsterPos[1] && corns_have>0){
	  dropHere(corns_have);corns_have=0;
  }
}
}

public String getHamsterAuthor() { return "Jrg Futterlieb"; }

public String getHamsterDate() { return "27.04.2002"; }

public String getHamsterVersion() { return "1.2"; }

} 