package mannie;

/**	Klasse, die die Funktionalitaet eines		
	Speichers zweier Koordinaten der GAUSS'schen
	Zahlenebene, und die Ausgabe derselben		
	bereitstellt*/
public class Coord{
	//Konstruktoren
	public Coord(){
		actual[0]=0;
		actual[1]=0;
	}
	public Coord(int x, int y){
		actual[0]=x;
		actual[1]=y;
	}
	public Coord(Coord c){
		actual[0]=c.getX();
		actual[1]=c.getY();
	}
	public Coord(int[] a){
		actual[0]=a[0];
		actual[1]=a[1];
	}
	//interner Speicher des aktuellen Koordinatenpaares
	private int[] actual=new int[2];
	
	//Accessor-Methoden
	public int[] getCoords() {return actual;}
	public int getX() {return actual[0];}
	public int getY() {return actual[1];}
	
	//Setz-Methoden
	public void setCoords(int x, int y){
		actual[0]=x;
		actual[1]=y;
	}
	public void setX(int x) {actual[0]=x;}
	public void setY(int y) {actual[1]=y;}
	
	//Ueberladen der toString()-Methode
	//als debug-Element
	public String toString(){
		return("x:"+actual[0]+"\ty:"+actual[1]);
	}
}