package mannie;
import java.util.*;
import algds.c2002.*;
/**            
 * HAUPTKLASSE 
 *             
*/
public class Mannie extends Hamster{
	boolean finished=false;
	Map map=new Map(70,70);					//neue map
	int dir=0;   			//Restklassenkoerper mod 6
//ChS: Restklassenkoerper Z/6Z... aha... *g*

	Coord coord=new Coord();
	Vector cornPos=new Vector();
	//int[][] speicher=new int[2][20];
	//int speicherzaehler;
    
    public void output(String string){
    	if(verbose()) log(string);	
    }
/**Wand-Methoden*/
	//Praedikat Wand voraus?
	private boolean isWall(){
		return((lookForward()&WALLMASK)==WALL);
    }
    private boolean getWallAt(int direction){
    	boolean[] wall = turnAndLook();
    	return wall[direction];
    }
    
	private boolean wall(){
		return map.getWall();
	}
	
/**	Bewegungs-Methoden*/
	//klaert Wandeigenschaften der umgebenden Felder auf.
	//OP: Wand-Praedikate In Reihenfolge der Numme-
	//    rierung der Felder
    private boolean[] turnAndLook(){
    	int temp=dir;
    	boolean [] wall=new boolean[6];
    	//einnorden ueberfluessig wegen wall[dir]=...
    	//while(dir!=0)turnRight();
    	for (int i=0;i<6;i++){
    		wall[dir]=isWall();
    		turnRight();
    	}
    	map.setWalls(wall);
    	while(dir!=temp) turnRight();	//zurck in alte richtung
    	return wall;
    }
    private void turnRight(){
		turn(TURN_RIGHT);
		++dir;
		dir=dir%6;						//Restklassenkoerper mod 6
		//oder auch:
		//if (dir>6) dir-=6;
		map.setDir(dir);
    }
    private void turnLeft(){
		turn(TURN_LEFT);
		--dir;
		dir=(6+dir)%6;
		map.setDir(dir);
	}
    private void goForward(){
    	turnAndLook();					//hole Infos ueber Umgebung
    	if(!getWallAt(dir))forward();	//vorwrts wenn keine Wand
    	else output("!!!wand");			//das sollte niemals erreicht werden
    	map.updateCoords();    			//Coords aktualisieren
		map.incDist();					//distance erhhen
		map.setDir(dir);				//map.dir aktualisieren
		map.setWalls(turnAndLook());	//waende an map uebermitteln
		/*speicherupdate();
		int[] a=vergleichsspeicher();
		map.setMark(a[0],a[1],'s');*/
    }
	
	//Praedikat: ist noch ein Weg in direkter Umgebung
	//unbetreten?
	private boolean newWay(){
		for(int i=0;i<6;i++){
			if(!map.getWallAt(map.x(),map.y(),i) && map.getDistAt(map.x(),map.y(),i)==200)return true;
		}
		return false;
	}
	
	private int countWalls(){
		int count=0;
		for(int i=0;i<6;i++)
			if(map.getWallAt(map.x(),map.y(),i));
		return count;
	}
	
	//soviel Mais wie moeglich aufheben
	private void takeAll(){
		while(getAvailableCorn()>0 && getCarriedCorn()<20)take(1);
	}
	
	//Praedikat: mehr als vier Waende rundherum?
	private boolean onlyWay(){
		int counter=0;
		for(int i=0;i<6;i++){
			if(map.getWallAt(map.x(),map.y(),i))counter++;
		}
		return (counter>=5);
	}
	
	/*private boolean isReady(){
		int counter=0;
		for(int i=0;i<6;i++){
			if((map.getMarkAt(map.x(),map.y(),i)=='s' || map.getWallAt(map.x(),map.y(),i)) && counter<6)++counter;
		}
		return (counter>=6);
	}*/
	
	//Praedikat: eingebaut(==ende)?
	private boolean isReady(){
		return getWay(map.x(),map.y())==100;
	}
	
	//
	public int getWay(int isx,int isy){
		for(int i=0;i<6;i++){
			if(!map.getWallAt(isx,isy,i) && map.getMarkAt(isx,isy,i)!='s' && map.getMarkAt(isx,isy,i)!='g'){
				//System.out.print(i+" ");
				return i;
			}
		}
		return 100;
	}
	
/**
 * Kern-Methode zum Erkunden*/
	public void hamstern(){
		if(!isReady()){
			//erkunde umliegende Felder
			turnAndLook();
			//liegt Mais auf einem Feld der  Distanz<100
			//und ist Position unbekannt, dann merke sie dir
			if(getAvailableCorn()>0 && map.distance()<100&&!atHome()){
				int[] data={map.x(),map.y(),getAvailableCorn()};
				//keine Abfrage mehr mit "contains()"
				//Grund: (contains) Vergleich der zweier identischer
				//Objekte an zwei verschiedenen Speicherstellen
				//liefert immer FALSE, wegen Referenzvergleich
				//--->fuege alle Positionen hinzu und bearbeite den
				//Vector spaeter mit "compareVector()", um alle
				//mehrfach vorhandenen Daten zu entfernen
				cornPos.addElement(data);
				
			}
			//Sackgasse?
			if(onlyWay()&&!atHome() &&!isReady()){
				while(!map.cross(map.x(),map.y())){
					while( dir!=map.followMark('w',map.x(),map.y()) )turnLeft();
					map.setMark(map.x(),map.y(),'s');
					goForward();
				}
			}
			else{
				if(newWay() &&! isReady()){
					while(isWall() || map.getMarkAt(map.x(),map.y(),dir)=='s'
						|| map.getMarkAt(map.x(),map.y(),dir)=='w' )turnRight();
					map.setMark(map.x(),map.y(),'w');
					goForward();
				}
				else{
					while((isWall() || map.getMarkAt(map.x(),map.y(),dir)=='s') &&!isReady())turnLeft();
					if(!map.cross(map.x(),map.y()) && map.followMark('s',map.x(),map.y())!=100)
							map.setMark(map.x(),map.y(),'s');
					else map.setMark(map.x(),map.y(),'w');
					goForward();
				}
			}
			//Sackgasse
			if(map.cross(map.x(),map.y()) && !newWay() && !isReady()){
				map.setMark(map.x(),map.y(),'s');
				while(dir!=map.followMark('w',map.x(),map.y()))turnLeft();
				goForward();
			}
			//Rekursion
			hamstern();
		}
	}
	
	/*public int[] vergleichsspeicher(){
    	int[][] helper = new int[3][20];
    	int helperzaehler=0;
    	
    	for (int i=0;i<20;i++){
    		for (int j=0;j<20;j++){
    			if(speicher[0][i]==speicher[0][j])
    				if(speicher[1][i]==speicher[1][j]){
    					speicher[2][i]=(speicher[2][i])+1;
    					speicher[2][j]=(speicher[2][j])+1;
    				}
    		}
    	}
    	for(int i=0;i<20;i++)
    		if(speicher[2][20]>5)return new int[] {speicher[0][i],speicher[1][i]};
    	return new int[]{60,60};
    }	

	
	public void speicherupdate(){
    	speicher[0][speicherzaehler]=map.x();
    	speicher[1][speicherzaehler]=map.y();
    	++speicherzaehler;
    	speicherzaehler=(speicherzaehler%20);
    
    }*/
    
    //geh und sammle alles Mais, was du kennst
    public void collectCorn(){
    	//beginne bei HOME
    	goHome();
    	//int[] temp=new int[200];
    	for(int i=0; i<cornPos.size(); i++){
    		int[] temp = new int[200];
    		//Grundinitialisierung, Belegung mit defaul-Werten
    		for(int c=0;c<200;c++)temp[c]=-1;
    		int[] act=(int[])cornPos.elementAt(i);
    		//TRICK: suche guenstigen Weg von Position des Mais
    		//bis zu HOME ueber distanzvergleich packe Positionen
    		//auf den Stack
    		int[] coordarray = map.getWayTo(act[0],act[1],map.x(),map.y(),temp,0);
	    	//Mais-Positions-Speicher-Stack
	    	Stack stack = new Stack();
    		for(int v=0;v<200;v++){
    			if(coordarray[v]!=-1){
    				stack.push(new Integer(coordarray[v]));
    			}
    		}
    		//nach LIFO-Prinzip folgt Umkehrung der Reihen-
    		//folge des errechneten Loesungsweges
    		while(!stack.isEmpty()){
    			int todir=((Integer)stack.pop()).intValue();
    			//System.out.print(todir+" ");
    			while(dir!=todir)turnRight();
    			goForward();
    		}
    		takeAll();
    		if(getAvailableCorn()>0){
    			output(" ...mehr ");
				//entartete goto-methodik durch
				//Ruecksprung in dieser FOR-Schleife
				//--> Bearbeitung genau diesen Elementes
				//bei naechstem Durchlauf; somit
				//wird jeder Maishaufen komplett abgetragen
    			--i;
       		}
    		goHome();
    		dropHere(getCarriedCorn());
    		//System.out.print("KLOPS "); //for debug
    	}
	}
	
	//streiche alle Vielfachen des ersten, nchst-moeglichen...
	//nicht schoen, aber auf die Schnelle...
    private void compareVector(){
		try{
			for(int i=0;i<cornPos.size();i++){
				for(int j=i+1;j<cornPos.size();j++){
					int[] helpi = (int[])cornPos.elementAt(i);
					int[] helpj = (int[])cornPos.elementAt(j);					
					
					if(helpi[0]==helpj[0] && helpi[1]==helpj[1])
						cornPos.removeElementAt(j);
				}
			}
		//Standard-Initialisierung des Vectors erfolgt mit
		//capacity=10; bei genau 10 Elementen ist AIOOB-E
		//moeglich wegen 2. FOR-Schleife
		}catch(ArrayIndexOutOfBoundsException e){
			System.out.println("ArrayIndexOutOfBoundsException caught.");
			//mache nix, einfach weiter
		}
	}
    
    //rekursive Methode, zum hach-Hause-laufen,
    //indem immer der naechstkleineren Distanz zu HOME
    //gefolgt wird
    public void goHome(){
		if(!atHome()){
			//output("\n"+map.getMinDistWay(map.x(),map.y(),map.distance())+" "+map.distance());
			while(dir!=map.getMinDistWay(map.x(),map.y(),map.distance()))turnRight();
			goForward();
			goHome();
		}
	}
	
	/*public void goToXY(int x, int y){
	 *	map.getWayTo(map.x(),map.y(),x,y);
	 *	int follow=0;
	 *	while(map.x()!=x && map.y()!=y && follow!=100){
	 *		follow = map.followMark('g',map.x(),map.y());
	 *		if(follow!=100){
	 *			while(dir != follow)turnLeft();
	 *			map.setMark(map.x(),map.y(),'-');
	 *			goForward();
	 *		}
	 *	}
	}*/
    
    
    public void run(){
    	hamstern();
		compareVector();
    	collectCorn();
    }
    
    public String getHamsterAuthor() { return "written by Input and ebe"; }
    public String getHamsterDate() { return "30.03.2002, revision 16.05.2002"; }
    public String getHamsterVersion() { return "1.1"; }
}