
package nexus;

import algds.c2002.Constants; 


class ExplorePath extends ShortestPath implements Constants {

    ExplorePath(Nexus hamster){
	super(hamster);
    }

    /**
     *   
     *
     *  @param p  die fragliche Position
     *  @return true, wenn es noch unangesehene Nachbarn hat
     */
    private boolean hasUnknownNeighbors(Position p){  
	Field f = hamster.map.getField(p);
	return (!f.lookedaround && 
		hamster.map.hasUnknownNeighbors(p));
    }

    /**
     *  Bei welchen Feld soll der Pfad enden?
     * 
     *  @return true, wenn der Pfad zu diesem Feld fhren soll
     */  
    protected boolean compare(Path path){
	if(hamster.verbose() && hasUnknownNeighbors(path.position))
	    hamster.logln("Expl" + path.position + " ");
	return (hasUnknownNeighbors(path.position));
    }

}















