import algds.c2002.Hamster;
public class schopenhauer extends Hamster {
boolean finished = false;
int x = 0;      //x-Loordinate
int y = 0;      //y-Koordinate
int d = 0;      //Richtungszeiger
int c = 1;      //Zeigt an, wieviel Korn beim letzten Streifzug liegen blieb
boolean w = true;               //true=keine wand, false=wand
public void run() {             //Haupt-Methode
        /*Der Hamster geht in alle 6 Richtungen, auch mehrmals, wenn
         *noch Korn brig ist
         */
        while (c > 0) goShopping();
	goHome();while (d != 1) Left();c++;
        while (c > 0) goShopping();
	goHome();while (d != 2) Left();c++;
        while (c > 0) goShopping();
	goHome();while (d != 3) Left();c++;
        while (c > 0) goShopping();
	goHome();while (d != 4) Left();c++;
        while (c > 0) goShopping();
	goHome();while (d != 5) Left();c++;
        while (c > 0) goShopping();
	goHome();
}

private void goShopping() {
	boolean full = false;      //ist true, wenn Hamster maximale Last trgt
        /*Der Hamster geht 30 Felder geradeaus, wenn eine Wand kommt,
         *weicht er nach rechts aus
         */
        for(int i=0; i<30; i++){
            watchForWall();
            while (w==true) {
                Right(); watchForWall();
            }
            Step();
            if (getCarriedCorn() == CORNCARRY_MAX) { //Bring Korn nach Haus,
                goHome();                            //wenn maximale Last
            }
        }
}


private void goHome() { //Nach-Hause-gehn-Methode
    while ((y != 0) | (y != 0)) {
        /* Der Hamster findet nach Hause, indem er
         * sich allmhlich an die Koordinaten (0,0) annhert
         */
        if (Math.abs(x) >  Math.abs(y)) {
            goToNext(minus(x), y);
        }
        if (Math.abs(x) <  Math.abs(y)) {
            goToNext(x, minus(y));
        }
        if (Math.abs(x) == Math.abs(y)) {
            goToNext(minus(x), y);
        }
    }
}


public void goToNext(int a, int b) {   //Geht ins nchste Feld
    turnTo(a, b);                      //dreht sich zum nchsten Feld
    while ((a != x) | (b !=y)) {//weicht Hindernissen aus, bis das Feld erreicht ist
        watchForWall();
        while (w==true) {   //dreht sich nach rechts, wenn Wand im Weg ist
            Right(); watchForWall();
        }
        Step(); Left(); Left(); //Hindernis umgehen
    }
}


public void Step() {         //Ein Schritt vorwrts, speichert Position
   take(CORNCARRY_MAX);      //soviel Korn, wie mglich aufnehmen
   c = c+getAvailableCorn(); //speichern, wieviel Korn liegenbleibt
   if ((!atHome()) & (getCarriedCorn() == 0))  c=0; //Zhler zurcksetzen
   if (atHome()){
       dropAll();   //alles auspacken, wenn er zu Hause ist
    }
    if (d == 0) {x++;}          //Schritt nach vorn
    if (d == 1) {x++; y++;}     //Schritt nach rechts-vorn
    if (d == 2) {y++;}          //Schritt nach rechts-hinten
    if (d == 3) {x--;}          //Schritt nach hinten
    if (d == 4) {x--; y--;}     //Schritt nach links-hinten
    if (d == 5) {y--;}          //Schritt nach links-vorn
    forward();                  //fhre Schritt aus
}


public void turnTo(int a, int b) {      //Hamster in Richtung Zielfeld drehen
    int f, g;   //Differenz zu Ziel-Koordinaten
    f = a-x; g = b-y;
    //Nach rechts drehen, bis die Richtung stimmt:
    if (f ==  1 & g ==  0) {while (d != 0) Right();}
    if (f ==  1 & g ==  1) {while (d != 1) Right();}
    if (f ==  0 & g ==  1) {while (d != 2) Right();}
    if (f == -1 & g ==  0) {while (d != 3) Right();}
    if (f == -1 & g == -1) {while (d != 4) Right();}
    if (f ==  0 & g == -1) {while (d != 5) Right();}
}

public void Left() {        //Drehung um 1 nach links
    turn(TURN_LEFT);
    d = ((d+5)%6);          //dreht den Richtungszeiger 1 nach links
}


public void Right() {       //Drehung um 1 nach rechts
    turn(TURN_RIGHT);
    d = ((d+1)%6);          //dreht den Richtungszeiger 1 nach rechts
}


public void watchForWall(){ //schaut, ob geradeaus eine Wand ist
    if ((lookForward() & WALLMASK) != WALL) w = false;
    if ((lookForward() & WALLMASK) == WALL) w = true;
}


public int minus(int n) { //Nhert Koordinaten um 1 an Null an
    if (n < 0) n++;
    if (n > 0) n--;
    return n;
}

public void dropAll() {      //Alles Korn auspacken
	int dropped = dropHere(CORNCARRY_MAX);
}


/** Autor(en) des Hamsters. */
public String getHamsterAuthor() { return "Bjrn Raguse, Matthias Kohse"; }

/** Datum der Hamsterversion. */
public String getHamsterDate() { return "30.04.2002"; }

/** Hamsterversion. */
public String getHamsterVersion() { return "0.0.0.1"; }

} // schopenhauer
