//****************************************************************************
//
//					Hamster TICO (urspr. TICONDEROGA)
//
//	 ein Beitrag zum Hamsterwettbewerb 2002 der Fakultt fr Informatik
//		       der Otto-von-Guericke-Universitt Magdeburg
//
//			 entwickelt und programmiert von:  Andreas Strehl
//
//                       HILFSKLASSE "Position"
//****************************************************************************

//****************************************************************************
// Funktionsaufbau dieser Klasse:
// Diese Klasse definiert einen Abstrakten Datentyp mit zwei Instanzvariablen
// X und Y, sowie einer Navigationsmethode "vorwaerts()", die nach dem in der
// Klasse Tico.class erluterten Navigationsprinzip die Berechnung der
// Koordinaten vornimmt.
// Die Klasse wird zur Navigation durch die Klasse Tico.java benutzt.
//**************************************************************************** 

package tico;

import algds.c2002.Hamster;

public class Position{
	
	//Instanzvariablen
	int x;
	int y;
	
	//Konstruktor
	public Position(int zuSetzendesX, int zuSetzendesY){
		x=zuSetzendesX;
		y=zuSetzendesY;
	}
	
	//Instanzmethoden
	public void vorwaerts(int blickrichtung){
		if (blickrichtung==0){
  	   		x++;
  	   		y++;
  	   	}
  		else if (blickrichtung==1){
  	   			x=x+2;
  	   		}
  	   		else if (blickrichtung==2){
  	   				x++;
  	   				y--;
  	   			}
  	   			else if (blickrichtung==3){
  	   					x--;
  	   					y--;
  	   				}
  	   				else if (blickrichtung==4){
  	   						x=x-2;
  	   					}
  	   					else if (blickrichtung==5){
  	   							x--;
  	   							y++;
  	   						}
  	   						else System.out.println("Keine Positionsnderung!");
  	   }
}	   		 